var n={4912:n=>{n.exports='/*\ndescription: Include all available easing animations\n*/\n\n#ifndef QTR_PI\n#define QTR_PI 0.78539816339\n#endif\n#ifndef HALF_PI\n#define HALF_PI 1.5707963267948966192313216916398\n#endif\n#ifndef PI\n#define PI 3.1415926535897932384626433832795\n#endif\n#ifndef TWO_PI\n#define TWO_PI 6.2831853071795864769252867665590\n#endif\n#ifndef TAU\n#define TAU 6.2831853071795864769252867665590\n#endif\n#ifndef ONE_OVER_PI\n#define ONE_OVER_PI 0.31830988618\n#endif\n#ifndef PHI\n#define PHI 1.618033988749894848204586834\n#endif\n#ifndef EPSILON\n#define EPSILON 0.0000001\n#endif\n#ifndef GOLDEN_RATIO\n#define GOLDEN_RATIO 1.6180339887\n#endif\n#ifndef GOLDEN_ANGLE // (3.-sqrt(5.0))*PI radians\n#define GOLDEN_ANGLE 2.39996323\n#endif\n\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: Back easing. From https://github.com/stackgl/glsl-easings\nuse: back<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_BACKIN\n#define FNC_BACKIN\nfloat backIn(in float t) {\n    return pow(t, 3.) - t * sin(t * PI);\n}\n#endif\n\n#ifndef FNC_BACKOUT\n#define FNC_BACKOUT\nfloat backOut(in float t) {\n    return 1. - backIn(1. - t);\n}\n#endif\n\n#ifndef FNC_BACKINOUT\n#define FNC_BACKINOUT\nfloat backInOut(in float t) {\n    float f = t < .5\n        ? 2.0 * t\n        : 1.0 - (2.0 * t - 1.0);\n\n    float g = backIn(f);\n\n    return t < 0.5\n        ? 0.5 * g\n        : 0.5 * (1.0 - g) + 0.5;\n}\n#endif\n\n#ifndef QTR_PI\n#define QTR_PI 0.78539816339\n#endif\n#ifndef HALF_PI\n#define HALF_PI 1.5707963267948966192313216916398\n#endif\n#ifndef PI\n#define PI 3.1415926535897932384626433832795\n#endif\n#ifndef TWO_PI\n#define TWO_PI 6.2831853071795864769252867665590\n#endif\n#ifndef TAU\n#define TAU 6.2831853071795864769252867665590\n#endif\n#ifndef ONE_OVER_PI\n#define ONE_OVER_PI 0.31830988618\n#endif\n#ifndef PHI\n#define PHI 1.618033988749894848204586834\n#endif\n#ifndef EPSILON\n#define EPSILON 0.0000001\n#endif\n#ifndef GOLDEN_RATIO\n#define GOLDEN_RATIO 1.6180339887\n#endif\n#ifndef GOLDEN_ANGLE // (3.-sqrt(5.0))*PI radians\n#define GOLDEN_ANGLE 2.39996323\n#endif\n\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: bounce easing. From https://github.com/stackgl/glsl-easings\nuse: bounce<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_BOUNCEOUT\n#define FNC_BOUNCEOUT\nfloat bounceOut(in float t) {\n    const float a = 4.0 / 11.0;\n    const float b = 8.0 / 11.0;\n    const float c = 9.0 / 10.0;\n\n    const float ca = 4356.0 / 361.0;\n    const float cb = 35442.0 / 1805.0;\n    const float cc = 16061.0 / 1805.0;\n\n    float t2 = t * t;\n\n    return t < a\n        ? 7.5625 * t2\n        : t < b\n            ? 9.075 * t2 - 9.9 * t + 3.4\n            : t < c\n                ? ca * t2 - cb * t + cc\n                : 10.8 * t * t - 20.52 * t + 10.72;\n}\n#endif\n\n#ifndef FNC_BOUNCEIN\n#define FNC_BOUNCEIN\nfloat bounceIn(in float t) {\n    return 1.0 - bounceOut(1.0 - t);\n}\n#endif\n\n#ifndef FNC_BOUNCEINOUT\n#define FNC_BOUNCEINOUT\nfloat bounceInOut(in float t) {\n    return t < 0.5\n        ? 0.5 * (1.0 - bounceOut(1.0 - t * 2.0))\n        : 0.5 * bounceOut(t * 2.0 - 1.0) + 0.5;\n}\n#endif\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: circular easing. From https://github.com/stackgl/glsl-easings\nuse: circular<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_CIRCULARIN\n#define FNC_CIRCULARIN\nfloat circularIn(in float t) {\n    return 1.0 - sqrt(1.0 - t * t);\n}\n#endif\n\n#ifndef FNC_CIRCULAROUT\n#define FNC_CIRCULAROUT\nfloat circularOut(in float t) {\n    return sqrt((2.0 - t) * t);\n}\n#endif\n\n#ifndef FNC_CIRCULARINOUT\n#define FNC_CIRCULARINOUT\nfloat circularInOut(in float t) {\n    return t < 0.5\n        ? 0.5 * (1.0 - sqrt(1.0 - 4.0 * t * t))\n        : 0.5 * (sqrt((3.0 - 2.0 * t) * (2.0 * t - 1.0)) + 1.0);\n}\n#endif\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: cubic easing. From https://github.com/stackgl/glsl-easings\nuse: cubic<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_CUBICIN\n#define FNC_CUBICIN\nfloat cubicIn(in float t) {\n  return t * t * t;\n}\n#endif\n\n#ifndef FNC_CUBICOUT\n#define FNC_CUBICOUT\nfloat cubicOut(in float t) {\n  float f = t - 1.0;\n  return f * f * f + 1.0;\n}\n#endif\n\n#ifndef FNC_CUBICINOUT\n#define FNC_CUBICINOUT\nfloat cubicInOut(in float t) {\n  return t < 0.5\n    ? 4.0 * t * t * t\n    : 0.5 * pow(2.0 * t - 2.0, 3.0) + 1.0;\n}\n#endif\n\n#ifndef QTR_PI\n#define QTR_PI 0.78539816339\n#endif\n#ifndef HALF_PI\n#define HALF_PI 1.5707963267948966192313216916398\n#endif\n#ifndef PI\n#define PI 3.1415926535897932384626433832795\n#endif\n#ifndef TWO_PI\n#define TWO_PI 6.2831853071795864769252867665590\n#endif\n#ifndef TAU\n#define TAU 6.2831853071795864769252867665590\n#endif\n#ifndef ONE_OVER_PI\n#define ONE_OVER_PI 0.31830988618\n#endif\n#ifndef PHI\n#define PHI 1.618033988749894848204586834\n#endif\n#ifndef EPSILON\n#define EPSILON 0.0000001\n#endif\n#ifndef GOLDEN_RATIO\n#define GOLDEN_RATIO 1.6180339887\n#endif\n#ifndef GOLDEN_ANGLE // (3.-sqrt(5.0))*PI radians\n#define GOLDEN_ANGLE 2.39996323\n#endif\n\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: elastic easing. From https://github.com/stackgl/glsl-easings\nuse: elastic<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_ELASTICIN\n#define FNC_ELASTICIN\nfloat elasticIn(in float t) {\n    return sin(13.0 * t * HALF_PI) * pow(2.0, 10.0 * (t - 1.0));\n}\n#endif \n\n#ifndef FNC_ELASTICOUT\n#define FNC_ELASTICOUT\nfloat elasticOut(in float t) {\n    return sin(-13.0 * (t + 1.0) * HALF_PI) * pow(2.0, -10.0 * t) + 1.0;\n}\n#endif\n\n#ifndef FNC_ELASTICINOUT\n#define FNC_ELASTICINOUT\nfloat elasticInOut(in float t) {\n    return t < 0.5\n        ? 0.5 * sin(+13.0 * HALF_PI * 2.0 * t) * pow(2.0, 10.0 * (2.0 * t - 1.0))\n        : 0.5 * sin(-13.0 * HALF_PI * ((2.0 * t - 1.0) + 1.0)) * pow(2.0, -10.0 * (2.0 * t - 1.0)) + 1.0;\n}\n#endif\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: exponential easing. From https://github.com/stackgl/glsl-easings\nuse: exponential<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_EXPONENTIALIN\n#define FNC_EXPONENTIALIN\nfloat exponentialIn(in float t) {\n    return t == 0.0 ? t : pow(2.0, 10.0 * (t - 1.0));\n}\n#endif\n\n#ifndef FNC_EXPONENTIALOUT\n#define FNC_EXPONENTIALOUT\nfloat exponentialOut(in float t) {\n    return t == 1.0 ? t : 1.0 - pow(2.0, -10.0 * t);\n}\n#endif\n\n#ifndef FNC_EXPONENTIALINOUT\n#define FNC_EXPONENTIALINOUT\nfloat exponentialInOut(in float t) {\n    return t == 0.0 || t == 1.0\n        ? t\n        : t < 0.5\n            ? +0.5 * pow(2.0, (20.0 * t) - 10.0)\n            : -0.5 * pow(2.0, 10.0 - (t * 20.0)) + 1.0;\n}\n#endif\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: Linear easing. From https://github.com/stackgl/glsl-easings\nuse: linear(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_LINEAR\n#define FNC_LINEAR\nfloat linear(in float t) {\n    return t;\n}\n#endif\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: quadrtic easing. From https://github.com/stackgl/glsl-easings\nuse: quadratic<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_QUADRATICIN\n#define FNC_QUADRATICIN\nfloat quadraticIn(in float t) {\n    return t * t;\n}\n#endif\n\n#ifndef FNC_QUADRATICOUT\n#define FNC_QUADRATICOUT\nfloat quadraticOut(in float t) {\n    return -t * (t - 2.0);\n}\n#endif\n\n#ifndef FNC_QUADRATICINOUT\n#define FNC_QUADRATICINOUT\nfloat quadraticInOut(in float t) {\n    float p = 2.0 * t * t;\n    return t < 0.5 ? p : -p + (4.0 * t) - 1.0;\n}\n#endif\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: quintic easing. From https://github.com/stackgl/glsl-easings\nuse: quintic<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_QUINTICIN\n#define FNC_QUINTICIN\nfloat quinticIn(in float t) {\n    return pow(t, 5.0);\n}\n#endif\n\n#ifndef FNC_QUINTICOUT\n#define FNC_QUINTICOUT\nfloat quinticOut(in float t) {\n    return 1.0 - (pow(t - 1.0, 5.0));\n}\n#endif\n\n#ifndef FNC_QUINTICINOUT\n#define FNC_QUINTICINOUT\nfloat quinticInOut(in float t) {\n    return t < 0.5\n        ? +16.0 * pow(t, 5.0)\n        : -0.5 * pow(2.0 * t - 2.0, 5.0) + 1.0;\n}\n#endif\n\n#ifndef QTR_PI\n#define QTR_PI 0.78539816339\n#endif\n#ifndef HALF_PI\n#define HALF_PI 1.5707963267948966192313216916398\n#endif\n#ifndef PI\n#define PI 3.1415926535897932384626433832795\n#endif\n#ifndef TWO_PI\n#define TWO_PI 6.2831853071795864769252867665590\n#endif\n#ifndef TAU\n#define TAU 6.2831853071795864769252867665590\n#endif\n#ifndef ONE_OVER_PI\n#define ONE_OVER_PI 0.31830988618\n#endif\n#ifndef PHI\n#define PHI 1.618033988749894848204586834\n#endif\n#ifndef EPSILON\n#define EPSILON 0.0000001\n#endif\n#ifndef GOLDEN_RATIO\n#define GOLDEN_RATIO 1.6180339887\n#endif\n#ifndef GOLDEN_ANGLE // (3.-sqrt(5.0))*PI radians\n#define GOLDEN_ANGLE 2.39996323\n#endif\n\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: sine easing. From https://github.com/stackgl/glsl-easings\nuse: sine<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_QINTICIN\n#define FNC_QINTICIN\nfloat sineIn(in float t) {\n    return sin((t - 1.0) * HALF_PI) + 1.0;\n}\n#endif\n\n#ifndef FNC_QINTICOUT\n#define FNC_QINTICOUT\nfloat sineOut(in float t) {\n    return sin(t * HALF_PI);\n}\n#endif\n\n#ifndef FNC_QINTICINOUT\n#define FNC_QINTICINOUT\nfloat sineInOut(in float t) {\n    return -0.5 * (cos(PI * t) - 1.0);\n}\n#endif\n'},1198:n=>{n.exports='#ifndef QTR_PI\n#define QTR_PI 0.78539816339\n#endif\n#ifndef HALF_PI\n#define HALF_PI 1.5707963267948966192313216916398\n#endif\n#ifndef PI\n#define PI 3.1415926535897932384626433832795\n#endif\n#ifndef TWO_PI\n#define TWO_PI 6.2831853071795864769252867665590\n#endif\n#ifndef TAU\n#define TAU 6.2831853071795864769252867665590\n#endif\n#ifndef ONE_OVER_PI\n#define ONE_OVER_PI 0.31830988618\n#endif\n#ifndef PHI\n#define PHI 1.618033988749894848204586834\n#endif\n#ifndef EPSILON\n#define EPSILON 0.0000001\n#endif\n#ifndef GOLDEN_RATIO\n#define GOLDEN_RATIO 1.6180339887\n#endif\n#ifndef GOLDEN_ANGLE // (3.-sqrt(5.0))*PI radians\n#define GOLDEN_ANGLE 2.39996323\n#endif\n\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: Back easing. From https://github.com/stackgl/glsl-easings\nuse: back<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_BACKIN\n#define FNC_BACKIN\nfloat backIn(in float t) {\n    return pow(t, 3.) - t * sin(t * PI);\n}\n#endif\n\n#ifndef FNC_BACKOUT\n#define FNC_BACKOUT\nfloat backOut(in float t) {\n    return 1. - backIn(1. - t);\n}\n#endif\n\n#ifndef FNC_BACKINOUT\n#define FNC_BACKINOUT\nfloat backInOut(in float t) {\n    float f = t < .5\n        ? 2.0 * t\n        : 1.0 - (2.0 * t - 1.0);\n\n    float g = backIn(f);\n\n    return t < 0.5\n        ? 0.5 * g\n        : 0.5 * (1.0 - g) + 0.5;\n}\n#endif\n'},6788:n=>{n.exports='#ifndef QTR_PI\n#define QTR_PI 0.78539816339\n#endif\n#ifndef HALF_PI\n#define HALF_PI 1.5707963267948966192313216916398\n#endif\n#ifndef PI\n#define PI 3.1415926535897932384626433832795\n#endif\n#ifndef TWO_PI\n#define TWO_PI 6.2831853071795864769252867665590\n#endif\n#ifndef TAU\n#define TAU 6.2831853071795864769252867665590\n#endif\n#ifndef ONE_OVER_PI\n#define ONE_OVER_PI 0.31830988618\n#endif\n#ifndef PHI\n#define PHI 1.618033988749894848204586834\n#endif\n#ifndef EPSILON\n#define EPSILON 0.0000001\n#endif\n#ifndef GOLDEN_RATIO\n#define GOLDEN_RATIO 1.6180339887\n#endif\n#ifndef GOLDEN_ANGLE // (3.-sqrt(5.0))*PI radians\n#define GOLDEN_ANGLE 2.39996323\n#endif\n\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: bounce easing. From https://github.com/stackgl/glsl-easings\nuse: bounce<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_BOUNCEOUT\n#define FNC_BOUNCEOUT\nfloat bounceOut(in float t) {\n    const float a = 4.0 / 11.0;\n    const float b = 8.0 / 11.0;\n    const float c = 9.0 / 10.0;\n\n    const float ca = 4356.0 / 361.0;\n    const float cb = 35442.0 / 1805.0;\n    const float cc = 16061.0 / 1805.0;\n\n    float t2 = t * t;\n\n    return t < a\n        ? 7.5625 * t2\n        : t < b\n            ? 9.075 * t2 - 9.9 * t + 3.4\n            : t < c\n                ? ca * t2 - cb * t + cc\n                : 10.8 * t * t - 20.52 * t + 10.72;\n}\n#endif\n\n#ifndef FNC_BOUNCEIN\n#define FNC_BOUNCEIN\nfloat bounceIn(in float t) {\n    return 1.0 - bounceOut(1.0 - t);\n}\n#endif\n\n#ifndef FNC_BOUNCEINOUT\n#define FNC_BOUNCEINOUT\nfloat bounceInOut(in float t) {\n    return t < 0.5\n        ? 0.5 * (1.0 - bounceOut(1.0 - t * 2.0))\n        : 0.5 * bounceOut(t * 2.0 - 1.0) + 0.5;\n}\n#endif\n'},4477:n=>{n.exports='/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: circular easing. From https://github.com/stackgl/glsl-easings\nuse: circular<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_CIRCULARIN\n#define FNC_CIRCULARIN\nfloat circularIn(in float t) {\n    return 1.0 - sqrt(1.0 - t * t);\n}\n#endif\n\n#ifndef FNC_CIRCULAROUT\n#define FNC_CIRCULAROUT\nfloat circularOut(in float t) {\n    return sqrt((2.0 - t) * t);\n}\n#endif\n\n#ifndef FNC_CIRCULARINOUT\n#define FNC_CIRCULARINOUT\nfloat circularInOut(in float t) {\n    return t < 0.5\n        ? 0.5 * (1.0 - sqrt(1.0 - 4.0 * t * t))\n        : 0.5 * (sqrt((3.0 - 2.0 * t) * (2.0 * t - 1.0)) + 1.0);\n}\n#endif\n'},134:n=>{n.exports='/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: cubic easing. From https://github.com/stackgl/glsl-easings\nuse: cubic<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_CUBICIN\n#define FNC_CUBICIN\nfloat cubicIn(in float t) {\n  return t * t * t;\n}\n#endif\n\n#ifndef FNC_CUBICOUT\n#define FNC_CUBICOUT\nfloat cubicOut(in float t) {\n  float f = t - 1.0;\n  return f * f * f + 1.0;\n}\n#endif\n\n#ifndef FNC_CUBICINOUT\n#define FNC_CUBICINOUT\nfloat cubicInOut(in float t) {\n  return t < 0.5\n    ? 4.0 * t * t * t\n    : 0.5 * pow(2.0 * t - 2.0, 3.0) + 1.0;\n}\n#endif\n'},4621:n=>{n.exports='#ifndef QTR_PI\n#define QTR_PI 0.78539816339\n#endif\n#ifndef HALF_PI\n#define HALF_PI 1.5707963267948966192313216916398\n#endif\n#ifndef PI\n#define PI 3.1415926535897932384626433832795\n#endif\n#ifndef TWO_PI\n#define TWO_PI 6.2831853071795864769252867665590\n#endif\n#ifndef TAU\n#define TAU 6.2831853071795864769252867665590\n#endif\n#ifndef ONE_OVER_PI\n#define ONE_OVER_PI 0.31830988618\n#endif\n#ifndef PHI\n#define PHI 1.618033988749894848204586834\n#endif\n#ifndef EPSILON\n#define EPSILON 0.0000001\n#endif\n#ifndef GOLDEN_RATIO\n#define GOLDEN_RATIO 1.6180339887\n#endif\n#ifndef GOLDEN_ANGLE // (3.-sqrt(5.0))*PI radians\n#define GOLDEN_ANGLE 2.39996323\n#endif\n\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: elastic easing. From https://github.com/stackgl/glsl-easings\nuse: elastic<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_ELASTICIN\n#define FNC_ELASTICIN\nfloat elasticIn(in float t) {\n    return sin(13.0 * t * HALF_PI) * pow(2.0, 10.0 * (t - 1.0));\n}\n#endif \n\n#ifndef FNC_ELASTICOUT\n#define FNC_ELASTICOUT\nfloat elasticOut(in float t) {\n    return sin(-13.0 * (t + 1.0) * HALF_PI) * pow(2.0, -10.0 * t) + 1.0;\n}\n#endif\n\n#ifndef FNC_ELASTICINOUT\n#define FNC_ELASTICINOUT\nfloat elasticInOut(in float t) {\n    return t < 0.5\n        ? 0.5 * sin(+13.0 * HALF_PI * 2.0 * t) * pow(2.0, 10.0 * (2.0 * t - 1.0))\n        : 0.5 * sin(-13.0 * HALF_PI * ((2.0 * t - 1.0) + 1.0)) * pow(2.0, -10.0 * (2.0 * t - 1.0)) + 1.0;\n}\n#endif\n'},3814:n=>{n.exports='/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: exponential easing. From https://github.com/stackgl/glsl-easings\nuse: exponential<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_EXPONENTIALIN\n#define FNC_EXPONENTIALIN\nfloat exponentialIn(in float t) {\n    return t == 0.0 ? t : pow(2.0, 10.0 * (t - 1.0));\n}\n#endif\n\n#ifndef FNC_EXPONENTIALOUT\n#define FNC_EXPONENTIALOUT\nfloat exponentialOut(in float t) {\n    return t == 1.0 ? t : 1.0 - pow(2.0, -10.0 * t);\n}\n#endif\n\n#ifndef FNC_EXPONENTIALINOUT\n#define FNC_EXPONENTIALINOUT\nfloat exponentialInOut(in float t) {\n    return t == 0.0 || t == 1.0\n        ? t\n        : t < 0.5\n            ? +0.5 * pow(2.0, (20.0 * t) - 10.0)\n            : -0.5 * pow(2.0, 10.0 - (t * 20.0)) + 1.0;\n}\n#endif'},406:n=>{n.exports='/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: Linear easing. From https://github.com/stackgl/glsl-easings\nuse: linear(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_LINEAR\n#define FNC_LINEAR\nfloat linear(in float t) {\n    return t;\n}\n#endif\n'},6463:n=>{n.exports='/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: quadrtic easing. From https://github.com/stackgl/glsl-easings\nuse: quadratic<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_QUADRATICIN\n#define FNC_QUADRATICIN\nfloat quadraticIn(in float t) {\n    return t * t;\n}\n#endif\n\n#ifndef FNC_QUADRATICOUT\n#define FNC_QUADRATICOUT\nfloat quadraticOut(in float t) {\n    return -t * (t - 2.0);\n}\n#endif\n\n#ifndef FNC_QUADRATICINOUT\n#define FNC_QUADRATICINOUT\nfloat quadraticInOut(in float t) {\n    float p = 2.0 * t * t;\n    return t < 0.5 ? p : -p + (4.0 * t) - 1.0;\n}\n#endif\n'},7549:n=>{n.exports='/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: quartic easing. From https://github.com/stackgl/glsl-easings\nuse: quartic<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_QUARTICIN\n#define FNC_QUARTICIN\nfloat quarticIn(in float t) {\n  return pow(t, 4.0);\n}\n#endif\n\n#ifndef FNC_QUARTICOUT\n#define FNC_QUARTICOUT\nfloat quarticOut(in float t) {\n  return pow(t - 1.0, 3.0) * (1.0 - t) + 1.0;\n}\n#endif\n\n#ifndef FNC_QUARTICINOUT\n#define FNC_QUARTICINOUT\nfloat quarticInOut(in float t) {\n  return t < 0.5\n    ? +8.0 * pow(t, 4.0)\n    : -8.0 * pow(t - 1.0, 4.0) + 1.0;\n}\n#endif\n'},173:n=>{n.exports='/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: quintic easing. From https://github.com/stackgl/glsl-easings\nuse: quintic<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_QUINTICIN\n#define FNC_QUINTICIN\nfloat quinticIn(in float t) {\n    return pow(t, 5.0);\n}\n#endif\n\n#ifndef FNC_QUINTICOUT\n#define FNC_QUINTICOUT\nfloat quinticOut(in float t) {\n    return 1.0 - (pow(t - 1.0, 5.0));\n}\n#endif\n\n#ifndef FNC_QUINTICINOUT\n#define FNC_QUINTICINOUT\nfloat quinticInOut(in float t) {\n    return t < 0.5\n        ? +16.0 * pow(t, 5.0)\n        : -0.5 * pow(2.0 * t - 2.0, 5.0) + 1.0;\n}\n#endif\n'},3241:n=>{n.exports='#ifndef QTR_PI\n#define QTR_PI 0.78539816339\n#endif\n#ifndef HALF_PI\n#define HALF_PI 1.5707963267948966192313216916398\n#endif\n#ifndef PI\n#define PI 3.1415926535897932384626433832795\n#endif\n#ifndef TWO_PI\n#define TWO_PI 6.2831853071795864769252867665590\n#endif\n#ifndef TAU\n#define TAU 6.2831853071795864769252867665590\n#endif\n#ifndef ONE_OVER_PI\n#define ONE_OVER_PI 0.31830988618\n#endif\n#ifndef PHI\n#define PHI 1.618033988749894848204586834\n#endif\n#ifndef EPSILON\n#define EPSILON 0.0000001\n#endif\n#ifndef GOLDEN_RATIO\n#define GOLDEN_RATIO 1.6180339887\n#endif\n#ifndef GOLDEN_ANGLE // (3.-sqrt(5.0))*PI radians\n#define GOLDEN_ANGLE 2.39996323\n#endif\n\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: sine easing. From https://github.com/stackgl/glsl-easings\nuse: sine<In|Out|InOut>(<float> x)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_QINTICIN\n#define FNC_QINTICIN\nfloat sineIn(in float t) {\n    return sin((t - 1.0) * HALF_PI) + 1.0;\n}\n#endif\n\n#ifndef FNC_QINTICOUT\n#define FNC_QINTICOUT\nfloat sineOut(in float t) {\n    return sin(t * HALF_PI);\n}\n#endif\n\n#ifndef FNC_QINTICINOUT\n#define FNC_QINTICINOUT\nfloat sineInOut(in float t) {\n    return -0.5 * (cos(PI * t) - 1.0);\n}\n#endif'}},e={};function t(i){var o=e[i];if(void 0!==o)return o.exports;var I=e[i]={exports:{}};return n[i](I,I.exports,t),I.exports}t.n=n=>{var e=n&&n.__esModule?()=>n.default:()=>n;return t.d(e,{a:e}),e},t.d=(n,e)=>{for(var i in e)t.o(e,i)&&!t.o(n,i)&&Object.defineProperty(n,i,{enumerable:!0,get:e[i]})},t.o=(n,e)=>Object.prototype.hasOwnProperty.call(n,e);var i={};(()=>{t.d(i,{Z:()=>g});var n=t(4912),e=t.n(n),o=t(1198),I=t.n(o),s=t(4477),f=t.n(s),T=t(4621),O=t.n(T),N=t(406),a=t.n(N),E=t(7549),r=t.n(E),d=t(3241),R=t.n(d),A=t(6788),l=t.n(A),h=t(134),c=t.n(h),u=t(3814),S=t.n(u),C=t(6463),H=t.n(C),L=t(173),F=t.n(L);const p={back:I(),circular:f(),elastic:O(),linear:a(),quartic:r(),sine:R(),bounce:l(),cubic:c(),exponential:S(),quadratic:H(),quintic:F()},g={easing:Object.assign(e(),p)}})();var o=i.Z;export{o as default};