var n={976:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Add blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendAdd(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDADD\n#define FNC_BLENDADD\nfloat blendAdd(in float base, in float blend) {\n    return min(base + blend, 1.);\n}\n\nvec3 blendAdd(in vec3 base, in vec3 blend) {\n    return min(base + blend, vec3(1.));\n}\n\nvec3 blendAdd(in vec3 base, in vec3 blend, float opacity) {\n    return (blendAdd(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Average blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendAverage(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDAVERAGE\n#define FNC_BLENDAVERAGE\nfloat blendAverage(in float base, in float blend) {\n    return (base + blend) * .5;\n}\n\nvec3 blendAverage(in vec3 base, in vec3 blend) {\n    return (base + blend) * .5;\n}\n\nvec3 blendAverage(in vec3 base, in vec3 blend, float opacity) {\n    return (blendAverage(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Color Dodge blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendColorDodge(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDCOLORDODGE\n#define FNC_BLENDCOLORDODGE\nfloat blendColorDodge(in float base, in float blend) {\n    return (blend == 1.)? blend: min( base / (1. - blend), 1.);\n}\n\nvec3 blendColorDodge(in vec3 base, in vec3 blend) {\n    return vec3(blendColorDodge(base.r, blend.r),\n                blendColorDodge(base.g, blend.g),\n                blendColorDodge(base.b, blend.b));\n}\n\nvec3 blendColorDodge(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendColorDodge(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Difference blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendDifference(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDDIFFERENCE\n#define FNC_BLENDDIFFERENCE\nfloat blendDifference(in float base, in float blend) {\n    return abs(base-blend);\n}\n\nvec3 blendDifference(in vec3 base, in vec3 blend) {\n    return abs(base-blend);\n}\n\nvec3 blendDifference(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendDifference(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Reflect blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendReflect(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDREFLECT\n#define FNC_BLENDREFLECT\nfloat blendReflect(in float base, in float blend) {\n    return (blend == 1.)? blend : min(base * base / (1. - blend), 1.);\n}\n\nvec3 blendReflect(in vec3 base, in vec3 blend) {\n    return vec3(blendReflect(base.r, blend.r),\n                blendReflect(base.g, blend.g),\n                blendReflect(base.b, blend.b));\n}\n\nvec3 blendReflect(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendReflect(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Glow blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendGlow(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDGLOW\n#define FNC_BLENDGLOW\nfloat blendGlow(in float base, in float blend) {\n    return blendReflect(blend, base);\n}\n\nvec3 blendGlow(in vec3 base, in vec3 blend) {\n    return blendReflect(blend, base);\n}\n\nvec3 blendGlow(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendGlow(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Color Burn blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendColorBurn(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDCOLORBURN\n#define FNC_BLENDCOLORBURN\nfloat blendColorBurn(in float base, in float blend) {\n    return (blend == 0.)? blend: max((1. - ((1. - base ) / blend)), 0.);\n}\n\nvec3 blendColorBurn(in vec3 base, in vec3 blend) {\n    return vec3(blendColorBurn(base.r, blend.r),\n                blendColorBurn(base.g, blend.g),\n                blendColorBurn(base.b, blend.b));\n}\n\nvec3 blendColorBurn(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendColorBurn(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Color Dodge blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendColorDodge(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDCOLORDODGE\n#define FNC_BLENDCOLORDODGE\nfloat blendColorDodge(in float base, in float blend) {\n    return (blend == 1.)? blend: min( base / (1. - blend), 1.);\n}\n\nvec3 blendColorDodge(in vec3 base, in vec3 blend) {\n    return vec3(blendColorDodge(base.r, blend.r),\n                blendColorDodge(base.g, blend.g),\n                blendColorDodge(base.b, blend.b));\n}\n\nvec3 blendColorDodge(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendColorDodge(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Vivid Light blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendVividLight(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDVIVIDLIGHT\n#define FNC_BLENDVIVIDLIGHT\nfloat blendVividLight(in float base, in float blend) {\n    return (blend < .5)? blendColorBurn(base, (2.*blend)): blendColorDodge(base, (2. * (blend - .5)));\n}\n\nvec3 blendVividLight(in vec3 base, in vec3 blend) {\n    return vec3(blendVividLight(base.r, blend.r),\n                            blendVividLight(base.g, blend.g),\n                            blendVividLight(base.b, blend.b));\n}\n\nvec3 blendVividLight(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendVividLight(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Hard Mix blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendHardMix(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDHARDMIX\n#define FNC_BLENDHARDMIX\nfloat blendHardMix(in float base, in float blend) {\n    return (blendVividLight(base, blend) < .5)? 0.: 1.;\n}\n\nvec3 blendHardMix(in vec3 base, in vec3 blend) {\n    return vec3(blendHardMix(base.r, blend.r),\n                blendHardMix(base.g, blend.g),\n                blendHardMix(base.b, blend.b));\n}\n\nvec3 blendHardMix(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendHardMix(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Linear Burn blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendLinearBurn(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDLINEARBURN\n#define FNC_BLENDLINEARBURN\nfloat blendLinearBurn(in float base, in float blend) {\n  // Note : Same implementation as BlendSubtractf\n    return max(base + blend - 1., 0.);\n}\n\nvec3 blendLinearBurn(in vec3 base, in vec3 blend) {\n  // Note : Same implementation as BlendSubtract\n    return max(base + blend - vec3(1.), vec3(0.));\n}\n\nvec3 blendLinearBurn(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendLinearBurn(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Linear Dodge blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendLinearDodge(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDLINEARDODGE\n#define FNC_BLENDLINEARDODGE\nfloat blendLinearDodge(in float base, in float blend) {\n  // Note : Same implementation as BlendAddf\n    return min(base + blend, 1.);\n}\n\nvec3 blendLinearDodge(in vec3 base, in vec3 blend) {\n  // Note : Same implementation as BlendAdd\n    return min(base + blend, vec3(1.));\n}\n\nvec3 blendLinearDodge(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendLinearDodge(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Linear Burn blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendLinearBurn(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDLINEARBURN\n#define FNC_BLENDLINEARBURN\nfloat blendLinearBurn(in float base, in float blend) {\n  // Note : Same implementation as BlendSubtractf\n    return max(base + blend - 1., 0.);\n}\n\nvec3 blendLinearBurn(in vec3 base, in vec3 blend) {\n  // Note : Same implementation as BlendSubtract\n    return max(base + blend - vec3(1.), vec3(0.));\n}\n\nvec3 blendLinearBurn(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendLinearBurn(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Linear Light blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendLinearLigth(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDLINEARLIGHT\n#define FNC_BLENDLINEARLIGHT\nfloat blendLinearLigth(in float base, in float blend) {\n  return blend < .5? blendLinearBurn(base, (2. * blend)): blendLinearDodge(base, (2. * (blend- .5)));\n}\n\nvec3 blendLinearLigth(in vec3 base, in vec3 blend) {\n  return vec3(blendLinearLigth(base.r, blend.r),\n              blendLinearLigth(base.g, blend.g),\n              blendLinearLigth(base.b, blend.b));\n}\n\nvec3 blendLinearLigth(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendLinearLigth(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Negation blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendNegation(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDNEGATION\n#define FNC_BLENDNEGATION\nfloat blendNegation(in float base, in float blend) {\n    return 1. - abs(1. - base - blend);\n}\n\nvec3 blendNegation(in vec3 base, in vec3 blend) {\n    return vec3(1.) - abs(vec3(1.) - base - blend);\n}\n\nvec3 blendNegation(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendNegation(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Phoenix blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendPhoenix(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDPHOENIX\n#define FNC_BLENDPHOENIX\nfloat blendPhoenix(in float base, in float blend) {\n    return min(base, blend) - max(base, blend) + 1.;\n}\n\nvec3 blendPhoenix(in vec3 base, in vec3 blend) {\n    return min(base, blend) - max(base, blend) + vec3(1.);\n}\n\nvec3 blendPhoenix(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendPhoenix(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Reflect blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendReflect(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDREFLECT\n#define FNC_BLENDREFLECT\nfloat blendReflect(in float base, in float blend) {\n    return (blend == 1.)? blend : min(base * base / (1. - blend), 1.);\n}\n\nvec3 blendReflect(in vec3 base, in vec3 blend) {\n    return vec3(blendReflect(base.r, blend.r),\n                blendReflect(base.g, blend.g),\n                blendReflect(base.b, blend.b));\n}\n\nvec3 blendReflect(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendReflect(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Soft Light blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendSoftLight(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDSOFTLIGHT\n#define FNC_BLENDSOFTLIGHT\nfloat blendSoftLight(in float base, in float blend) {\n    return (blend < .5)? (2. * base * blend + base * base * (1. - 2.*blend)): (sqrt(base) * (2. * blend - 1.) + 2. * base * (1. - blend));\n}\n\nvec3 blendSoftLight(in vec3 base, in vec3 blend) {\n    return vec3(blendSoftLight(base.r, blend.r),\n                blendSoftLight(base.g, blend.g),\n                blendSoftLight(base.b, blend.b));\n}\n\nvec4 blendSoftLight(in vec4 base, in vec4 blend) {\n    return vec4(blendSoftLight( base.r, blend.r ),\n                blendSoftLight( base.g, blend.g ),\n                blendSoftLight( base.b, blend.b ),\n                blendSoftLight( base.a, blend.a )\n    );\n}\n\nvec3 blendSoftLight(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendSoftLight(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Color Burn blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendColorBurn(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDCOLORBURN\n#define FNC_BLENDCOLORBURN\nfloat blendColorBurn(in float base, in float blend) {\n    return (blend == 0.)? blend: max((1. - ((1. - base ) / blend)), 0.);\n}\n\nvec3 blendColorBurn(in vec3 base, in vec3 blend) {\n    return vec3(blendColorBurn(base.r, blend.r),\n                blendColorBurn(base.g, blend.g),\n                blendColorBurn(base.b, blend.b));\n}\n\nvec3 blendColorBurn(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendColorBurn(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Color Dodge blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendColorDodge(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDCOLORDODGE\n#define FNC_BLENDCOLORDODGE\nfloat blendColorDodge(in float base, in float blend) {\n    return (blend == 1.)? blend: min( base / (1. - blend), 1.);\n}\n\nvec3 blendColorDodge(in vec3 base, in vec3 blend) {\n    return vec3(blendColorDodge(base.r, blend.r),\n                blendColorDodge(base.g, blend.g),\n                blendColorDodge(base.b, blend.b));\n}\n\nvec3 blendColorDodge(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendColorDodge(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Vivid Light blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendVividLight(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDVIVIDLIGHT\n#define FNC_BLENDVIVIDLIGHT\nfloat blendVividLight(in float base, in float blend) {\n    return (blend < .5)? blendColorBurn(base, (2.*blend)): blendColorDodge(base, (2. * (blend - .5)));\n}\n\nvec3 blendVividLight(in vec3 base, in vec3 blend) {\n    return vec3(blendVividLight(base.r, blend.r),\n                            blendVividLight(base.g, blend.g),\n                            blendVividLight(base.b, blend.b));\n}\n\nvec3 blendVividLight(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendVividLight(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Color Burn blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendColorBurn(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDCOLORBURN\n#define FNC_BLENDCOLORBURN\nfloat blendColorBurn(in float base, in float blend) {\n    return (blend == 0.)? blend: max((1. - ((1. - base ) / blend)), 0.);\n}\n\nvec3 blendColorBurn(in vec3 base, in vec3 blend) {\n    return vec3(blendColorBurn(base.r, blend.r),\n                blendColorBurn(base.g, blend.g),\n                blendColorBurn(base.b, blend.b));\n}\n\nvec3 blendColorBurn(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendColorBurn(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Darken blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendDarken(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDDARKEN\n#define FNC_BLENDDARKEN\nfloat blendDarken(in float base, in float blend) {\n    return min(blend,base);\n}\n\nvec3 blendDarken(in vec3 base, in vec3 blend) {\n    return vec3(blendDarken(base.r, blend.r),\n                blendDarken(base.g, blend.g),\n                blendDarken(base.b, blend.b));\n}\n\nvec3 blendDarken(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendDarken(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Exclusion blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendExclusion(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDEXCLUSION\n#define FNC_BLENDEXCLUSION\nfloat blendExclusion(in float base, in float blend) {\n    return base + blend - 2. * base * blend;\n}\n\nvec3 blendExclusion(in vec3 base, in vec3 blend) {\n    return base + blend - 2. * base * blend;\n}\n\nvec3 blendExclusion(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendExclusion(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Overlay blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendOverlay(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDOVERLAY\n#define FNC_BLENDOVERLAY\nfloat blendOverlay(in float base, in float blend) {\n    return (base < .5)? (2.*base*blend): (1. - 2. * (1. - base) * (1. - blend));\n}\n\nvec3 blendOverlay(in vec3 base, in vec3 blend) {\n    return vec3(blendOverlay(base.r, blend.r),\n                blendOverlay(base.g, blend.g),\n                blendOverlay(base.b, blend.b));\n}\n\nvec3 blendOverlay(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendOverlay(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop HardLight blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendHardLight(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDHARDLIGHT\n#define FNC_BLENDHARDLIGHT\nfloat blendHardLight(in float base, in float blend) {\n    return blendOverlay(blend, base);\n}\n\nvec3 blendHardLight(in vec3 base, in vec3 blend) {\n    return blendOverlay(blend, base);\n}\n\nvec3 blendHardLight(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendHardLight(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Lighten blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendLighten(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDLIGHTEN\n#define FNC_BLENDLIGHTEN\nfloat blendLighten(in float base, in float blend) {\n    return max(blend, base);\n}\n\nvec3 blendLighten(in vec3 base, in vec3 blend) {\n    return vec3(blendLighten(base.r, blend.r),\n                blendLighten(base.g, blend.g),\n                blendLighten(base.b, blend.b));\n}\n\nvec3 blendLighten(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendLighten(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Linear Dodge blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendLinearDodge(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDLINEARDODGE\n#define FNC_BLENDLINEARDODGE\nfloat blendLinearDodge(in float base, in float blend) {\n  // Note : Same implementation as BlendAddf\n    return min(base + blend, 1.);\n}\n\nvec3 blendLinearDodge(in vec3 base, in vec3 blend) {\n  // Note : Same implementation as BlendAdd\n    return min(base + blend, vec3(1.));\n}\n\nvec3 blendLinearDodge(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendLinearDodge(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Multiply blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendMultiply(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDMULTIPLY\n#define FNC_BLENDMULTIPLY\nfloat blendMultiply(in float base, in float blend) {\n    return base * blend;\n}\n\nvec3 blendMultiply(in vec3 base, in vec3 blend) {\n    return base * blend;\n}\n\nvec3 blendMultiply(in vec3 base, in vec3 blend, float opacity) {\n    return (blendMultiply(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Overlay blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendOverlay(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDOVERLAY\n#define FNC_BLENDOVERLAY\nfloat blendOverlay(in float base, in float blend) {\n    return (base < .5)? (2.*base*blend): (1. - 2. * (1. - base) * (1. - blend));\n}\n\nvec3 blendOverlay(in vec3 base, in vec3 blend) {\n    return vec3(blendOverlay(base.r, blend.r),\n                blendOverlay(base.g, blend.g),\n                blendOverlay(base.b, blend.b));\n}\n\nvec3 blendOverlay(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendOverlay(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Lighten blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendLighten(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDLIGHTEN\n#define FNC_BLENDLIGHTEN\nfloat blendLighten(in float base, in float blend) {\n    return max(blend, base);\n}\n\nvec3 blendLighten(in vec3 base, in vec3 blend) {\n    return vec3(blendLighten(base.r, blend.r),\n                blendLighten(base.g, blend.g),\n                blendLighten(base.b, blend.b));\n}\n\nvec3 blendLighten(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendLighten(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Darken blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendDarken(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDDARKEN\n#define FNC_BLENDDARKEN\nfloat blendDarken(in float base, in float blend) {\n    return min(blend,base);\n}\n\nvec3 blendDarken(in vec3 base, in vec3 blend) {\n    return vec3(blendDarken(base.r, blend.r),\n                blendDarken(base.g, blend.g),\n                blendDarken(base.b, blend.b));\n}\n\nvec3 blendDarken(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendDarken(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Pin Light blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendPinLight(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDPINLIGHT\n#define FNC_BLENDPINLIGHT\nfloat blendPinLight(in float base, in float blend) {\n    return (blend < .5)? blendDarken(base, (2.*blend)): blendLighten(base, (2. * (blend - .5)));\n}\n\nvec3 blendPinLight(in vec3 base, in vec3 blend) {\n    return vec3(blendPinLight(base.r, blend.r),\n                blendPinLight(base.g, blend.g),\n                blendPinLight(base.b, blend.b));\n}\n\nvec3 blendPinLight(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendPinLight(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Screen blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendScreen(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDSCREEN\n#define FNC_BLENDSCREEN\nfloat blendScreen(in float base, in float blend) {\n    return 1. - ((1. - base) * (1. - blend));\n}\n\nvec3 blendScreen(in vec3 base, in vec3 blend) {\n    return vec3(blendScreen(base.r, blend.r),\n                blendScreen(base.g, blend.g),\n                blendScreen(base.b, blend.b));\n}\n\nvec3 blendScreen(in vec3 base, in vec3 blend, float opacity) {\n    return (blendScreen(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Soft Light blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendSubtract(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDSUBTRACT\n#define FNC_BLENDSUBTRACT\nfloat blendSubtract(in float base, in float blend) {\n    return max(base + blend - 1., 0.);\n}\n\nvec3 blendSubtract(in vec3 base, in vec3 blend) {\n    return max(base + blend - vec3(1.), vec3(0.));\n}\n\nvec3 blendSubtract(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendSubtract(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},4440:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Add blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendAdd(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDADD\n#define FNC_BLENDADD\nfloat blendAdd(in float base, in float blend) {\n    return min(base + blend, 1.);\n}\n\nvec3 blendAdd(in vec3 base, in vec3 blend) {\n    return min(base + blend, vec3(1.));\n}\n\nvec3 blendAdd(in vec3 base, in vec3 blend, float opacity) {\n    return (blendAdd(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},613:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Average blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendAverage(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDAVERAGE\n#define FNC_BLENDAVERAGE\nfloat blendAverage(in float base, in float blend) {\n    return (base + blend) * .5;\n}\n\nvec3 blendAverage(in vec3 base, in vec3 blend) {\n    return (base + blend) * .5;\n}\n\nvec3 blendAverage(in vec3 base, in vec3 blend, float opacity) {\n    return (blendAverage(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},1135:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Color Burn blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendColorBurn(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDCOLORBURN\n#define FNC_BLENDCOLORBURN\nfloat blendColorBurn(in float base, in float blend) {\n    return (blend == 0.)? blend: max((1. - ((1. - base ) / blend)), 0.);\n}\n\nvec3 blendColorBurn(in vec3 base, in vec3 blend) {\n    return vec3(blendColorBurn(base.r, blend.r),\n                blendColorBurn(base.g, blend.g),\n                blendColorBurn(base.b, blend.b));\n}\n\nvec3 blendColorBurn(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendColorBurn(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},6444:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Color Dodge blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendColorDodge(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDCOLORDODGE\n#define FNC_BLENDCOLORDODGE\nfloat blendColorDodge(in float base, in float blend) {\n    return (blend == 1.)? blend: min( base / (1. - blend), 1.);\n}\n\nvec3 blendColorDodge(in vec3 base, in vec3 blend) {\n    return vec3(blendColorDodge(base.r, blend.r),\n                blendColorDodge(base.g, blend.g),\n                blendColorDodge(base.b, blend.b));\n}\n\nvec3 blendColorDodge(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendColorDodge(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},9976:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Darken blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendDarken(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDDARKEN\n#define FNC_BLENDDARKEN\nfloat blendDarken(in float base, in float blend) {\n    return min(blend,base);\n}\n\nvec3 blendDarken(in vec3 base, in vec3 blend) {\n    return vec3(blendDarken(base.r, blend.r),\n                blendDarken(base.g, blend.g),\n                blendDarken(base.b, blend.b));\n}\n\nvec3 blendDarken(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendDarken(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},313:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Difference blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendDifference(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDDIFFERENCE\n#define FNC_BLENDDIFFERENCE\nfloat blendDifference(in float base, in float blend) {\n    return abs(base-blend);\n}\n\nvec3 blendDifference(in vec3 base, in vec3 blend) {\n    return abs(base-blend);\n}\n\nvec3 blendDifference(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendDifference(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},9220:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Exclusion blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendExclusion(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDEXCLUSION\n#define FNC_BLENDEXCLUSION\nfloat blendExclusion(in float base, in float blend) {\n    return base + blend - 2. * base * blend;\n}\n\nvec3 blendExclusion(in vec3 base, in vec3 blend) {\n    return base + blend - 2. * base * blend;\n}\n\nvec3 blendExclusion(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendExclusion(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},2542:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Reflect blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendReflect(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDREFLECT\n#define FNC_BLENDREFLECT\nfloat blendReflect(in float base, in float blend) {\n    return (blend == 1.)? blend : min(base * base / (1. - blend), 1.);\n}\n\nvec3 blendReflect(in vec3 base, in vec3 blend) {\n    return vec3(blendReflect(base.r, blend.r),\n                blendReflect(base.g, blend.g),\n                blendReflect(base.b, blend.b));\n}\n\nvec3 blendReflect(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendReflect(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Glow blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendGlow(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDGLOW\n#define FNC_BLENDGLOW\nfloat blendGlow(in float base, in float blend) {\n    return blendReflect(blend, base);\n}\n\nvec3 blendGlow(in vec3 base, in vec3 blend) {\n    return blendReflect(blend, base);\n}\n\nvec3 blendGlow(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendGlow(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},4951:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Overlay blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendOverlay(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDOVERLAY\n#define FNC_BLENDOVERLAY\nfloat blendOverlay(in float base, in float blend) {\n    return (base < .5)? (2.*base*blend): (1. - 2. * (1. - base) * (1. - blend));\n}\n\nvec3 blendOverlay(in vec3 base, in vec3 blend) {\n    return vec3(blendOverlay(base.r, blend.r),\n                blendOverlay(base.g, blend.g),\n                blendOverlay(base.b, blend.b));\n}\n\nvec3 blendOverlay(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendOverlay(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop HardLight blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendHardLight(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDHARDLIGHT\n#define FNC_BLENDHARDLIGHT\nfloat blendHardLight(in float base, in float blend) {\n    return blendOverlay(blend, base);\n}\n\nvec3 blendHardLight(in vec3 base, in vec3 blend) {\n    return blendOverlay(blend, base);\n}\n\nvec3 blendHardLight(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendHardLight(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},2078:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Color Burn blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendColorBurn(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDCOLORBURN\n#define FNC_BLENDCOLORBURN\nfloat blendColorBurn(in float base, in float blend) {\n    return (blend == 0.)? blend: max((1. - ((1. - base ) / blend)), 0.);\n}\n\nvec3 blendColorBurn(in vec3 base, in vec3 blend) {\n    return vec3(blendColorBurn(base.r, blend.r),\n                blendColorBurn(base.g, blend.g),\n                blendColorBurn(base.b, blend.b));\n}\n\nvec3 blendColorBurn(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendColorBurn(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Color Dodge blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendColorDodge(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDCOLORDODGE\n#define FNC_BLENDCOLORDODGE\nfloat blendColorDodge(in float base, in float blend) {\n    return (blend == 1.)? blend: min( base / (1. - blend), 1.);\n}\n\nvec3 blendColorDodge(in vec3 base, in vec3 blend) {\n    return vec3(blendColorDodge(base.r, blend.r),\n                blendColorDodge(base.g, blend.g),\n                blendColorDodge(base.b, blend.b));\n}\n\nvec3 blendColorDodge(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendColorDodge(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Vivid Light blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendVividLight(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDVIVIDLIGHT\n#define FNC_BLENDVIVIDLIGHT\nfloat blendVividLight(in float base, in float blend) {\n    return (blend < .5)? blendColorBurn(base, (2.*blend)): blendColorDodge(base, (2. * (blend - .5)));\n}\n\nvec3 blendVividLight(in vec3 base, in vec3 blend) {\n    return vec3(blendVividLight(base.r, blend.r),\n                            blendVividLight(base.g, blend.g),\n                            blendVividLight(base.b, blend.b));\n}\n\nvec3 blendVividLight(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendVividLight(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Hard Mix blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendHardMix(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDHARDMIX\n#define FNC_BLENDHARDMIX\nfloat blendHardMix(in float base, in float blend) {\n    return (blendVividLight(base, blend) < .5)? 0.: 1.;\n}\n\nvec3 blendHardMix(in vec3 base, in vec3 blend) {\n    return vec3(blendHardMix(base.r, blend.r),\n                blendHardMix(base.g, blend.g),\n                blendHardMix(base.b, blend.b));\n}\n\nvec3 blendHardMix(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendHardMix(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},9378:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Lighten blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendLighten(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDLIGHTEN\n#define FNC_BLENDLIGHTEN\nfloat blendLighten(in float base, in float blend) {\n    return max(blend, base);\n}\n\nvec3 blendLighten(in vec3 base, in vec3 blend) {\n    return vec3(blendLighten(base.r, blend.r),\n                blendLighten(base.g, blend.g),\n                blendLighten(base.b, blend.b));\n}\n\nvec3 blendLighten(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendLighten(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},1221:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Linear Burn blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendLinearBurn(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDLINEARBURN\n#define FNC_BLENDLINEARBURN\nfloat blendLinearBurn(in float base, in float blend) {\n  // Note : Same implementation as BlendSubtractf\n    return max(base + blend - 1., 0.);\n}\n\nvec3 blendLinearBurn(in vec3 base, in vec3 blend) {\n  // Note : Same implementation as BlendSubtract\n    return max(base + blend - vec3(1.), vec3(0.));\n}\n\nvec3 blendLinearBurn(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendLinearBurn(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},2527:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Linear Dodge blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendLinearDodge(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDLINEARDODGE\n#define FNC_BLENDLINEARDODGE\nfloat blendLinearDodge(in float base, in float blend) {\n  // Note : Same implementation as BlendAddf\n    return min(base + blend, 1.);\n}\n\nvec3 blendLinearDodge(in vec3 base, in vec3 blend) {\n  // Note : Same implementation as BlendAdd\n    return min(base + blend, vec3(1.));\n}\n\nvec3 blendLinearDodge(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendLinearDodge(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},2021:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Linear Dodge blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendLinearDodge(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDLINEARDODGE\n#define FNC_BLENDLINEARDODGE\nfloat blendLinearDodge(in float base, in float blend) {\n  // Note : Same implementation as BlendAddf\n    return min(base + blend, 1.);\n}\n\nvec3 blendLinearDodge(in vec3 base, in vec3 blend) {\n  // Note : Same implementation as BlendAdd\n    return min(base + blend, vec3(1.));\n}\n\nvec3 blendLinearDodge(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendLinearDodge(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Linear Burn blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendLinearBurn(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDLINEARBURN\n#define FNC_BLENDLINEARBURN\nfloat blendLinearBurn(in float base, in float blend) {\n  // Note : Same implementation as BlendSubtractf\n    return max(base + blend - 1., 0.);\n}\n\nvec3 blendLinearBurn(in vec3 base, in vec3 blend) {\n  // Note : Same implementation as BlendSubtract\n    return max(base + blend - vec3(1.), vec3(0.));\n}\n\nvec3 blendLinearBurn(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendLinearBurn(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Linear Light blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendLinearLigth(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDLINEARLIGHT\n#define FNC_BLENDLINEARLIGHT\nfloat blendLinearLigth(in float base, in float blend) {\n  return blend < .5? blendLinearBurn(base, (2. * blend)): blendLinearDodge(base, (2. * (blend- .5)));\n}\n\nvec3 blendLinearLigth(in vec3 base, in vec3 blend) {\n  return vec3(blendLinearLigth(base.r, blend.r),\n              blendLinearLigth(base.g, blend.g),\n              blendLinearLigth(base.b, blend.b));\n}\n\nvec3 blendLinearLigth(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendLinearLigth(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},4925:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Multiply blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendMultiply(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDMULTIPLY\n#define FNC_BLENDMULTIPLY\nfloat blendMultiply(in float base, in float blend) {\n    return base * blend;\n}\n\nvec3 blendMultiply(in vec3 base, in vec3 blend) {\n    return base * blend;\n}\n\nvec3 blendMultiply(in vec3 base, in vec3 blend, float opacity) {\n    return (blendMultiply(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},823:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Negation blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendNegation(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDNEGATION\n#define FNC_BLENDNEGATION\nfloat blendNegation(in float base, in float blend) {\n    return 1. - abs(1. - base - blend);\n}\n\nvec3 blendNegation(in vec3 base, in vec3 blend) {\n    return vec3(1.) - abs(vec3(1.) - base - blend);\n}\n\nvec3 blendNegation(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendNegation(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},4681:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Overlay blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendOverlay(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDOVERLAY\n#define FNC_BLENDOVERLAY\nfloat blendOverlay(in float base, in float blend) {\n    return (base < .5)? (2.*base*blend): (1. - 2. * (1. - base) * (1. - blend));\n}\n\nvec3 blendOverlay(in vec3 base, in vec3 blend) {\n    return vec3(blendOverlay(base.r, blend.r),\n                blendOverlay(base.g, blend.g),\n                blendOverlay(base.b, blend.b));\n}\n\nvec3 blendOverlay(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendOverlay(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},2435:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Phoenix blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendPhoenix(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDPHOENIX\n#define FNC_BLENDPHOENIX\nfloat blendPhoenix(in float base, in float blend) {\n    return min(base, blend) - max(base, blend) + 1.;\n}\n\nvec3 blendPhoenix(in vec3 base, in vec3 blend) {\n    return min(base, blend) - max(base, blend) + vec3(1.);\n}\n\nvec3 blendPhoenix(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendPhoenix(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},8186:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Lighten blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendLighten(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDLIGHTEN\n#define FNC_BLENDLIGHTEN\nfloat blendLighten(in float base, in float blend) {\n    return max(blend, base);\n}\n\nvec3 blendLighten(in vec3 base, in vec3 blend) {\n    return vec3(blendLighten(base.r, blend.r),\n                blendLighten(base.g, blend.g),\n                blendLighten(base.b, blend.b));\n}\n\nvec3 blendLighten(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendLighten(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Darken blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendDarken(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDDARKEN\n#define FNC_BLENDDARKEN\nfloat blendDarken(in float base, in float blend) {\n    return min(blend,base);\n}\n\nvec3 blendDarken(in vec3 base, in vec3 blend) {\n    return vec3(blendDarken(base.r, blend.r),\n                blendDarken(base.g, blend.g),\n                blendDarken(base.b, blend.b));\n}\n\nvec3 blendDarken(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendDarken(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Pin Light blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendPinLight(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDPINLIGHT\n#define FNC_BLENDPINLIGHT\nfloat blendPinLight(in float base, in float blend) {\n    return (blend < .5)? blendDarken(base, (2.*blend)): blendLighten(base, (2. * (blend - .5)));\n}\n\nvec3 blendPinLight(in vec3 base, in vec3 blend) {\n    return vec3(blendPinLight(base.r, blend.r),\n                blendPinLight(base.g, blend.g),\n                blendPinLight(base.b, blend.b));\n}\n\nvec3 blendPinLight(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendPinLight(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},8622:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Reflect blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendReflect(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDREFLECT\n#define FNC_BLENDREFLECT\nfloat blendReflect(in float base, in float blend) {\n    return (blend == 1.)? blend : min(base * base / (1. - blend), 1.);\n}\n\nvec3 blendReflect(in vec3 base, in vec3 blend) {\n    return vec3(blendReflect(base.r, blend.r),\n                blendReflect(base.g, blend.g),\n                blendReflect(base.b, blend.b));\n}\n\nvec3 blendReflect(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendReflect(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},9600:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Screen blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendScreen(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDSCREEN\n#define FNC_BLENDSCREEN\nfloat blendScreen(in float base, in float blend) {\n    return 1. - ((1. - base) * (1. - blend));\n}\n\nvec3 blendScreen(in vec3 base, in vec3 blend) {\n    return vec3(blendScreen(base.r, blend.r),\n                blendScreen(base.g, blend.g),\n                blendScreen(base.b, blend.b));\n}\n\nvec3 blendScreen(in vec3 base, in vec3 blend, float opacity) {\n    return (blendScreen(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},9556:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Soft Light blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendSoftLight(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDSOFTLIGHT\n#define FNC_BLENDSOFTLIGHT\nfloat blendSoftLight(in float base, in float blend) {\n    return (blend < .5)? (2. * base * blend + base * base * (1. - 2.*blend)): (sqrt(base) * (2. * blend - 1.) + 2. * base * (1. - blend));\n}\n\nvec3 blendSoftLight(in vec3 base, in vec3 blend) {\n    return vec3(blendSoftLight(base.r, blend.r),\n                blendSoftLight(base.g, blend.g),\n                blendSoftLight(base.b, blend.b));\n}\n\nvec4 blendSoftLight(in vec4 base, in vec4 blend) {\n    return vec4(blendSoftLight( base.r, blend.r ),\n                blendSoftLight( base.g, blend.g ),\n                blendSoftLight( base.b, blend.b ),\n                blendSoftLight( base.a, blend.a )\n    );\n}\n\nvec3 blendSoftLight(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendSoftLight(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},5232:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Soft Light blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendSubtract(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDSUBTRACT\n#define FNC_BLENDSUBTRACT\nfloat blendSubtract(in float base, in float blend) {\n    return max(base + blend - 1., 0.);\n}\n\nvec3 blendSubtract(in vec3 base, in vec3 blend) {\n    return max(base + blend - vec3(1.), vec3(0.));\n}\n\nvec3 blendSubtract(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendSubtract(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},971:n=>{n.exports="/*\nauthor: Jamie Owen\ndescription: Photoshop Color Burn blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendColorBurn(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDCOLORBURN\n#define FNC_BLENDCOLORBURN\nfloat blendColorBurn(in float base, in float blend) {\n    return (blend == 0.)? blend: max((1. - ((1. - base ) / blend)), 0.);\n}\n\nvec3 blendColorBurn(in vec3 base, in vec3 blend) {\n    return vec3(blendColorBurn(base.r, blend.r),\n                blendColorBurn(base.g, blend.g),\n                blendColorBurn(base.b, blend.b));\n}\n\nvec3 blendColorBurn(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendColorBurn(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Color Dodge blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendColorDodge(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDCOLORDODGE\n#define FNC_BLENDCOLORDODGE\nfloat blendColorDodge(in float base, in float blend) {\n    return (blend == 1.)? blend: min( base / (1. - blend), 1.);\n}\n\nvec3 blendColorDodge(in vec3 base, in vec3 blend) {\n    return vec3(blendColorDodge(base.r, blend.r),\n                blendColorDodge(base.g, blend.g),\n                blendColorDodge(base.b, blend.b));\n}\n\nvec3 blendColorDodge(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendColorDodge(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n\n\n/*\nauthor: Jamie Owen\ndescription: Photoshop Vivid Light blend mode mplementations sourced from this article on https://mouaif.wordpress.com/2009/01/05/photoshop-math-with-glsl-shaders/\nuse: blendVividLight(<float|vec3> base, <float|vec3> blend [, <float> opacity])\nlicence: TODO\n*/\n\n#ifndef FNC_BLENDVIVIDLIGHT\n#define FNC_BLENDVIVIDLIGHT\nfloat blendVividLight(in float base, in float blend) {\n    return (blend < .5)? blendColorBurn(base, (2.*blend)): blendColorDodge(base, (2. * (blend - .5)));\n}\n\nvec3 blendVividLight(in vec3 base, in vec3 blend) {\n    return vec3(blendVividLight(base.r, blend.r),\n                            blendVividLight(base.g, blend.g),\n                            blendVividLight(base.b, blend.b));\n}\n\nvec3 blendVividLight(in vec3 base, in vec3 blend, in float opacity) {\n    return (blendVividLight(base, blend) * opacity + base * (1. - opacity));\n}\n#endif\n"},2743:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: generate a matrix to change a the brightness of any color\nuse: brightnessMatrix(<float> amount)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_BRIGHTNESSMATRIX\n#define FNC_BRIGHTNESSMATRIX\nmat4 brightnessMatrix(in float amount) {\n    return mat4(  1., 0., 0., 0.,\n                  0., 1., 0., 0.,\n                  0., 0., 1., 0.,\n                  amount, amount, amount, 1. );\n}\n#endif\n'},1663:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: generate a matrix to change a the contrast of any color\nuse: contrastMatrix(<float> amount)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_CONTRASTMATRIX\n#define FNC_CONTRASTMATRIX\nmat4 contrastMatrix(in float amount) {\n    float t = ( 1. - amount ) * .5;\n    return mat4( amount, .0, .0, .0,\n                .0, amount, .0, .0,\n                .0, .0, amount, .0,\n                t,   t,      t, 1. );\n}\n#endif\n'},2799:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: change saturation of a color\nuse: desaturate(<float|vec3|vec4> color, float amount)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_DESATURATE\n#define FNC_DESATURATE\nvec3 desaturate(in vec3 color, in float amount ) {\n    return mix(color, vec3(dot(vec3(.3, .59, .11), color)), amount);\n}\n\nvec4 desaturate(in vec4 color, in float amount ) {\n    return vec4(desaturate(color.rgb, amount), color.a);\n}\n#endif\n'},7427:n=>{n.exports='/*\nauthor: Sam Hocevar\ndescription: pass a color in RGB and get HSB color. From http://lolengine.net/blog/2013/07/27/rgb-to-hsv-in-glsl\nuse: rgb2hsv(<vec3|vec4> color)\nlicence: TODO\n*/\n\n#ifndef FNC_RGB2HSV\n#define FNC_RGB2HSV\nvec3 rgb2hsv(in vec3 c) {\n    vec4 K = vec4(0., -.33333333333333333333, .6666666666666666666, -1.);\n\n#ifdef RGB2HSV_MIX\n    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));\n    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));\n#else\n    vec4 p = c.g < c.b ? vec4(c.bg, K.wz) : vec4(c.gb, K.xy);\n    vec4 q = c.r < p.x ? vec4(p.xyw, c.r) : vec4(c.r, p.yzx);\n#endif\n\n    float d = q.x - min(q.w, q.y);\n    float e = 1.0e-10;\n    return vec3(abs(q.z + (q.w - q.y) / (6. * d + e)), \n                d / (q.x + e), \n                q.x);\n}\n\nvec4 rgb2hsv(in vec4 c) {\n    return vec4(rgb2hsv(c.rgb), c.a);\n}\n#endif\n/*\nauthor: Inigo Quiles\ndescription: pass a color in HSB and get RGB color. Also use as reference http://lolengine.net/blog/2013/07/27/rgb-to-hsv-in-glsl\nuse: hsv2rgb(<vec3|vec4> color)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_HSV2RGB\n#define FNC_HSV2RGB\nvec3 hsv2rgb(in vec3 hsb) {\n    vec3 rgb = clamp(abs(mod(hsb.x * 6. + vec3(0., 4., 2.), \n                            6.) - 3.) - 1.,\n                      0.,\n                      1.);\n    #ifdef HSV2RGB_SMOOTH\n    rgb = rgb*rgb*(3. - 2. * rgb);\n    #endif\n    return hsb.z * mix(vec3(1.), rgb, hsb.y);\n}\n\nvec4 hsv2rgb(in vec4 hsb) {\n    return vec4(hsv2rgb(hsb.rgb), hsb.a);\n}\n#endif\n\n/*\nauthor: Johan Ismael\ndescription: shifts color hue\nuse: hueShift(<vec3|vec4> color, <float> amount)\nlicense: |\n  Copyright (c) 2017 Johan Ismael.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_HUESHIFT\n#define FNC_HUESHIFT\nvec3 hueShift(in vec3 color, in float amount) {\n    vec3 hsv = rgb2hsv(color);\n    hsv.r += amount;\n    return hsv2rgb(hsv);\n}\n\nvec4 hueShift(in vec4 color, in float amount) {\n    return vec4(hueShift(color.rgb, amount), color.a);\n}\n#endif`'},177:n=>{n.exports='/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: get\'s the luminosity of a color. From https://github.com/hughsk/glsl-luma/blob/master/index.glsl\nuse: rgb2luma(<vec3|vec4> color)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_RGB2LUMA\n#define FNC_RGB2LUMA\nfloat rgb2luma(in vec3 color) {\n    return dot(color, vec3(0.299, 0.587, 0.114));\n}\n\nfloat rgb2luma(in vec4 color) {\n    return rgb2luma(color.rgb);\n}\n#endif\n\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: get the luminosity of a color. From https://github.com/hughsk/glsl-luma/blob/master/index.glsl\nuse: luma(<vec3|vec4> color)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_LUMA\n#define FNC_LUMA\nfloat luma(float color) {\n    return color;\n}\n\nfloat luma(in vec3 color) {\n    return rgb2luma(color);\n}\n\nfloat luma(in vec4 color) {\n    return rgb2luma(color.rgb);\n}\n#endif\n'},4141:n=>{n.exports='/*\nAuthor: [Johan Ismael, Patricio Gonzalez Vivo]\ndescription: Use LUT textures to modify colors (vec4 and vec3) or a position in a gradient (vec2 and floats)\nuse: lut(<sampler2D> texture, <vec4|vec3|vec2|float> value [, int row])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo & Johan Ismael.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef LUT_N_ROWS\n#define LUT_N_ROWS 1\n#endif\n\n#ifndef LUT_CELL_SIZE\n#define LUT_CELL_SIZE 32.0\n#endif\n\n#ifndef FNC_LUT\n#define FNC_LUT\n// Data about how the LUTs rows are encoded\nconst float LUT_WIDTH = LUT_CELL_SIZE*LUT_CELL_SIZE;\nconst float LUT_OFFSET = 1./ float( LUT_N_ROWS );\nconst vec4 LUT_SIZE = vec4(LUT_WIDTH, LUT_CELL_SIZE, 1./LUT_WIDTH, 1./LUT_CELL_SIZE);\n\n// Apply LUT to a COLOR\n// ------------------------------------------------------------\nvec4 lut(in sampler2D tex_lut, in vec4 color, in int offset) {\n  vec3 scaledColor = clamp(color.rgb, vec3(0.), vec3(1.)) * (LUT_SIZE.y - 1.);\n  float bFrac = fract(scaledColor.z);\n\n  // offset by 0.5 pixel and fit within range [0.5, width-0.5]\n  // to prevent bilinear filtering with adjacent colors\n  vec2 texc = (.5 + scaledColor.xy) * LUT_SIZE.zw;\n\n  // offset by the blue slice\n  texc.x += (scaledColor.z - bFrac) * LUT_SIZE.w;\n  texc.y *= LUT_OFFSET;\n  texc.y += float(offset) * LUT_OFFSET;\n  #ifndef LUT_INVERT\n  texc.y = 1. - texc.y; \n  #endif\n\n  // sample the 2 adjacent blue slices\n  vec3 b0 = texture2D(tex_lut, texc).xyz;\n  vec3 b1 = texture2D(tex_lut, vec2(texc.x + LUT_SIZE.w, texc.y)).xyz;\n\n  // blend between the 2 adjacent blue slices\n  color.xyz = mix(b0, b1, bFrac);\n\n  return color;\n}\n\nvec4 lut(in sampler2D tex_lut, in vec4 color) {\n  return lut(tex_lut, color, 0);\n}\n\nvec3 lut(in sampler2D tex_lut, in vec3 color, in int offset) {\n  return lut(tex_lut, vec4(color, 1.), offset).rgb;\n}\n\nvec3 lut(in sampler2D tex_lut, in vec3 color) {\n  return lut(tex_lut, color, 0).rgb;\n}\n\n#endif'},8063:n=>{n.exports='#ifndef QTR_PI\n#define QTR_PI 0.78539816339\n#endif\n#ifndef HALF_PI\n#define HALF_PI 1.5707963267948966192313216916398\n#endif\n#ifndef PI\n#define PI 3.1415926535897932384626433832795\n#endif\n#ifndef TWO_PI\n#define TWO_PI 6.2831853071795864769252867665590\n#endif\n#ifndef TAU\n#define TAU 6.2831853071795864769252867665590\n#endif\n#ifndef ONE_OVER_PI\n#define ONE_OVER_PI 0.31830988618\n#endif\n#ifndef PHI\n#define PHI 1.618033988749894848204586834\n#endif\n#ifndef EPSILON\n#define EPSILON 0.0000001\n#endif\n#ifndef GOLDEN_RATIO\n#define GOLDEN_RATIO 1.6180339887\n#endif\n#ifndef GOLDEN_ANGLE // (3.-sqrt(5.0))*PI radians\n#define GOLDEN_ANGLE 2.39996323\n#endif\n\n\n/*\nauthor: Inigo Quiles\ndescription:  Procedural generation of color palette algorithm explained here http://www.iquilezles.org/www/articles/palettes/palettes.htm)\nuse: palette(<float> t, <vec3|vec4> a, <vec3|vec4> b, <vec3|vec4> c, <vec3|vec4> d)\nlicense: |\n  Copyright © 2015 Inigo Quilez\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_PALETTE\n#define FNC_PALETTE\nvec3 palette (in float t, in vec3 a, in vec3 b, in vec3 c, in vec3 d) {\n    return a + b * cos(TAU * ( c * t + d ));\n}\n\nvec4 palette (in float t, in vec4 a, in vec4 b, in vec4 c, in vec4 d) {\n    return a + b * cos(TAU * ( c * t + d ));\n}\n#endif\n'},8980:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: generate a matrix to change a the saturation of any color\nuse: saturationMatrix(<float> amount)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_SATURATIONMATRIX\n#define FNC_SATURATIONMATRIX\nmat4 saturationMatrix(in float amount) {\n    vec3 lum = vec3(.3086, .6094, .0820 );\n\n    float invAmount= 1. - amount;\n\n    vec3 red = vec3(lum.x * invAmount);\n    red += vec3(amount, .0, .0);\n\n    vec3 green = vec3(lum.y * invAmount);\n    green += vec3( .0, amount, .0);\n\n    vec3 blue = vec3(lum.z * invAmount);\n    blue += vec3( .0, .0, amount);\n\n    return mat4(red,        .0,\n                green,      .0,\n                blue,       .0,\n                .0, .0, .0, 1.);\n}\n#endif\n'},82:n=>{n.exports='/*\ndescription: Include all available color spaces conversions\n*/\n\n/*\nauthor: Sam Hocevar\ndescription: pass a color in RGB and get HSB color. From http://lolengine.net/blog/2013/07/27/rgb-to-hsv-in-glsl\nuse: rgb2hsv(<vec3|vec4> color)\nlicence: TODO\n*/\n\n#ifndef FNC_RGB2HSV\n#define FNC_RGB2HSV\nvec3 rgb2hsv(in vec3 c) {\n    vec4 K = vec4(0., -.33333333333333333333, .6666666666666666666, -1.);\n\n#ifdef RGB2HSV_MIX\n    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));\n    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));\n#else\n    vec4 p = c.g < c.b ? vec4(c.bg, K.wz) : vec4(c.gb, K.xy);\n    vec4 q = c.r < p.x ? vec4(p.xyw, c.r) : vec4(c.r, p.yzx);\n#endif\n\n    float d = q.x - min(q.w, q.y);\n    float e = 1.0e-10;\n    return vec3(abs(q.z + (q.w - q.y) / (6. * d + e)), \n                d / (q.x + e), \n                q.x);\n}\n\nvec4 rgb2hsv(in vec4 c) {\n    return vec4(rgb2hsv(c.rgb), c.a);\n}\n#endif\n/*\nauthor: Inigo Quiles\ndescription: pass a color in HSB and get RGB color. Also use as reference http://lolengine.net/blog/2013/07/27/rgb-to-hsv-in-glsl\nuse: hsv2rgb(<vec3|vec4> color)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_HSV2RGB\n#define FNC_HSV2RGB\nvec3 hsv2rgb(in vec3 hsb) {\n    vec3 rgb = clamp(abs(mod(hsb.x * 6. + vec3(0., 4., 2.), \n                            6.) - 3.) - 1.,\n                      0.,\n                      1.);\n    #ifdef HSV2RGB_SMOOTH\n    rgb = rgb*rgb*(3. - 2. * rgb);\n    #endif\n    return hsb.z * mix(vec3(1.), rgb, hsb.y);\n}\n\nvec4 hsv2rgb(in vec4 hsb) {\n    return vec4(hsv2rgb(hsb.rgb), hsb.a);\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: pass a color in RGB and get it in YUB\nuse: rgb2yuv(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_RGB2YUV\n#define FNC_RGB2YUV\n\n#ifdef YUV_SDTV\nconst mat3 rgb2yuv_mat = mat3(\n    .299, -.14713,  .615,\n    .587, -.28886, -.51499,\n    .114,  .436,   -.10001\n);\n#else\nconst mat3 rgb2yuv_mat = mat3(\n    .2126,  -.09991, .615,\n    .7152,  -.33609,-.55861,\n    .0722,   .426,  -.05639\n);\n#endif\n\nvec3 rgb2yuv(in vec3 rgb) {\n    return rgb2yuv_mat * rgb;\n}\n\nvec4 rgb2yuv(in vec4 rgb) {\n    return vec4(rgb2yuv(rgb.rgb),rgb.a);\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: pass a color in YUB and get RGB color\nuse: yuv2rgb(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_YUV2RGB\n#define FNC_YUV2RGB\n\n#ifdef YUV_SDTV\nconst mat3 yuv2rgb_mat = mat3(\n    1.,       1. ,      1.,\n    0.,       -.39465,  2.03211,\n    1.13983,  -.58060,  0.\n);\n#else\nconst mat3 yuv2rgb_mat = mat3(\n    1.,       1. ,      1.,\n    0.,       -.21482,  2.12798,\n    1.28033,  -.38059,  0.\n);\n#endif\n\nvec3 yuv2rgb(in vec3 yuv) {\n    return yuv2rgb_mat * yuv;\n}\n\nvec4 yuv2rgb(in vec4 yuv) {\n    return vec4(yuv2rgb(yuv.rgb), yuv.a);\n}\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: |\n  Convert from RGB to YIQ which was the followin range\n  Y [0,.1], I [-0.5957, 0.5957], Q [-0.5226, 0.5226]\n  From https://en.wikipedia.org/wiki/YIQ\nuse: rgb2yiq(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_RGB2YIQ\n#define FNC_RGB2YIQ\n// https://en.wikipedia.org/wiki/YIQ\nconst mat3 rgb2yiq_mat = mat3(\n    .299,  .596,  .211,\n    .587, -.274, -.523,\n    .114, -.322,  .0312\n);\n\nvec3 rgb2yiq(in vec3 rgb) {\n    return rgb2yiq_mat * rgb;\n}\n\nvec4 rgb2yiq(in vec4 rgb) {\n    return vec4(rgb2yiq(rgb.rgb), rgb.a);\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: pass a color in YIQ and get RGB color. From https://en.wikipedia.org/wiki/YIQ\nuse: yiq2rgb(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_YIQ2RGB\n#define FNC_YIQ2RGB\n\nconst mat3 yiq2rgb_mat = mat3(\n    1.,     1.,     1.,\n    .956,  -.272, -1.106,\n    .621,  -.647,  1.703\n);\n\nvec3 yiq2rgb(in vec3 yiq) {\n    return yiq2rgb_mat * yiq;\n}\n\nvec4 yiq2rgb(in vec4 yiq) {\n    return vec4(yiq2rgb(yiq.rgb), yiq.a);\n}\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: convert RGB to YCbCr according to https://en.wikipedia.org/wiki/YCbCr\nuse: rgb2YCbCr(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_RGB2YCBCR\n#define FNC_RGB2YCBCR\nvec3 rgb2YCbCr(in vec3 rgb){\n    float y = dot(rgb, vec3(.299, .587, .114));\n    float cb = .5 + dot(rgb, vec3(-.168736, -.331264, .5));\n    float cr = .5 + dot(rgb, vec3(.5, -.418688, -.081312));\n    return vec3(y, cb, cr);\n}\n\nvec4 rgb2YCbCr(in vec4 rgb) {\n    return vec4(rgb2YCbCr(rgb.rgb),rgb.a);\n}\n#endif\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: convert YCbCr to RGB according to https://en.wikipedia.org/wiki/YCbCr\nuse: YCbCr2rgb(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_YCBCR2RGB\n#define FNC_YCBCR2RGB\nvec3 YCbCr2rgb(in vec3 ycbcr) {\n    float cb = ycbcr.y - .5;\n    float cr = ycbcr.z - .5;\n    float y = ycbcr.x;\n    float r = 1.402 * cr;\n    float g = -.344 * cb - .714 * cr;\n    float b = 1.772 * cb;\n    return vec3(r, g, b) + y;\n}\n\nvec4 YCbCr2rgb(in vec4 ycbcr) {\n    return vec4(YCbCr2rgb(ycbcr.rgb),ycbcr.a);\n}\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: pass a color in RGB and get it in YPbPr from http://www.equasys.de/colorconversion.html\nuse: rgb2YPbPr(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_RGB2YPBPR\n#define FNC_RGB2YPBPR\n\n#ifdef YPBPR_SDTV\nconst mat3 rgb2YPbPr_mat = mat3( \n    .299, -.169,  .5,\n    .587, -.331, -.419,\n    .114,  .5,   -.081\n);\n#else\nconst mat3 rgb2YPbPr_mat = mat3( \n    0.2126, -0.1145721060573399,   0.5,\n    0.7152, -0.3854278939426601,  -0.4541529083058166,\n    0.0722,  0.5,                 -0.0458470916941834\n);\n#endif\n\nvec3 rgb2YPbPr(in vec3 rgb) {\n    return rgb2YPbPr_mat * rgb;\n}\n\nvec4 rgb2YPbPr(in vec4 rgb) {\n    return vec4(rgb2YPbPr(rgb.rgb),rgb.a);\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: pass a color in RGB and get it in YPbPr from http://www.equasys.de/colorconversion.html\nuse: YPbPr2RGB(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_YPBPR2RGB\n#define FNC_YPBPR2RGB\n\n#ifdef YPBPR_SDTV\nconst mat3 YPbPr2rgb_mat = mat3( \n    1.,     1.,       1.,\n    0.,     -.344,    1.772,\n    1.402,  -.714,    0.\n);\n#else\nconst mat3 YPbPr2rgb_mat = mat3( \n    1.,     1.,       1.,\n    0.,     -.187,    1.856,\n    1.575,  -.468,    0.\n);\n#endif\n\nvec3 YPbPr2rgb(in vec3 rgb) {\n    return YPbPr2rgb_mat * rgb;\n}\n\nvec4 YPbPr2rgb(in vec4 rgb) {\n    return vec4(YPbPr2rgb(rgb.rgb),rgb.a);\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: convert from linear to gamma color space.\nuse: linear2gamma(<float|vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#if !defined(TARGET_MOBILE) && !defined(GAMMA)\n#define GAMMA 2.2\n#endif\n\n#ifndef FNC_LINEAR2GAMMA\n#define FNC_LINEAR2GAMMA\nvec3 linear2gamma(in vec3 v) {\n#ifdef GAMMA\n    return pow(v, vec3(1. / GAMMA));\n#else\n    // assume gamma 2.0\n    return sqrt(v);\n#endif\n}\n\nvec4 linear2gamma(in vec4 v) {\n    return vec4(linear2gamma(v.rgb), v.a);\n}\n\nfloat linear2gamma(in float v) {\n#ifdef GAMMA\n    return pow(v, 1. / GAMMA);\n#else\n    // assume gamma 2.0\n    return sqrt(v);\n#endif\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: convert from gamma to linear color space.\nuse: gamma2linear(<float|vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#if !defined(TARGET_MOBILE) && !defined(GAMMA)\n#define GAMMA 2.2\n#endif\n\n#ifndef FNC_GAMMA2LINEAR\n#define FNC_GAMMA2LINEAR\nfloat gamma2linear(in float v) {\n#ifdef GAMMA\n    return pow(v, GAMMA);\n#else\n    // assume gamma 2.0\n    return v * v;\n#endif\n}\n\nvec3 gamma2linear(in vec3 v) {\n#ifdef GAMMA\n    return pow(v, vec3(GAMMA));\n#else\n    // assume gamma 2.0\n    return v * v;\n#endif\n}\n\nvec4 gamma2linear(in vec4 v) {\n    return vec4(gamma2linear(v.rgb), v.a);\n}\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: extend GLSL min function to add more arguments\nuse: \n  - min(<float> A, <float> B, <float> C[, <float> D])\n  - min(<vec2|vec3|vec4> A)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_MIN\n#define FNC_MIN\nfloat min(in float a, in float b, in float c) {\n  return min(a, min(b, c));\n}\n\nfloat min(in float a, in float b, in float c, in float d) {\n  return min(min(a,b), min(c, d));\n}\n\nfloat min(const vec2 v) {\n    return min(v.x, v.y);\n}\n\nfloat min(const vec3 v) {\n    return min(v.x, v.y, v.z);\n}\n\nfloat min(const vec4 v) {\n    return min(v.x, v.y, v.z, v.w);\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: clamp a value between 0 and 1\nuse: saturation(<float|vec2|vec3|vec4> value)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_SATURATE\n#define FNC_SATURATE\n// #define saturate(x) clamp(x, 0.0, 1.0)\nfloat saturate( float x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec2 saturate( vec2 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec3 saturate( vec3 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec4 saturate( vec4 x) {\n    return clamp(x, 0.0, 1.0);\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: convert CMYK to RGB\nuse: rgb2cmyk(<vec3|vec4> rgba)\nlicense: |\n  Copyright (c) 2021 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_RGB2CMYK\n#define FNC_RGB2CMYK\nvec4 rgb2cmyk(vec3 rgb) {\n    float k = min(1.0 - rgb);\n    float invK = 1.0 - k;\n    vec3 cmy = (1.0 - rgb - k) / invK;\n    cmy *= step(0.0, invK);\n    return saturate(vec4(cmy, k));\n}\n#endif\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: clamp a value between 0 and 1\nuse: saturation(<float|vec2|vec3|vec4> value)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_SATURATE\n#define FNC_SATURATE\n// #define saturate(x) clamp(x, 0.0, 1.0)\nfloat saturate( float x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec2 saturate( vec2 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec3 saturate( vec3 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec4 saturate( vec4 x) {\n    return clamp(x, 0.0, 1.0);\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: convert CMYK to RGB\nuse: cmyk2rgb(<vec4> cmyk)\nlicense: |\n  Copyright (c) 2021 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_CMYK2RGB\n#define FNC_CMYK2RGB\nvec3 cmyk2rgb(vec4 cmyk) {\n    float invK = 1.0 - cmyk.w;\n    return saturate(1.0-min(vec3(1.0), cmyk.xyz * invK + cmyk.w));\n}\n#endif\n'},9872:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: convert YCbCr to RGB according to https://en.wikipedia.org/wiki/YCbCr\nuse: YCbCr2rgb(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_YCBCR2RGB\n#define FNC_YCBCR2RGB\nvec3 YCbCr2rgb(in vec3 ycbcr) {\n    float cb = ycbcr.y - .5;\n    float cr = ycbcr.z - .5;\n    float y = ycbcr.x;\n    float r = 1.402 * cr;\n    float g = -.344 * cb - .714 * cr;\n    float b = 1.772 * cb;\n    return vec3(r, g, b) + y;\n}\n\nvec4 YCbCr2rgb(in vec4 ycbcr) {\n    return vec4(YCbCr2rgb(ycbcr.rgb),ycbcr.a);\n}\n#endif\n'},338:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: pass a color in RGB and get it in YPbPr from http://www.equasys.de/colorconversion.html\nuse: YPbPr2RGB(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_YPBPR2RGB\n#define FNC_YPBPR2RGB\n\n#ifdef YPBPR_SDTV\nconst mat3 YPbPr2rgb_mat = mat3( \n    1.,     1.,       1.,\n    0.,     -.344,    1.772,\n    1.402,  -.714,    0.\n);\n#else\nconst mat3 YPbPr2rgb_mat = mat3( \n    1.,     1.,       1.,\n    0.,     -.187,    1.856,\n    1.575,  -.468,    0.\n);\n#endif\n\nvec3 YPbPr2rgb(in vec3 rgb) {\n    return YPbPr2rgb_mat * rgb;\n}\n\nvec4 YPbPr2rgb(in vec4 rgb) {\n    return vec4(YPbPr2rgb(rgb.rgb),rgb.a);\n}\n#endif'},3701:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: convert from gamma to linear color space.\nuse: gamma2linear(<float|vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#if !defined(TARGET_MOBILE) && !defined(GAMMA)\n#define GAMMA 2.2\n#endif\n\n#ifndef FNC_GAMMA2LINEAR\n#define FNC_GAMMA2LINEAR\nfloat gamma2linear(in float v) {\n#ifdef GAMMA\n    return pow(v, GAMMA);\n#else\n    // assume gamma 2.0\n    return v * v;\n#endif\n}\n\nvec3 gamma2linear(in vec3 v) {\n#ifdef GAMMA\n    return pow(v, vec3(GAMMA));\n#else\n    // assume gamma 2.0\n    return v * v;\n#endif\n}\n\nvec4 gamma2linear(in vec4 v) {\n    return vec4(gamma2linear(v.rgb), v.a);\n}\n#endif\n'},9446:n=>{n.exports='/*\nauthor: Inigo Quiles\ndescription: pass a color in HSB and get RGB color. Also use as reference http://lolengine.net/blog/2013/07/27/rgb-to-hsv-in-glsl\nuse: hsv2rgb(<vec3|vec4> color)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_HSV2RGB\n#define FNC_HSV2RGB\nvec3 hsv2rgb(in vec3 hsb) {\n    vec3 rgb = clamp(abs(mod(hsb.x * 6. + vec3(0., 4., 2.), \n                            6.) - 3.) - 1.,\n                      0.,\n                      1.);\n    #ifdef HSV2RGB_SMOOTH\n    rgb = rgb*rgb*(3. - 2. * rgb);\n    #endif\n    return hsb.z * mix(vec3(1.), rgb, hsb.y);\n}\n\nvec4 hsv2rgb(in vec4 hsb) {\n    return vec4(hsv2rgb(hsb.rgb), hsb.a);\n}\n#endif'},9001:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: convert from linear to gamma color space.\nuse: linear2gamma(<float|vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#if !defined(TARGET_MOBILE) && !defined(GAMMA)\n#define GAMMA 2.2\n#endif\n\n#ifndef FNC_LINEAR2GAMMA\n#define FNC_LINEAR2GAMMA\nvec3 linear2gamma(in vec3 v) {\n#ifdef GAMMA\n    return pow(v, vec3(1. / GAMMA));\n#else\n    // assume gamma 2.0\n    return sqrt(v);\n#endif\n}\n\nvec4 linear2gamma(in vec4 v) {\n    return vec4(linear2gamma(v.rgb), v.a);\n}\n\nfloat linear2gamma(in float v) {\n#ifdef GAMMA\n    return pow(v, 1. / GAMMA);\n#else\n    // assume gamma 2.0\n    return sqrt(v);\n#endif\n}\n#endif\n'},9339:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: convert RGB to YCbCr according to https://en.wikipedia.org/wiki/YCbCr\nuse: rgb2YCbCr(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_RGB2YCBCR\n#define FNC_RGB2YCBCR\nvec3 rgb2YCbCr(in vec3 rgb){\n    float y = dot(rgb, vec3(.299, .587, .114));\n    float cb = .5 + dot(rgb, vec3(-.168736, -.331264, .5));\n    float cr = .5 + dot(rgb, vec3(.5, -.418688, -.081312));\n    return vec3(y, cb, cr);\n}\n\nvec4 rgb2YCbCr(in vec4 rgb) {\n    return vec4(rgb2YCbCr(rgb.rgb),rgb.a);\n}\n#endif'},6084:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: pass a color in RGB and get it in YPbPr from http://www.equasys.de/colorconversion.html\nuse: rgb2YPbPr(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_RGB2YPBPR\n#define FNC_RGB2YPBPR\n\n#ifdef YPBPR_SDTV\nconst mat3 rgb2YPbPr_mat = mat3( \n    .299, -.169,  .5,\n    .587, -.331, -.419,\n    .114,  .5,   -.081\n);\n#else\nconst mat3 rgb2YPbPr_mat = mat3( \n    0.2126, -0.1145721060573399,   0.5,\n    0.7152, -0.3854278939426601,  -0.4541529083058166,\n    0.0722,  0.5,                 -0.0458470916941834\n);\n#endif\n\nvec3 rgb2YPbPr(in vec3 rgb) {\n    return rgb2YPbPr_mat * rgb;\n}\n\nvec4 rgb2YPbPr(in vec4 rgb) {\n    return vec4(rgb2YPbPr(rgb.rgb),rgb.a);\n}\n#endif\n'},1725:n=>{n.exports="/*\nauthor: Sam Hocevar\ndescription: pass a color in RGB and get HSB color. From http://lolengine.net/blog/2013/07/27/rgb-to-hsv-in-glsl\nuse: rgb2hsv(<vec3|vec4> color)\nlicence: TODO\n*/\n\n#ifndef FNC_RGB2HSV\n#define FNC_RGB2HSV\nvec3 rgb2hsv(in vec3 c) {\n    vec4 K = vec4(0., -.33333333333333333333, .6666666666666666666, -1.);\n\n#ifdef RGB2HSV_MIX\n    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));\n    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));\n#else\n    vec4 p = c.g < c.b ? vec4(c.bg, K.wz) : vec4(c.gb, K.xy);\n    vec4 q = c.r < p.x ? vec4(p.xyw, c.r) : vec4(c.r, p.yzx);\n#endif\n\n    float d = q.x - min(q.w, q.y);\n    float e = 1.0e-10;\n    return vec3(abs(q.z + (q.w - q.y) / (6. * d + e)), \n                d / (q.x + e), \n                q.x);\n}\n\nvec4 rgb2hsv(in vec4 c) {\n    return vec4(rgb2hsv(c.rgb), c.a);\n}\n#endif"},3713:n=>{n.exports='/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: get\'s the luminosity of a color. From https://github.com/hughsk/glsl-luma/blob/master/index.glsl\nuse: rgb2luma(<vec3|vec4> color)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_RGB2LUMA\n#define FNC_RGB2LUMA\nfloat rgb2luma(in vec3 color) {\n    return dot(color, vec3(0.299, 0.587, 0.114));\n}\n\nfloat rgb2luma(in vec4 color) {\n    return rgb2luma(color.rgb);\n}\n#endif\n'},304:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: |\n  Convert from RGB to YIQ which was the followin range\n  Y [0,.1], I [-0.5957, 0.5957], Q [-0.5226, 0.5226]\n  From https://en.wikipedia.org/wiki/YIQ\nuse: rgb2yiq(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_RGB2YIQ\n#define FNC_RGB2YIQ\n// https://en.wikipedia.org/wiki/YIQ\nconst mat3 rgb2yiq_mat = mat3(\n    .299,  .596,  .211,\n    .587, -.274, -.523,\n    .114, -.322,  .0312\n);\n\nvec3 rgb2yiq(in vec3 rgb) {\n    return rgb2yiq_mat * rgb;\n}\n\nvec4 rgb2yiq(in vec4 rgb) {\n    return vec4(rgb2yiq(rgb.rgb), rgb.a);\n}\n#endif\n'},7885:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: pass a color in RGB and get it in YUB\nuse: rgb2yuv(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_RGB2YUV\n#define FNC_RGB2YUV\n\n#ifdef YUV_SDTV\nconst mat3 rgb2yuv_mat = mat3(\n    .299, -.14713,  .615,\n    .587, -.28886, -.51499,\n    .114,  .436,   -.10001\n);\n#else\nconst mat3 rgb2yuv_mat = mat3(\n    .2126,  -.09991, .615,\n    .7152,  -.33609,-.55861,\n    .0722,   .426,  -.05639\n);\n#endif\n\nvec3 rgb2yuv(in vec3 rgb) {\n    return rgb2yuv_mat * rgb;\n}\n\nvec4 rgb2yuv(in vec4 rgb) {\n    return vec4(rgb2yuv(rgb.rgb),rgb.a);\n}\n#endif\n'},157:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: pass a color in YIQ and get RGB color. From https://en.wikipedia.org/wiki/YIQ\nuse: yiq2rgb(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_YIQ2RGB\n#define FNC_YIQ2RGB\n\nconst mat3 yiq2rgb_mat = mat3(\n    1.,     1.,     1.,\n    .956,  -.272, -1.106,\n    .621,  -.647,  1.703\n);\n\nvec3 yiq2rgb(in vec3 yiq) {\n    return yiq2rgb_mat * yiq;\n}\n\nvec4 yiq2rgb(in vec4 yiq) {\n    return vec4(yiq2rgb(yiq.rgb), yiq.a);\n}\n#endif\n'},9323:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: pass a color in YUB and get RGB color\nuse: yuv2rgb(<vec3|vec4> color)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_YUV2RGB\n#define FNC_YUV2RGB\n\n#ifdef YUV_SDTV\nconst mat3 yuv2rgb_mat = mat3(\n    1.,       1. ,      1.,\n    0.,       -.39465,  2.03211,\n    1.13983,  -.58060,  0.\n);\n#else\nconst mat3 yuv2rgb_mat = mat3(\n    1.,       1. ,      1.,\n    0.,       -.21482,  2.12798,\n    1.28033,  -.38059,  0.\n);\n#endif\n\nvec3 yuv2rgb(in vec3 yuv) {\n    return yuv2rgb_mat * yuv;\n}\n\nvec4 yuv2rgb(in vec4 yuv) {\n    return vec4(yuv2rgb(yuv.rgb), yuv.a);\n}\n#endif\n'}},e={};function o(t){var i=e[t];if(void 0!==i)return i.exports;var a=e[t]={exports:{}};return n[t](a,a.exports,o),a.exports}o.n=n=>{var e=n&&n.__esModule?()=>n.default:()=>n;return o.d(e,{a:e}),e},o.d=(n,e)=>{for(var t in e)o.o(e,t)&&!o.o(n,t)&&Object.defineProperty(n,t,{enumerable:!0,get:e[t]})},o.o=(n,e)=>Object.prototype.hasOwnProperty.call(n,e);var t={};(()=>{o.d(t,{Z:()=>kn});var n=o(976),e=o.n(n),i=o(4440),a=o.n(i),r=o(6444),l=o.n(r),s=o(9220),d=o.n(s),c=o(2078),b=o.n(c),f=o(2527),h=o.n(f),O=o(823),T=o.n(O),E=o(8186),N=o.n(E),R=o(9556),I=o.n(R),p=o(613),u=o.n(p),v=o(9976),m=o.n(v),A=o(2542),g=o.n(A),S=o(9378),L=o.n(S),C=o(2021),D=o.n(C),H=o(4681),y=o.n(H),F=o(8622),w=o.n(F),P=o(5232),B=o.n(P),G=o(1135),M=o.n(G),U=o(313),Y=o.n(U),W=o(4951),_=o.n(W),x=o(1221),V=o.n(x),z=o(4925),k=o.n(z),q=o(2435),K=o.n(q),J=o(9600),X=o.n(J),j=o(971),Q=o.n(j);const Z={add:a(),colorDodge:l(),exclusion:d(),hardMix:b(),linearDodge:h(),negation:T(),pinLight:N(),softLight:I(),average:u(),darken:m(),glow:g(),lighten:L(),linearLight:D(),overlay:y(),reflect:w(),subtract:B(),colorBurn:M(),difference:Y(),hardLight:_(),linearBurn:V(),multiply:k(),phoenix:K(),screen:X(),vividLight:Q()};var $=o(1663),nn=o.n($),en=o(7427),on=o.n(en),tn=o(4141),an=o.n(tn),rn=o(8980),ln=o.n(rn),sn=o(2743),dn=o.n(sn),cn=o(2799),bn=o.n(cn),fn=o(177),hn=o.n(fn),On=o(8063),Tn=o.n(On),En=o(82),Nn=o.n(En),Rn=o(9872),In=o.n(Rn),pn=o(3701),un=o.n(pn),vn=o(9001),mn=o.n(vn),An=o(6084),gn=o.n(An),Sn=o(3713),Ln=o.n(Sn),Cn=o(7885),Dn=o.n(Cn),Hn=o(9323),yn=o.n(Hn),Fn=o(338),wn=o.n(Fn),Pn=o(9446),Bn=o.n(Pn),Gn=o(9339),Mn=o.n(Gn),Un=o(1725),Yn=o.n(Un),Wn=o(304),_n=o.n(Wn),xn=o(157),Vn=o.n(xn);const zn={YCbCr2rgb:In(),gamma2linear:un(),linear2gamma:mn(),rgb2YPbPr:gn(),rgb2luma:Ln(),rgb2yuv:Dn(),yuv2rgb:yn(),YPbPr2rgb:wn(),hsv2rgb:Bn(),rgb2YCbCr:Mn(),rgb2hsv:Yn(),rgb2yiq:_n(),yiq2rgb:Vn()},kn={blend:Object.assign(e(),Z),contrastMatrix:nn(),hueShift:on(),lut:an(),saturationMatrix:ln(),brightnessMatrix:dn(),desaturate:bn(),luma:hn(),palette:Tn(),space:Object.assign(Nn(),zn)}})();var i=t.Z;export{i as default};