var e={1595:e=>{e.exports='/*\nauthor: Matt DesLauriers\ndescription: Performs a smoothstep using standard derivatives for anti-aliased edges at any level of magnification. From https://github.com/glslify/glsl-aastep\nuse: aastep(<float> threshold, <float> value)\noption:\n    AA_EDGE: in the absence of derivatives you can specify the antialiasing factor\nlicense: |\n    The MIT License (MIT) Copyright (c) 2015 stackgl\n    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_AASTEP\n#define FNC_AASTEP\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n#endif\n\nfloat aastep(float threshold, float value) {\n    #ifdef GL_OES_standard_derivatives\n    float afwidth = 0.7 * length(vec2(dFdx(value), dFdy(value)));\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #elif defined(AA_EDGE)\n    float afwidth = AA_EDGE;\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #else \n    return step(threshold, value);\n    #endif\n}\n#endif'},9797:e=>{e.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: fill a stroke in a SDF. From PixelSpiritDeck https://github.com/patriciogonzalezvivo/PixelSpiritDeck\nuse: stroke(<float> sdf, <float> size, <float> width [, <float> edge])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_STROKE\n#define FNC_STROKE\n\n/*\nauthor: Matt DesLauriers\ndescription: Performs a smoothstep using standard derivatives for anti-aliased edges at any level of magnification. From https://github.com/glslify/glsl-aastep\nuse: aastep(<float> threshold, <float> value)\noption:\n    AA_EDGE: in the absence of derivatives you can specify the antialiasing factor\nlicense: |\n    The MIT License (MIT) Copyright (c) 2015 stackgl\n    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_AASTEP\n#define FNC_AASTEP\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n#endif\n\nfloat aastep(float threshold, float value) {\n    #ifdef GL_OES_standard_derivatives\n    float afwidth = 0.7 * length(vec2(dFdx(value), dFdy(value)));\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #elif defined(AA_EDGE)\n    float afwidth = AA_EDGE;\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #else \n    return step(threshold, value);\n    #endif\n}\n#endif\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: clamp a value between 0 and 1\nuse: saturation(<float|vec2|vec3|vec4> value)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_SATURATE\n#define FNC_SATURATE\n// #define saturate(x) clamp(x, 0.0, 1.0)\nfloat saturate( float x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec2 saturate( vec2 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec3 saturate( vec3 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec4 saturate( vec4 x) {\n    return clamp(x, 0.0, 1.0);\n}\n#endif\n\nfloat stroke(float x, float size, float w) {\n    float d = aastep(size, x + w * 0.5) - aastep(size, x - w * 0.5);\n    return saturate(d);\n}\n\nfloat stroke(float x, float size, float w, float edge) {\n    float d = smoothstep(size - edge, size + edge, x + w * 0.5) - smoothstep(size - edge, size + edge, x - w * 0.5);\n    return saturate(d);\n}\n\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: create a bridge on a given in_value and draw a stroke inside that gap\nuse: bridge(<float|vec2|vec3|vec4> in_value, <float> sdf, <float> size, <float> width)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_BRIDGE\n#define FNC_BRIDGE\nfloat bridge(float c, float d, float s, float w) {\n    c *= 1.0 - stroke(d, s , w * 2.0);\n    return c + stroke(d, s, w);\n}\n\nvec2 bridge(vec2 c, float d, float s, float w) {\n    c *= 1.0 - stroke(d, s , w * 2.0);\n    return c + stroke(d, s, w);\n}\n\nvec3 bridge(vec3 c, float d, float s, float w) {\n    c *= 1.0 - stroke(d, s , w * 2.0);\n    return c + stroke(d, s, w);\n}\n\nvec4 bridge(vec4 c, float d, float s, float w) {\n    c *= 1.0 - stroke(d, s , w * 2.0);\n    return c + stroke(d, s, w);\n}\n\n#endif'},4525:e=>{e.exports='\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: Returns a circle-shaped SDF.\nuse: circleSDF(vec2 st[, vec2 center])\noptions:\n  CIRCLESDF_FNC(POS_UV) : function used to calculate the SDF, defaults to GLSL length function, use lengthSq for a different slope\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef CIRCLESDF_FNC\n#define CIRCLESDF_FNC(POS_UV) length(POS_UV)\n#endif\n\n#ifndef FNC_CIRCLESDF\n#define FNC_CIRCLESDF\n\nfloat circleSDF(in vec2 st, in vec2 center) {\n    return CIRCLESDF_FNC(st - center) * 2.;\n}\n\nfloat circleSDF(in vec2 st) {\n    return circleSDF(st, vec2(.5));\n}\n\n#endif\n\n\n/*\nauthor: Matt DesLauriers\ndescription: Performs a smoothstep using standard derivatives for anti-aliased edges at any level of magnification. From https://github.com/glslify/glsl-aastep\nuse: aastep(<float> threshold, <float> value)\noption:\n    AA_EDGE: in the absence of derivatives you can specify the antialiasing factor\nlicense: |\n    The MIT License (MIT) Copyright (c) 2015 stackgl\n    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_AASTEP\n#define FNC_AASTEP\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n#endif\n\nfloat aastep(float threshold, float value) {\n    #ifdef GL_OES_standard_derivatives\n    float afwidth = 0.7 * length(vec2(dFdx(value), dFdy(value)));\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #elif defined(AA_EDGE)\n    float afwidth = AA_EDGE;\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #else \n    return step(threshold, value);\n    #endif\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: fill a SDF. From PixelSpiritDeck https://github.com/patriciogonzalezvivo/PixelSpiritDeck\nuse: fill(<float> sdf, <float> size [, <float> edge])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_FILL\n#define FNC_FILL\nfloat fill(float x, float size, float edge) {\n    return 1.0 - smoothstep(size - edge, size + edge, x);\n}\n\nfloat fill(float x, float size) {\n    return 1.0 - aastep(size, x);\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: fill a stroke in a SDF. From PixelSpiritDeck https://github.com/patriciogonzalezvivo/PixelSpiritDeck\nuse: stroke(<float> sdf, <float> size, <float> width [, <float> edge])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_STROKE\n#define FNC_STROKE\n\n/*\nauthor: Matt DesLauriers\ndescription: Performs a smoothstep using standard derivatives for anti-aliased edges at any level of magnification. From https://github.com/glslify/glsl-aastep\nuse: aastep(<float> threshold, <float> value)\noption:\n    AA_EDGE: in the absence of derivatives you can specify the antialiasing factor\nlicense: |\n    The MIT License (MIT) Copyright (c) 2015 stackgl\n    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_AASTEP\n#define FNC_AASTEP\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n#endif\n\nfloat aastep(float threshold, float value) {\n    #ifdef GL_OES_standard_derivatives\n    float afwidth = 0.7 * length(vec2(dFdx(value), dFdy(value)));\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #elif defined(AA_EDGE)\n    float afwidth = AA_EDGE;\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #else \n    return step(threshold, value);\n    #endif\n}\n#endif\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: clamp a value between 0 and 1\nuse: saturation(<float|vec2|vec3|vec4> value)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_SATURATE\n#define FNC_SATURATE\n// #define saturate(x) clamp(x, 0.0, 1.0)\nfloat saturate( float x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec2 saturate( vec2 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec3 saturate( vec3 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec4 saturate( vec4 x) {\n    return clamp(x, 0.0, 1.0);\n}\n#endif\n\nfloat stroke(float x, float size, float w) {\n    float d = aastep(size, x + w * 0.5) - aastep(size, x - w * 0.5);\n    return saturate(d);\n}\n\nfloat stroke(float x, float size, float w, float edge) {\n    float d = smoothstep(size - edge, size + edge, x + w * 0.5) - smoothstep(size - edge, size + edge, x - w * 0.5);\n    return saturate(d);\n}\n\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: draw a circle filled or not. \nuse: circle(<vec2> st, <float> size [, <float> width])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_CIRCLE\n#define FNC_CIRCLE\nfloat circle(vec2 st, float size) {\n    return fill(circleSDF(st), size);\n}\n\nfloat circle(vec2 st, float size, float strokeWidth) {\n    return stroke(circleSDF(st), size, strokeWidth);\n}\n#endif'},2788:e=>{e.exports='\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: Returns a rectangular SDF\nuse: rectSDF(<vec2> st, <vec2> size)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_RECTSDF\n#define FNC_RECTSDF\nfloat rectSDF(in vec2 st, in vec2 s) {\n    st = st * 2. - 1.;\n    return max( abs(st.x / s.x),\n                abs(st.y / s.y) );\n}\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: Returns a cross-shaped SDF\nuse: crossSDF(<vec2> st, size s)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_CROSSSDF\n#define FNC_CROSSSDF\nfloat crossSDF(in vec2 st, in float s) {\n    vec2 size = vec2(.25, s);\n    return min(rectSDF(st.xy, size.xy),\n               rectSDF(st.xy, size.yx));\n}\n#endif\n\n\n/*\nauthor: Matt DesLauriers\ndescription: Performs a smoothstep using standard derivatives for anti-aliased edges at any level of magnification. From https://github.com/glslify/glsl-aastep\nuse: aastep(<float> threshold, <float> value)\noption:\n    AA_EDGE: in the absence of derivatives you can specify the antialiasing factor\nlicense: |\n    The MIT License (MIT) Copyright (c) 2015 stackgl\n    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_AASTEP\n#define FNC_AASTEP\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n#endif\n\nfloat aastep(float threshold, float value) {\n    #ifdef GL_OES_standard_derivatives\n    float afwidth = 0.7 * length(vec2(dFdx(value), dFdy(value)));\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #elif defined(AA_EDGE)\n    float afwidth = AA_EDGE;\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #else \n    return step(threshold, value);\n    #endif\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: fill a SDF. From PixelSpiritDeck https://github.com/patriciogonzalezvivo/PixelSpiritDeck\nuse: fill(<float> sdf, <float> size [, <float> edge])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_FILL\n#define FNC_FILL\nfloat fill(float x, float size, float edge) {\n    return 1.0 - smoothstep(size - edge, size + edge, x);\n}\n\nfloat fill(float x, float size) {\n    return 1.0 - aastep(size, x);\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: fill a stroke in a SDF. From PixelSpiritDeck https://github.com/patriciogonzalezvivo/PixelSpiritDeck\nuse: stroke(<float> sdf, <float> size, <float> width [, <float> edge])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_STROKE\n#define FNC_STROKE\n\n/*\nauthor: Matt DesLauriers\ndescription: Performs a smoothstep using standard derivatives for anti-aliased edges at any level of magnification. From https://github.com/glslify/glsl-aastep\nuse: aastep(<float> threshold, <float> value)\noption:\n    AA_EDGE: in the absence of derivatives you can specify the antialiasing factor\nlicense: |\n    The MIT License (MIT) Copyright (c) 2015 stackgl\n    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_AASTEP\n#define FNC_AASTEP\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n#endif\n\nfloat aastep(float threshold, float value) {\n    #ifdef GL_OES_standard_derivatives\n    float afwidth = 0.7 * length(vec2(dFdx(value), dFdy(value)));\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #elif defined(AA_EDGE)\n    float afwidth = AA_EDGE;\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #else \n    return step(threshold, value);\n    #endif\n}\n#endif\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: clamp a value between 0 and 1\nuse: saturation(<float|vec2|vec3|vec4> value)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_SATURATE\n#define FNC_SATURATE\n// #define saturate(x) clamp(x, 0.0, 1.0)\nfloat saturate( float x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec2 saturate( vec2 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec3 saturate( vec3 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec4 saturate( vec4 x) {\n    return clamp(x, 0.0, 1.0);\n}\n#endif\n\nfloat stroke(float x, float size, float w) {\n    float d = aastep(size, x + w * 0.5) - aastep(size, x - w * 0.5);\n    return saturate(d);\n}\n\nfloat stroke(float x, float size, float w, float edge) {\n    float d = smoothstep(size - edge, size + edge, x + w * 0.5) - smoothstep(size - edge, size + edge, x - w * 0.5);\n    return saturate(d);\n}\n\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: draw a cross filled or not. \nuse: cross(<vec2> st, <float> size [, <float> width])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_CROSS\n#define FNC_CROSS\nfloat cross(vec2 st, float size) {\n    return fill(crossSDF(st, 1.), size);\n}\n\nfloat cross(vec2 st, float size, float strokeWidth) {\n    return stroke(crossSDF(st, 1.), size, strokeWidth);\n}\n#endif'},2823:e=>{e.exports="/*\nauthor: Patricio Gonzalez Vivo\ndescription: |\n  Draws all the digits of a floating point number, useful for debugging.\n  Requires high precision to work properly.\nuse: digits(<vec2> st, <float> value [, <float> nDecDigit])\noptions:\n  DIGITS_DECIMALS: number of decimals after the point, defaults to 2\n  DIGITS_SIZE: size of the font, defaults to vec2(.025)\n*/\n\n#ifndef DIGITS_SIZE\n#define DIGITS_SIZE vec2(.025)\n#endif\n\n#ifndef DIGITS_DECIMALS\n#define DIGITS_DECIMALS 2.0\n#endif\n\n#ifndef FNC_DIGITS\n#define FNC_DIGITS\nfloat digits(in vec2 st, in float value, in float nDecDigit) {\n    st /= DIGITS_SIZE;\n\n    float absValue = abs(value);\n    float biggestDigitIndex = max(floor(log2(absValue) / log2(10.)), 0.);\n\n    float counter = floor(value);\n    float nIntDigits = 0.;\n    for (int i = 0; i < 9; i++) {\n        counter = floor(counter*.1);\n        nIntDigits++;\n        if (counter == 0.)\n            break;\n    }\n    float digit = 12.;\n    float digitIndex = (nIntDigits-1.) - floor(st.x);\n    if (digitIndex > (-nDecDigit - 1.5)) {\n        if (digitIndex > biggestDigitIndex) {\n            if (value < 0.) {\n                if (digitIndex < (biggestDigitIndex+1.5)) {\n                    digit = 11.;\n                }\n            }\n        } \n        else {\n            if (digitIndex == -1.) {\n                if (nDecDigit > 0.) {\n                    digit = 10.;\n                }\n            } \n            else {\n                if (digitIndex < 0.) {\n                    digitIndex += 1.;\n                }\n                float digitValue = (absValue / (pow(10., digitIndex)));\n                digit = mod(floor(0.0001+digitValue), 10.);\n            }\n        }\n    }\n    vec2 pos = vec2(fract(st.x), st.y);\n\n    if (pos.x < 0.) return 0.;\n    if (pos.y < 0.) return 0.;\n    if (pos.x >= 1.) return 0.;\n    if (pos.y >= 1.) return 0.;\n\n    // make a 4x5 array of bits\n    float bin = 0.;\n    if (digit < 0.5) // 0\n        bin = 7. + 5. * 16. + 5. * 256. + 5. * 4096. + 7. * 65536.; \n    else if (digit < 1.5) // 1\n        bin = 2. + 2. * 16. + 2. * 256. + 2. * 4096. + 2. * 65536.;\n    else if (digit < 2.5) // 2\n        bin = 7. + 1. * 16. + 7. * 256. + 4. * 4096. + 7. * 65536.;\n    else if (digit < 3.5) // 3\n        bin = 7. + 4. * 16. + 7. * 256. + 4. * 4096. + 7. * 65536.;\n    else if (digit < 4.5) // 4\n        bin = 4. + 7. * 16. + 5. * 256. + 1. * 4096. + 1. * 65536.;\n    else if (digit < 5.5) // 5\n        bin = 7. + 4. * 16. + 7. * 256. + 1. * 4096. + 7. * 65536.;\n    else if (digit < 6.5) // 6\n        bin = 7. + 5. * 16. + 7. * 256. + 1. * 4096. + 7. * 65536.;\n    else if (digit < 7.5) // 7\n        bin = 4. + 4. * 16. + 4. * 256. + 4. * 4096. + 7. * 65536.;\n    else if (digit < 8.5) // 8\n        bin = 7. + 5. * 16. + 7. * 256. + 5. * 4096. + 7. * 65536.;\n    else if (digit < 9.5) // 9\n        bin = 7. + 4. * 16. + 7. * 256. + 5. * 4096. + 7. * 65536.;\n    else if (digit < 10.5) // '.'\n        bin = 2. + 0. * 16. + 0. * 256. + 0. * 4096. + 0. * 65536.;\n    else if (digit < 11.5) // '-'\n        bin = 0. + 0. * 16. + 7. * 256. + 0. * 4096. + 0. * 65536.;\n\n    vec2 pixel = floor(pos * vec2(4., 5.));\n    return mod(floor(bin / pow(2., (pixel.x + (pixel.y * 4.)))), 2.);\n}\n\nfloat digits(in vec2 st, in float value, in float nDecDigit, in float nIntDigits) {\n    vec2 st2 = st;\n    float result = 0.0;\n    for (float i = nIntDigits - 1.0; i > 0. ; --i) {\n        if (value < i * 10.) {\n            result += digits(st2, 0.0, nDecDigit);\n            st2.x -= DIGITS_SIZE.x;\n        }\n    }\n    result += digits(st2, value, nDecDigit);\n    return result; \n}\n\nfloat digits(in vec2 st, in float value) {\n    return digits(st, value, (DIGITS_DECIMALS));\n}\n#endif\n"},5991:e=>{e.exports='/*\nauthor: Matt DesLauriers\ndescription: Performs a smoothstep using standard derivatives for anti-aliased edges at any level of magnification. From https://github.com/glslify/glsl-aastep\nuse: aastep(<float> threshold, <float> value)\noption:\n    AA_EDGE: in the absence of derivatives you can specify the antialiasing factor\nlicense: |\n    The MIT License (MIT) Copyright (c) 2015 stackgl\n    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_AASTEP\n#define FNC_AASTEP\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n#endif\n\nfloat aastep(float threshold, float value) {\n    #ifdef GL_OES_standard_derivatives\n    float afwidth = 0.7 * length(vec2(dFdx(value), dFdy(value)));\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #elif defined(AA_EDGE)\n    float afwidth = AA_EDGE;\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #else \n    return step(threshold, value);\n    #endif\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: fill a SDF. From PixelSpiritDeck https://github.com/patriciogonzalezvivo/PixelSpiritDeck\nuse: fill(<float> sdf, <float> size [, <float> edge])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_FILL\n#define FNC_FILL\nfloat fill(float x, float size, float edge) {\n    return 1.0 - smoothstep(size - edge, size + edge, x);\n}\n\nfloat fill(float x, float size) {\n    return 1.0 - aastep(size, x);\n}\n#endif\n'},6141:e=>{e.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: Flips the float passed in, 0 becomes 1 and 1 becomes 0\nuse: flip(<float> v, <float> pct)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_FLIP\n#define FNC_FLIP\nfloat flip(in float v, in float pct) {\n    return mix(v, 1. - v, pct);\n}\n#endif\n'},5651:e=>{e.exports='\n/*\\\nauthor: Patricio Gonzalez Vivo\ndescription: Returns a hexagon-shaped SDF\nuse: hexSDF(<vec2> st)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_HEXSDF\n#define FNC_HEXSDF\nfloat hexSDF(in vec2 st) {\n    st = abs(st * 2. - 1.);\n    return max(abs(st.y), st.x * .866025 + st.y * .5);\n}\n#endif\n\n\n/*\nauthor: Matt DesLauriers\ndescription: Performs a smoothstep using standard derivatives for anti-aliased edges at any level of magnification. From https://github.com/glslify/glsl-aastep\nuse: aastep(<float> threshold, <float> value)\noption:\n    AA_EDGE: in the absence of derivatives you can specify the antialiasing factor\nlicense: |\n    The MIT License (MIT) Copyright (c) 2015 stackgl\n    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_AASTEP\n#define FNC_AASTEP\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n#endif\n\nfloat aastep(float threshold, float value) {\n    #ifdef GL_OES_standard_derivatives\n    float afwidth = 0.7 * length(vec2(dFdx(value), dFdy(value)));\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #elif defined(AA_EDGE)\n    float afwidth = AA_EDGE;\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #else \n    return step(threshold, value);\n    #endif\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: fill a SDF. From PixelSpiritDeck https://github.com/patriciogonzalezvivo/PixelSpiritDeck\nuse: fill(<float> sdf, <float> size [, <float> edge])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_FILL\n#define FNC_FILL\nfloat fill(float x, float size, float edge) {\n    return 1.0 - smoothstep(size - edge, size + edge, x);\n}\n\nfloat fill(float x, float size) {\n    return 1.0 - aastep(size, x);\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: fill a stroke in a SDF. From PixelSpiritDeck https://github.com/patriciogonzalezvivo/PixelSpiritDeck\nuse: stroke(<float> sdf, <float> size, <float> width [, <float> edge])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_STROKE\n#define FNC_STROKE\n\n/*\nauthor: Matt DesLauriers\ndescription: Performs a smoothstep using standard derivatives for anti-aliased edges at any level of magnification. From https://github.com/glslify/glsl-aastep\nuse: aastep(<float> threshold, <float> value)\noption:\n    AA_EDGE: in the absence of derivatives you can specify the antialiasing factor\nlicense: |\n    The MIT License (MIT) Copyright (c) 2015 stackgl\n    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_AASTEP\n#define FNC_AASTEP\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n#endif\n\nfloat aastep(float threshold, float value) {\n    #ifdef GL_OES_standard_derivatives\n    float afwidth = 0.7 * length(vec2(dFdx(value), dFdy(value)));\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #elif defined(AA_EDGE)\n    float afwidth = AA_EDGE;\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #else \n    return step(threshold, value);\n    #endif\n}\n#endif\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: clamp a value between 0 and 1\nuse: saturation(<float|vec2|vec3|vec4> value)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_SATURATE\n#define FNC_SATURATE\n// #define saturate(x) clamp(x, 0.0, 1.0)\nfloat saturate( float x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec2 saturate( vec2 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec3 saturate( vec3 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec4 saturate( vec4 x) {\n    return clamp(x, 0.0, 1.0);\n}\n#endif\n\nfloat stroke(float x, float size, float w) {\n    float d = aastep(size, x + w * 0.5) - aastep(size, x - w * 0.5);\n    return saturate(d);\n}\n\nfloat stroke(float x, float size, float w, float edge) {\n    float d = smoothstep(size - edge, size + edge, x + w * 0.5) - smoothstep(size - edge, size + edge, x - w * 0.5);\n    return saturate(d);\n}\n\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: draw a hexagon filled or not. \nuse: hex(<vec2> st, <float> size [, <float> width])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_HEX\n#define FNC_HEX\nfloat hex(vec2 st, float size) {\n    return fill(hexSDF(st), size);\n}\n\nfloat hex(vec2 st, float size, float strokeWidth) {\n    return stroke(hexSDF(st), size, strokeWidth);\n}\n#endif'},672:e=>{e.exports='\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: Returns a rectangular SDF\nuse: rectSDF(<vec2> st, <vec2> size)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_RECTSDF\n#define FNC_RECTSDF\nfloat rectSDF(in vec2 st, in vec2 s) {\n    st = st * 2. - 1.;\n    return max( abs(st.x / s.x),\n                abs(st.y / s.y) );\n}\n#endif\n\n\n/*\nauthor: Matt DesLauriers\ndescription: Performs a smoothstep using standard derivatives for anti-aliased edges at any level of magnification. From https://github.com/glslify/glsl-aastep\nuse: aastep(<float> threshold, <float> value)\noption:\n    AA_EDGE: in the absence of derivatives you can specify the antialiasing factor\nlicense: |\n    The MIT License (MIT) Copyright (c) 2015 stackgl\n    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_AASTEP\n#define FNC_AASTEP\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n#endif\n\nfloat aastep(float threshold, float value) {\n    #ifdef GL_OES_standard_derivatives\n    float afwidth = 0.7 * length(vec2(dFdx(value), dFdy(value)));\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #elif defined(AA_EDGE)\n    float afwidth = AA_EDGE;\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #else \n    return step(threshold, value);\n    #endif\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: fill a SDF. From PixelSpiritDeck https://github.com/patriciogonzalezvivo/PixelSpiritDeck\nuse: fill(<float> sdf, <float> size [, <float> edge])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_FILL\n#define FNC_FILL\nfloat fill(float x, float size, float edge) {\n    return 1.0 - smoothstep(size - edge, size + edge, x);\n}\n\nfloat fill(float x, float size) {\n    return 1.0 - aastep(size, x);\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: fill a stroke in a SDF. From PixelSpiritDeck https://github.com/patriciogonzalezvivo/PixelSpiritDeck\nuse: stroke(<float> sdf, <float> size, <float> width [, <float> edge])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_STROKE\n#define FNC_STROKE\n\n/*\nauthor: Matt DesLauriers\ndescription: Performs a smoothstep using standard derivatives for anti-aliased edges at any level of magnification. From https://github.com/glslify/glsl-aastep\nuse: aastep(<float> threshold, <float> value)\noption:\n    AA_EDGE: in the absence of derivatives you can specify the antialiasing factor\nlicense: |\n    The MIT License (MIT) Copyright (c) 2015 stackgl\n    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_AASTEP\n#define FNC_AASTEP\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n#endif\n\nfloat aastep(float threshold, float value) {\n    #ifdef GL_OES_standard_derivatives\n    float afwidth = 0.7 * length(vec2(dFdx(value), dFdy(value)));\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #elif defined(AA_EDGE)\n    float afwidth = AA_EDGE;\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #else \n    return step(threshold, value);\n    #endif\n}\n#endif\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: clamp a value between 0 and 1\nuse: saturation(<float|vec2|vec3|vec4> value)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_SATURATE\n#define FNC_SATURATE\n// #define saturate(x) clamp(x, 0.0, 1.0)\nfloat saturate( float x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec2 saturate( vec2 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec3 saturate( vec3 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec4 saturate( vec4 x) {\n    return clamp(x, 0.0, 1.0);\n}\n#endif\n\nfloat stroke(float x, float size, float w) {\n    float d = aastep(size, x + w * 0.5) - aastep(size, x - w * 0.5);\n    return saturate(d);\n}\n\nfloat stroke(float x, float size, float w, float edge) {\n    float d = smoothstep(size - edge, size + edge, x + w * 0.5) - smoothstep(size - edge, size + edge, x - w * 0.5);\n    return saturate(d);\n}\n\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: draw a rectangel filled or not. \nuse: rect(<vec2> st, <vec2> size [, <float> width])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_RECT\n#define FNC_RECT\nfloat rect(vec2 st, vec2 size) {\n    return fill(rectSDF(st, size), 1.0);\n}\n\nfloat rect(vec2 st, vec2 size, float strokeWidth) {\n    return stroke(rectSDF(st, size), 1.0, strokeWidth);\n}\n#endif'},7328:e=>{e.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: fill a stroke in a SDF. From PixelSpiritDeck https://github.com/patriciogonzalezvivo/PixelSpiritDeck\nuse: stroke(<float> sdf, <float> size, <float> width [, <float> edge])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_STROKE\n#define FNC_STROKE\n\n/*\nauthor: Matt DesLauriers\ndescription: Performs a smoothstep using standard derivatives for anti-aliased edges at any level of magnification. From https://github.com/glslify/glsl-aastep\nuse: aastep(<float> threshold, <float> value)\noption:\n    AA_EDGE: in the absence of derivatives you can specify the antialiasing factor\nlicense: |\n    The MIT License (MIT) Copyright (c) 2015 stackgl\n    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_AASTEP\n#define FNC_AASTEP\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n#endif\n\nfloat aastep(float threshold, float value) {\n    #ifdef GL_OES_standard_derivatives\n    float afwidth = 0.7 * length(vec2(dFdx(value), dFdy(value)));\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #elif defined(AA_EDGE)\n    float afwidth = AA_EDGE;\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #else \n    return step(threshold, value);\n    #endif\n}\n#endif\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: clamp a value between 0 and 1\nuse: saturation(<float|vec2|vec3|vec4> value)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_SATURATE\n#define FNC_SATURATE\n// #define saturate(x) clamp(x, 0.0, 1.0)\nfloat saturate( float x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec2 saturate( vec2 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec3 saturate( vec3 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec4 saturate( vec4 x) {\n    return clamp(x, 0.0, 1.0);\n}\n#endif\n\nfloat stroke(float x, float size, float w) {\n    float d = aastep(size, x + w * 0.5) - aastep(size, x - w * 0.5);\n    return saturate(d);\n}\n\nfloat stroke(float x, float size, float w, float edge) {\n    float d = smoothstep(size - edge, size + edge, x + w * 0.5) - smoothstep(size - edge, size + edge, x - w * 0.5);\n    return saturate(d);\n}\n\n#endif\n'},5080:e=>{e.exports='\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: Returns a triangle-shaped sdf\nuse: triSDF(<vec2> st)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_TRISDF\n#define FNC_TRISDF\nfloat triSDF(in vec2 st) {\n    st = (st * 2. - 1.) * 2.;\n    return max(abs(st.x) * .866025 + st.y * .5, -st.y * .5);\n}\n#endif\n\n\n/*\nauthor: Matt DesLauriers\ndescription: Performs a smoothstep using standard derivatives for anti-aliased edges at any level of magnification. From https://github.com/glslify/glsl-aastep\nuse: aastep(<float> threshold, <float> value)\noption:\n    AA_EDGE: in the absence of derivatives you can specify the antialiasing factor\nlicense: |\n    The MIT License (MIT) Copyright (c) 2015 stackgl\n    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_AASTEP\n#define FNC_AASTEP\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n#endif\n\nfloat aastep(float threshold, float value) {\n    #ifdef GL_OES_standard_derivatives\n    float afwidth = 0.7 * length(vec2(dFdx(value), dFdy(value)));\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #elif defined(AA_EDGE)\n    float afwidth = AA_EDGE;\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #else \n    return step(threshold, value);\n    #endif\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: fill a SDF. From PixelSpiritDeck https://github.com/patriciogonzalezvivo/PixelSpiritDeck\nuse: fill(<float> sdf, <float> size [, <float> edge])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_FILL\n#define FNC_FILL\nfloat fill(float x, float size, float edge) {\n    return 1.0 - smoothstep(size - edge, size + edge, x);\n}\n\nfloat fill(float x, float size) {\n    return 1.0 - aastep(size, x);\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: fill a stroke in a SDF. From PixelSpiritDeck https://github.com/patriciogonzalezvivo/PixelSpiritDeck\nuse: stroke(<float> sdf, <float> size, <float> width [, <float> edge])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo. All rights reserved.\n  Distributed under BSD 3-clause "New" or "Revised" License. See LICENSE file at\n  https://github.com/patriciogonzalezvivo/PixelSpiritDeck\n*/\n\n#ifndef FNC_STROKE\n#define FNC_STROKE\n\n/*\nauthor: Matt DesLauriers\ndescription: Performs a smoothstep using standard derivatives for anti-aliased edges at any level of magnification. From https://github.com/glslify/glsl-aastep\nuse: aastep(<float> threshold, <float> value)\noption:\n    AA_EDGE: in the absence of derivatives you can specify the antialiasing factor\nlicense: |\n    The MIT License (MIT) Copyright (c) 2015 stackgl\n    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_AASTEP\n#define FNC_AASTEP\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n#endif\n\nfloat aastep(float threshold, float value) {\n    #ifdef GL_OES_standard_derivatives\n    float afwidth = 0.7 * length(vec2(dFdx(value), dFdy(value)));\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #elif defined(AA_EDGE)\n    float afwidth = AA_EDGE;\n    return smoothstep(threshold-afwidth, threshold+afwidth, value);\n    #else \n    return step(threshold, value);\n    #endif\n}\n#endif\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: clamp a value between 0 and 1\nuse: saturation(<float|vec2|vec3|vec4> value)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_SATURATE\n#define FNC_SATURATE\n// #define saturate(x) clamp(x, 0.0, 1.0)\nfloat saturate( float x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec2 saturate( vec2 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec3 saturate( vec3 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec4 saturate( vec4 x) {\n    return clamp(x, 0.0, 1.0);\n}\n#endif\n\nfloat stroke(float x, float size, float w) {\n    float d = aastep(size, x + w * 0.5) - aastep(size, x - w * 0.5);\n    return saturate(d);\n}\n\nfloat stroke(float x, float size, float w, float edge) {\n    float d = smoothstep(size - edge, size + edge, x + w * 0.5) - smoothstep(size - edge, size + edge, x - w * 0.5);\n    return saturate(d);\n}\n\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: draw a triangle filled or not. \nuse: tri(<vec2> st, <float> size [, <float> width])\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_TRI\n#define FNC_TRI\nfloat tri(vec2 st, float size) {\n    return fill(triSDF(st), size);\n}\n\nfloat tri(vec2 st, float size, float strokeWidth) {\n    return stroke(triSDF(st), size, strokeWidth);\n}\n#endif'}},t={};function n(i){var o=t[i];if(void 0!==o)return o.exports;var a=t[i]={exports:{}};return e[i](a,a.exports,n),a.exports}n.n=e=>{var t=e&&e.__esModule?()=>e.default:()=>e;return n.d(t,{a:t}),t},n.d=(e,t)=>{for(var i in t)n.o(t,i)&&!n.o(e,i)&&Object.defineProperty(e,i,{enumerable:!0,get:t[i]})},n.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t);var i={};(()=>{n.d(i,{Z:()=>g});var e=n(1595),t=n.n(e),o=n(9797),a=n.n(o),s=n(4525),r=n.n(s),l=n(2788),d=n.n(l),f=n(2823),h=n.n(f),c=n(5991),E=n.n(c),T=n(6141),I=n.n(T),O=n(5651),R=n.n(O),S=n(672),N=n.n(S),A=n(7328),u=n.n(A),p=n(5080),v=n.n(p);const g={aastep:t(),bridge:a(),circle:r(),cross:d(),digits:h(),fill:E(),flip:I(),hex:R(),rect:N(),stroke:u(),tri:v()}})();var o=i.Z;export{o as default};