var e={1995:e=>{e.exports='/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: get\'s the luminosity of a color. From https://github.com/hughsk/glsl-luma/blob/master/index.glsl\nuse: rgb2luma(<vec3|vec4> color)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_RGB2LUMA\n#define FNC_RGB2LUMA\nfloat rgb2luma(in vec3 color) {\n    return dot(color, vec3(0.299, 0.587, 0.114));\n}\n\nfloat rgb2luma(in vec4 color) {\n    return rgb2luma(color.rgb);\n}\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: TODO\nuse: bilateralBlur(<sampler2D> texture, <vec2> st, <vec2> duv)\noptions: TODO\nlicense: TODO\n*/\n\n#ifndef BILATERALBLUR_AMOUNT\n#define BILATERALBLUR_AMOUNT bilateralBlur13\n#endif\n\n#ifndef BILATERALBLUR_TYPE\n#define BILATERALBLUR_TYPE vec4\n#endif\n\n#ifndef BILATERALBLUR_SAMPLER_FNC\n#define BILATERALBLUR_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n#ifndef BILATERALBLUR_LUMA\n#define BILATERALBLUR_LUMA(RGB) rgb2luma(RGB.rgb)\n#endif\n\n/*\nauthor: Hugh Kennedy (https://github.com/hughsk)\ndescription: get\'s the luminosity of a color. From https://github.com/hughsk/glsl-luma/blob/master/index.glsl\nuse: rgb2luma(<vec3|vec4> color)\nlicense: |\n  This software is released under the MIT license:\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef FNC_RGB2LUMA\n#define FNC_RGB2LUMA\nfloat rgb2luma(in vec3 color) {\n    return dot(color, vec3(0.299, 0.587, 0.114));\n}\n\nfloat rgb2luma(in vec4 color) {\n    return rgb2luma(color.rgb);\n}\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: two dimensional bilateral Blur, to do it in one single pass\nuse: bilateralBlur2D(<sampler2D> texture, <vec2> st, <vec2> offset, <int> kernelSize)\noptions:\n  BILATERALBLUR2D_TYPE: default is vec3\n  BILATERALBLUR2D_SAMPLER_FNC(POS_UV): default texture2D(tex, POS_UV)\n  BILATERALBLUR2D_LUMA(RGB): default rgb2luma\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef BILATERALBLUR2D_TYPE\n#define BILATERALBLUR2D_TYPE vec4\n#endif\n\n#ifndef BILATERALBLUR2D_SAMPLER_FNC\n#define BILATERALBLUR2D_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n#ifndef BILATERALBLUR2D_LUMA\n#define BILATERALBLUR2D_LUMA(RGB) rgb2luma(RGB.rgb)\n#endif\n\n#ifndef FNC_BILATERALBLUR2D\n#define FNC_BILATERALBLUR2D\nBILATERALBLUR2D_TYPE bilateralBlur2D(in sampler2D tex, in vec2 st, in vec2 offset, const int kernelSize) {\n  BILATERALBLUR2D_TYPE accumColor = BILATERALBLUR2D_TYPE(0.);\n  #ifndef BILATERALBLUR2D_KERNELSIZE\n  #define BILATERALBLUR2D_KERNELSIZE kernelSize\n  #endif\n  float accumWeight = 0.;\n  const float k = .15915494; // 1. / (2.*PI)\n  const float k2 = k * k;\n  float kernelSize2 = float(BILATERALBLUR2D_KERNELSIZE) * float(BILATERALBLUR2D_KERNELSIZE);\n  BILATERALBLUR2D_TYPE tex0 = BILATERALBLUR2D_SAMPLER_FNC(st);\n  float lum0 = BILATERALBLUR2D_LUMA(tex0);\n\n  for (int j = 0; j < BILATERALBLUR2D_KERNELSIZE; j++) {\n    float dy = -.5 * (float(BILATERALBLUR2D_KERNELSIZE) - 1.0) + float(j);\n    for (int i = 0; i < BILATERALBLUR2D_KERNELSIZE; i++) {\n      float dx = -.5 * (float(BILATERALBLUR2D_KERNELSIZE) - 1.0) + float(i);\n      BILATERALBLUR2D_TYPE tex = BILATERALBLUR2D_SAMPLER_FNC(st + vec2(dx, dy) * offset);\n      float lum = BILATERALBLUR2D_LUMA(tex);\n      float dl = 255. * (lum - lum0);\n      float weight = (k2 / kernelSize2) * exp(-(dx * dx + dy * dy + dl * dl) / (2. * kernelSize2));\n      accumColor += weight * tex;\n      accumWeight += weight;\n    }\n  }\n  return accumColor / accumWeight;\n}\n#endif\n\n\n#ifndef FNC_BILATERALFILTER\n#define FNC_BILATERALFILTER\nBILATERALBLUR_TYPE bilateralBlur(in sampler2D tex, in vec2 st, in vec2 offset, const int kernelSize) {\n  return bilateralBlur2D(tex, st, offset, kernelSize);\n}\n\nBILATERALBLUR_TYPE bilateralBlur13(in sampler2D tex, in vec2 st, in vec2 offset) {\n  return bilateralBlur(tex, st, offset, 7);\n}\n\nBILATERALBLUR_TYPE bilateralBlur9(in sampler2D tex, in vec2 st, in vec2 offset) {\n  return bilateralBlur(tex, st, offset, 5);\n}\n\nBILATERALBLUR_TYPE bilateralBlur5(in sampler2D tex, in vec2 st, in vec2 offset) {\n  return bilateralBlur(tex, st, offset, 3);\n}\n\nBILATERALBLUR_TYPE bilateralBlur(in sampler2D tex, in vec2 st, in vec2 offset) {\n  return BILATERALBLUR_AMOUNT(tex, st, offset);\n}\n#endif\n'},4207:e=>{e.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: given a texture return a simple box blured pixel\nuse: boxBlur(<sampler2D> texture, <vec2> st, <vec2> pixel_offset)\noptions:\n  BOXBLUR_2D: default to 1D\n  BOXBLUR_ITERATIONS: default 3\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef BOXBLUR_ITERATIONS\n#define BOXBLUR_ITERATIONS 3\n#endif\n\n#ifndef BOXBLUR_TYPE\n#define BOXBLUR_TYPE vec4\n#endif\n\n#ifndef BOXBLUR_SAMPLER_FNC\n#define BOXBLUR_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: simple one dimentional box blur, to be applied in two passes\nuse: boxBlur1D(<sampler2D> texture, <vec2> st, <vec2> pixel_offset, <int> kernelSize)\noptions:\n  BOXBLUR1D_TYPE: default is vec4\n  BOXBLUR1D_SAMPLER_FNC(POS_UV): default texture2D(tex, POS_UV)\n  BOXBLUR1D_KERNELSIZE: Use only for WebGL 1.0 and OpenGL ES 2.0 . For example RaspberryPis is not happy with dynamic loops. Default is \'kernelSize\'\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n#ifndef BOXBLUR1D_TYPE\n#define BOXBLUR1D_TYPE vec4\n#endif\n\n#ifndef BOXBLUR1D_SAMPLER_FNC\n#define BOXBLUR1D_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n#ifndef FNC_BOXBLUR1D\n#define FNC_BOXBLUR1D\nBOXBLUR1D_TYPE boxBlur1D(in sampler2D tex, in vec2 st, in vec2 offset, const int kernelSize) {\n  BOXBLUR1D_TYPE color = BOXBLUR1D_TYPE(0.);\n  #ifndef BOXBLUR1D_KERNELSIZE\n  #define BOXBLUR1D_KERNELSIZE kernelSize\n  #endif\n\n  float f_kernelSize = float(BOXBLUR1D_KERNELSIZE);\n  float weight = 1. / f_kernelSize;\n\n  for (int i = 0; i < BOXBLUR1D_KERNELSIZE; i++) {\n    float x = -.5 * (f_kernelSize - 1.) + float(i);\n    color += BOXBLUR1D_SAMPLER_FNC(st + offset * x ) * weight;\n  }\n  return color;\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: simple two dimentional box blur, so can be apply in a single pass\nuse: boxBlur2D(<sampler2D> texture, <vec2> st, <vec2> pixel_offset, <int> kernelSize)\noptions:\n  BOXBLUR2D_TYPE: Default `vec4`\n  BOXBLUR2D_SAMPLER_FNC(POS_UV): default is `texture2D(tex, POS_UV)`\n  BOXBLUR2D_KERNELSIZE: Use only for WebGL 1.0 and OpenGL ES 2.0 . For example RaspberryPis is not happy with dynamic loops. Default is \'kernelSize\'\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef BOXBLUR2D_TYPE\n#define BOXBLUR2D_TYPE vec4\n#endif\n\n#ifndef BOXBLUR2D_SAMPLER_FNC\n#define BOXBLUR2D_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n#ifndef FNC_BOXBLUR2D\n#define FNC_BOXBLUR2D\nBOXBLUR2D_TYPE boxBlur2D(in sampler2D tex, in vec2 st, in vec2 pixel, const int kernelSize) {\n  BOXBLUR2D_TYPE color = BOXBLUR2D_TYPE(0.);\n  #ifndef BOXBLUR2D_KERNELSIZE\n  #define BOXBLUR2D_KERNELSIZE kernelSize\n  #endif\n\n  float accumWeight = 0.;\n  float f_kernelSize = float(BOXBLUR2D_KERNELSIZE);\n  float kernelSize2 = f_kernelSize * f_kernelSize;\n  float weight = 1. / kernelSize2;\n\n  for (int j = 0; j < BOXBLUR2D_KERNELSIZE; j++) {\n    float y = -.5 * (f_kernelSize - 1.) + float(j);\n    for (int i = 0; i < BOXBLUR2D_KERNELSIZE; i++) {\n      float x = -.5 * (f_kernelSize - 1.) + float(i);\n      color += BOXBLUR2D_SAMPLER_FNC(st + vec2(x, y) * pixel) * weight;\n    }\n  }\n  return color;\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: simple two dimentional box blur, so can be apply in a single pass\nuse: boxBlur1D_fast9(<sampler2D> texture, <vec2> st, <vec2> pixel_direction)\noptions:\n  BOXBLUR2D_FAST9_TYPE: Default is `vec4`\n  BOXBLUR2D_FAST9_SAMPLER_FNC(POS_UV): Default is `texture2D(tex, POS_UV)`\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef BOXBLUR2D_FAST9_TYPE\n#define BOXBLUR2D_FAST9_TYPE vec4\n#endif\n\n#ifndef BOXBLUR2D_FAST9_SAMPLER_FNC\n#define BOXBLUR2D_FAST9_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n#ifndef FNC_BOXBLUR2D_FAST9\n#define FNC_BOXBLUR2D_FAST9\nBOXBLUR2D_FAST9_TYPE boxBlur2D_fast9(in sampler2D tex, in vec2 st, in vec2 offset) {\n  BOXBLUR2D_FAST9_TYPE color = BOXBLUR2D_FAST9_SAMPLER_FNC(st);           // center\n  color += BOXBLUR2D_FAST9_SAMPLER_FNC(st + vec2(-offset.x, offset.y));  // tleft\n  color += BOXBLUR2D_FAST9_SAMPLER_FNC(st + vec2(-offset.x, 0.));        // left\n  color += BOXBLUR2D_FAST9_SAMPLER_FNC(st + vec2(-offset.x, -offset.y)); // bleft\n  color += BOXBLUR2D_FAST9_SAMPLER_FNC(st + vec2(0., offset.y));         // top\n  color += BOXBLUR2D_FAST9_SAMPLER_FNC(st + vec2(0., -offset.y));        // bottom\n  color += BOXBLUR2D_FAST9_SAMPLER_FNC(st + offset);                     // tright\n  color += BOXBLUR2D_FAST9_SAMPLER_FNC(st + vec2(offset.x, 0.));         // right\n  color += BOXBLUR2D_FAST9_SAMPLER_FNC(st + vec2(offset.x, -offset.y));  // bright\n  return color * 0.1111111111; // 1./9.\n}\n#endif\n\n\n#ifndef FNC_BOXBLUR\n#define FNC_BOXBLUR\nBOXBLUR_TYPE boxBlur13(in sampler2D tex, in vec2 st, in vec2 offset) {\n#ifdef BOXBLUR_2D\n  return boxBlur2D(tex, st, offset, 7);\n#else\n  return boxBlur1D(tex, st, offset, 7);\n#endif\n}\n\nBOXBLUR_TYPE boxBlur9(in sampler2D tex, in vec2 st, in vec2 offset) {\n#ifdef BOXBLUR_2D\n  return boxBlur2D_fast9(tex, st, offset);\n#else\n  return boxBlur1D(tex, st, offset, 5);\n#endif\n}\n\nBOXBLUR_TYPE boxBlur5(in sampler2D tex, in vec2 st, in vec2 offset) {\n#ifdef BOXBLUR_2D\n  return boxBlur2D(tex, st, offset, 3);\n#else\n  return boxBlur1D(tex, st, offset, 3);\n#endif\n}\n\nvec4 boxBlur(in sampler2D tex, in vec2 st, vec2 offset, const int kernelSize) {\n#ifdef BOXBLUR_2D\n  return boxBlur2D(tex, st, offset, kernelSize);\n#else\n  return boxBlur1D(tex, st, offset, kernelSize);\n#endif\n}\n\nvec4 boxBlur(in sampler2D tex, in vec2 st, vec2 offset) {\n  #ifdef BOXBLUR_2D\n    return boxBlur2D(tex, st, offset, BOXBLUR_ITERATIONS);\n  #else\n    return boxBlur1D(tex, st, offset, BOXBLUR_ITERATIONS);\n  #endif\n}\n#endif\n'},548:e=>{e.exports='/*\nauthor: [Matt DesLauriers, Patricio Gonzalez Vivo]\ndescription: adapted versions from 5, 9 and 13 gaussian fast blur from https://github.com/Jam3/glsl-fast-gaussian-blur\nuse: gaussianBlur(<sampler2D> texture, <vec2> st, <vec2> pixel_direction [, const int kernelSize])\noptions:\n  GAUSSIANBLUR_AMOUNT: gaussianBlur5 gaussianBlur9 gaussianBlur13 \n  GAUSSIANBLUR_2D: default to 1D\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n#ifndef GAUSSIANBLUR_AMOUNT\n#define GAUSSIANBLUR_AMOUNT gaussianBlur13\n#endif\n\n#ifndef GAUSSIANBLUR_TYPE\n#define GAUSSIANBLUR_TYPE vec4\n#endif\n\n#ifndef GAUSSIANBLUR_SAMPLER_FNC\n#define GAUSSIANBLUR_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: two dimension Gaussian Blur to be applied in only one passes\nuse: gaussianBlur2D(<sampler2D> texture, <vec2> st, <vec2> pixel_direction , const int kernelSize)\noptions:\n  GAUSSIANBLUR2D_TYPE: Default `vec4`\n  GAUSSIANBLUR2D_SAMPLER_FNC(POS_UV): Default `texture2D(tex, POS_UV)`\n  GAUSSIANBLUR2D_KERNELSIZE: Use only for WebGL 1.0 and OpenGL ES 2.0 . For example RaspberryPis is not happy with dynamic loops. Default is \'kernelSize\'\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n\n*/\n#ifndef GAUSSIANBLUR2D_TYPE\n#define GAUSSIANBLUR2D_TYPE vec4\n#endif\n\n#ifndef GAUSSIANBLUR2D_SAMPLER_FNC\n#define GAUSSIANBLUR2D_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n#ifndef FNC_GAUSSIANBLUR2D\n#define FNC_GAUSSIANBLUR2D\nGAUSSIANBLUR2D_TYPE gaussianBlur2D(in sampler2D tex, in vec2 st, in vec2 offset, const int kernelSize) {\n  GAUSSIANBLUR2D_TYPE accumColor = GAUSSIANBLUR2D_TYPE(0.);\n  #ifndef GAUSSIANBLUR2D_KERNELSIZE\n  #define GAUSSIANBLUR2D_KERNELSIZE kernelSize\n  #endif\n\n  float accumWeight = 0.;\n  const float k = .15915494; // 1 / (2*PI)\n  float kernelSize2 = float(GAUSSIANBLUR2D_KERNELSIZE) * float(GAUSSIANBLUR2D_KERNELSIZE);\n\n  for (int j = 0; j < GAUSSIANBLUR2D_KERNELSIZE; j++) {\n    float y = -.5 * (float(GAUSSIANBLUR2D_KERNELSIZE) - 1.) + float(j);\n    for (int i = 0; i < GAUSSIANBLUR2D_KERNELSIZE; i++) {\n      float x = -.5 * (float(GAUSSIANBLUR2D_KERNELSIZE) - 1.) + float(i);\n      float weight = (k / float(GAUSSIANBLUR2D_KERNELSIZE)) * exp(-(x * x + y * y) / (2. * kernelSize2));\n      GAUSSIANBLUR2D_TYPE tex = GAUSSIANBLUR2D_SAMPLER_FNC(st + vec2(x, y) * offset);\n      accumColor += weight * tex;\n      accumWeight += weight;\n    }\n  }\n  return accumColor / accumWeight;\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: one dimension Gaussian Blur to be applied in two passes\nuse: gaussianBlur1D(<sampler2D> texture, <vec2> st, <vec2> pixel_direction , const int kernelSize)\noptions:\n  GAUSSIANBLUR1D_TYPE: \n  GAUSSIANBLUR1D_SAMPLER_FNC(POS_UV):\n  GAUSSIANBLUR1D_KERNELSIZE: Use only for WebGL 1.0 and OpenGL ES 2.0 . For example RaspberryPis is not happy with dynamic loops. Default is \'kernelSize\'\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef GAUSSIANBLUR1D_TYPE\n#define GAUSSIANBLUR1D_TYPE vec4\n#endif\n\n#ifndef GAUSSIANBLUR1D_SAMPLER_FNC\n#define GAUSSIANBLUR1D_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n#ifndef FNC_GAUSSIANBLUR1D\n#define FNC_GAUSSIANBLUR1D\nGAUSSIANBLUR1D_TYPE gaussianBlur1D(in sampler2D tex, in vec2 st, in vec2 offset, const int kernelSize) {\n  GAUSSIANBLUR1D_TYPE accumColor = GAUSSIANBLUR1D_TYPE(0.);\n  #ifndef GAUSSIANBLUR1D_KERNELSIZE\n  #define GAUSSIANBLUR1D_KERNELSIZE kernelSize\n  #endif\n\n  float accumWeight = 0.;\n  const float k = .39894228; // 1 / sqrt(2*PI)\n  float kernelSize2 = float(GAUSSIANBLUR1D_KERNELSIZE) * float(GAUSSIANBLUR1D_KERNELSIZE);\n  for (int i = 0; i < GAUSSIANBLUR1D_KERNELSIZE; i++) {\n    float x = -.5 * (float(GAUSSIANBLUR1D_KERNELSIZE) - 1.) + float(i);\n    float weight = (k / float(GAUSSIANBLUR1D_KERNELSIZE)) * exp(-(x * x) / (2. * kernelSize2));\n    GAUSSIANBLUR1D_TYPE tex = GAUSSIANBLUR1D_SAMPLER_FNC(st + x * offset);\n    accumColor += weight * tex;\n    accumWeight += weight;\n  }\n  return accumColor / accumWeight;\n}\n#endif\n\n/*\nfunction: gaussianBlur1D_fast13\nauthor: Matt DesLauriers\ndescription: adapted versions of gaussian fast blur 13 from https://github.com/Jam3/glsl-fast-gaussian-blur\nuse: gaussianBlur1D_fast13(<sampler2D> texture, <vec2> st, <vec2> pixel_direction)\noptions:\n  GAUSSIANBLUR1D_FAST13_TYPE\n  GAUSSIANBLUR1D_FAST13_SAMPLER_FNC(POS_UV)\nlicense: |\n  The MIT License (MIT) Copyright (c) 2015 Jam3\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n\n*/\n\n#ifndef GAUSSIANBLUR1D_FAST13_TYPE\n#define GAUSSIANBLUR1D_FAST13_TYPE vec4\n#endif\n\n#ifndef GAUSSIANBLUR1D_FAST13_SAMPLER_FNC\n#define GAUSSIANBLUR1D_FAST13_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n#ifndef FNC_GAUSSIANBLUR1D_FAST13\n#define FNC_GAUSSIANBLUR1D_FAST13\nGAUSSIANBLUR1D_FAST13_TYPE gaussianBlur1D_fast13(in sampler2D tex, in vec2 st, in vec2 offset) {\n  GAUSSIANBLUR1D_FAST13_TYPE color = GAUSSIANBLUR1D_FAST13_TYPE(0.);\n  vec2 off1 = vec2(1.411764705882353) * offset;\n  vec2 off2 = vec2(3.2941176470588234) * offset;\n  vec2 off3 = vec2(5.176470588235294) * offset;\n  color += GAUSSIANBLUR1D_FAST13_SAMPLER_FNC(st) * .1964825501511404;\n  color += GAUSSIANBLUR1D_FAST13_SAMPLER_FNC(st + (off1)) * .2969069646728344;\n  color += GAUSSIANBLUR1D_FAST13_SAMPLER_FNC(st - (off1)) * .2969069646728344;\n  color += GAUSSIANBLUR1D_FAST13_SAMPLER_FNC(st + (off2)) * .09447039785044732;\n  color += GAUSSIANBLUR1D_FAST13_SAMPLER_FNC(st - (off2)) * .09447039785044732;\n  color += GAUSSIANBLUR1D_FAST13_SAMPLER_FNC(st + (off3)) * .010381362401148057;\n  color += GAUSSIANBLUR1D_FAST13_SAMPLER_FNC(st - (off3)) * .010381362401148057;\n  return color;\n}\n#endif\n\n/*\nauthor: Matt DesLauriers\ndescription: adapted versions of gaussian fast blur 13 from https://github.com/Jam3/glsl-fast-gaussian-blur\nuse: gaussianBlur1D_fast9(<sampler2D> texture, <vec2> st, <vec2> pixel_direction)\noptions:\n  GAUSSIANBLUR1D_FAST9_TYPE\n  GAUSSIANBLUR1D_FAST9_SAMPLER_FNC(POS_UV)\nlicense: |\n  The MIT License (MIT) Copyright (c) 2015 Jam3\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n#ifndef GAUSSIANBLUR1D_FAST9_TYPE\n#define GAUSSIANBLUR1D_FAST9_TYPE vec4\n#endif\n\n#ifndef GAUSSIANBLUR1D_FAST9_SAMPLER_FNC\n#define GAUSSIANBLUR1D_FAST9_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n#ifndef FNC_GAUSSIANBLUR1D_FAST9\n#define FNC_GAUSSIANBLUR1D_FAST9\nGAUSSIANBLUR1D_FAST9_TYPE gaussianBlur1D_fast9(in sampler2D tex, in vec2 st, in vec2 offset) {\n  GAUSSIANBLUR1D_FAST9_TYPE color = GAUSSIANBLUR1D_FAST9_TYPE(0.);\n  vec2 off1 = vec2(1.3846153846) * offset;\n  vec2 off2 = vec2(3.2307692308) * offset;\n  color += GAUSSIANBLUR1D_FAST9_SAMPLER_FNC(st) * .2270270270;\n  color += GAUSSIANBLUR1D_FAST9_SAMPLER_FNC(st + (off1)) * .3162162162;\n  color += GAUSSIANBLUR1D_FAST9_SAMPLER_FNC(st - (off1)) * .3162162162;\n  color += GAUSSIANBLUR1D_FAST9_SAMPLER_FNC(st + (off2)) * .0702702703;\n  color += GAUSSIANBLUR1D_FAST9_SAMPLER_FNC(st - (off2)) * .0702702703;\n  return color;\n}\n#endif\n\n/*\nauthor: Matt DesLauriers\ndescription: adapted versions of gaussian fast blur 13 from https://github.com/Jam3/glsl-fast-gaussian-blur\nuse: gaussianBlur1D_fast5(<sampler2D> texture, <vec2> st, <vec2> pixel_direction)\noptions:\n  GAUSSIANBLUR1D_FAST5_TYPE\n  GAUSSIANBLUR1D_FAST5_SAMPLER_FNC(POS_UV)\nlicense: |\n  The MIT License (MIT) Copyright (c) 2015 Jam3\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef GAUSSIANBLUR1D_FAST5_TYPE\n#define GAUSSIANBLUR1D_FAST5_TYPE vec4\n#endif\n\n#ifndef GAUSSIANBLUR1D_FAST5_SAMPLER_FNC\n#define GAUSSIANBLUR1D_FAST5_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n#ifndef FNC_GAUSSIANBLUR1D_FAST5\n#define FNC_GAUSSIANBLUR1D_FAST5\nGAUSSIANBLUR1D_FAST5_TYPE gaussianBlur1D_fast5(in sampler2D tex, in vec2 st, in vec2 offset) {\n  GAUSSIANBLUR1D_FAST5_TYPE color = GAUSSIANBLUR1D_FAST5_TYPE(0.);\n  vec2 off1 = vec2(1.3333333333333333) * offset;\n  color += GAUSSIANBLUR1D_FAST5_SAMPLER_FNC(st) * .29411764705882354;\n  color += GAUSSIANBLUR1D_FAST5_SAMPLER_FNC(st + (off1)) * .35294117647058826;\n  color += GAUSSIANBLUR1D_FAST5_SAMPLER_FNC(st - (off1)) * .35294117647058826;\n  return color;\n}\n#endif\n\n\n#ifndef FNC_GAUSSIANBLUR\n#define FNC_GAUSSIANBLUR\nGAUSSIANBLUR_TYPE gaussianBlur13(in sampler2D tex, in vec2 st, in vec2 offset) {\n#ifdef GAUSSIANBLUR_2D\n  return gaussianBlur2D(tex, st, offset, 7);\n#else\n  return gaussianBlur1D_fast13(tex, st, offset);\n#endif\n}\n\nGAUSSIANBLUR_TYPE gaussianBlur9(in sampler2D tex, in vec2 st, in vec2 offset) {\n#ifdef GAUSSIANBLUR_2D\n  return gaussianBlur2D(tex, st, offset, 5);\n#else\n  return gaussianBlur1D_fast9(tex, st, offset);\n#endif\n}\n\nGAUSSIANBLUR_TYPE gaussianBlur5(in sampler2D tex, in vec2 st, in vec2 offset) {\n#ifdef GAUSSIANBLUR_2D\n  return gaussianBlur2D(tex, st, offset, 3);\n#else\n  return gaussianBlur1D_fast5(tex, st, offset);\n#endif\n}\n\nGAUSSIANBLUR_TYPE gaussianBlur(in sampler2D tex, in vec2 st, in vec2 offset, const int kernelSize) {\n#ifdef GAUSSIANBLUR_2D\n  return gaussianBlur2D(tex, st, offset, kernelSize);\n#else\n  return gaussianBlur1D(tex, st, offset, kernelSize);\n#endif\n}\n\nGAUSSIANBLUR_TYPE gaussianBlur(in sampler2D tex, in vec2 st, in vec2 offset) {\n  return GAUSSIANBLUR_AMOUNT(tex, st, offset);\n}\n#endif\n'},7030:e=>{e.exports='/*\nauthor: Brad Larson\ndescription: adapted version of mean average sampling on four coorners of a sampled point from https://github.com/BradLarson/GPUImage2\nuse: mean(<sampler2D> texture, <vec2> st, <vec2> pixel)\noptions:\n  MEAN_TYPE: defaults to vec4\n  AVERAGE_SAMPLER_FNC(POS_UV): defaults to texture2D(tex,POS_UV)\nlicence:\n  Copyright (c) 2015, Brad Larson. All rights reserved.\n  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:\n  Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.\n  Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.\n  Neither the name of the GPUImage framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.\n  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n*/\n\n#ifndef MEAN_TYPE\n#define MEAN_TYPE vec4\n#endif\n\n#ifndef MEAN_AMOUNT\n#define MEAN_AMOUNT mean4\n#endif\n\n#ifndef MEAN_SAMPLER_FNC\n#define MEAN_SAMPLER_FNC(POS_UV) texture2D(tex,POS_UV)\n#endif\n\n#ifndef FNC_AVERAGE\n#define FNC_AVERAGE\nMEAN_TYPE mean4(in sampler2D tex, in vec2 st, in vec2 pixel) {\n  MEAN_TYPE topLeft = MEAN_SAMPLER_FNC(st - pixel);\n  MEAN_TYPE bottomLeft = MEAN_SAMPLER_FNC(st + vec2(-pixel.x, pixel.y));\n  MEAN_TYPE topRight = MEAN_SAMPLER_FNC(st + vec2(pixel.x, -pixel.y));\n  MEAN_TYPE bottomRight = MEAN_SAMPLER_FNC(st + pixel);\n  return 0.25 * (topLeft + topRight + bottomLeft + bottomRight);\n}\n\nMEAN_TYPE mean(in sampler2D tex, in vec2 st, in vec2 pixel) {\n  return MEAN_AMOUNT(tex, st, pixel);\n}\n#endif\n'},6815:e=>{e.exports='/*\nauthor:[Morgan McGuire, Kyle Whitson]\ndescription: 3x3 and 5x5 median filter, adapted from "A Fast, Small-Radius GPU Median Filter" by Morgan McGuire in ShaderX6 https://casual-effects.com/research/McGuire2008Median/index.html\nuse: median(<sampler2D> texture, <vec2> st, <vec2> pixel)\noptions:\n  MEDIAN_AMOUNT: median3 (3x3) median5 (5x5)\n  MEDIAN_TYPE: default vec4\n  MEDIAN_SAMPLER_FNC(POS_UV): default texture2D(tex, POS_UV)\nlicense:\n  Copyright (c) Morgan McGuire and Williams College, 2006. All rights reserved.\n  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:\n  Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.\n  Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.\n  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n*/\n\n#ifndef MEDIAN_AMOUNT\n#define MEDIAN_AMOUNT median5\n#endif\n\n#ifndef MEDIAN_TYPE\n#define MEDIAN_TYPE vec4\n#endif\n\n#ifndef MEDIAN_SAMPLER_FNC\n#define MEDIAN_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n/*\nauthor: [Morgan McGuire, Kyle Whitson]\ndescription: |\n  3x3 median filter, adapted from "A Fast, Small-Radius GPU Median Filter" \n  by Morgan McGuire in ShaderX6 https://casual-effects.com/research/McGuire2008Median/index.html\nuse: median2D_fast3(<sampler2D> texture, <vec2> st, <vec2> pixel)\noptions:\n  MEDIAN2D_FAST3_TYPE: default vec4\n  MEDIAN2D_FAST3_SAMPLER_FNC(POS_UV): default texture2D(tex, POS_UV)\nlicense:\n  Copyright (c) Morgan McGuire and Williams College, 2006. All rights reserved.\n  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:\n  Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.\n  Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.\n  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n\n*/\n\n#ifndef MEDIAN2D_FAST3_TYPE\n#define MEDIAN2D_FAST3_TYPE vec4\n#endif\n\n#ifndef MEDIAN2D_FAST3_SAMPLER_FNC\n#define MEDIAN2D_FAST3_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n#ifndef MEDIAN_S2\n#define MEDIAN_S2(a, b) temp = a; a = min(a, b); b = max(temp, b);\n#endif\n\n#ifndef MEDIAN_2\n#define MEDIAN_2(a, b) MEDIAN_S2(v[a], v[b]);\n#endif\n\n#ifndef FNC_MEDIAN2D_FAST3\n#define FNC_MEDIAN2D_FAST3\n#define MEDIAN_MN3(a, b, c) MEDIAN_2(a, b); MEDIAN_2(a, c);\n#define MEDIAN_MX3(a, b, c) MEDIAN_2(b, c); MEDIAN_2(a, c);\n#define MEDIAN_MNMX3(a, b, c) MEDIAN_MX3(a, b, c); MEDIAN_2(a, b);                                                                // 3 exchanges\n#define MEDIAN_MNMX4(a, b, c, d) MEDIAN_2(a, b); MEDIAN_2(c, d); MEDIAN_2(a, c); MEDIAN_2(b, d);                                  // 4 exchanges\n#define MEDIAN_MNMX5(a, b, c, d, e) MEDIAN_2(a, b); MEDIAN_2(c, d); MEDIAN_MN3(a, c, e); MEDIAN_MX3(b, d, e);                     // 6 exchanges\n#define MEDIAN_MNMX6(a, b, c, d, e, f) MEDIAN_2(a, d); MEDIAN_2(b, e); MEDIAN_2(c, f); MEDIAN_MN3(a, b, c); MEDIAN_MX3(d, e, f);  // 7 exchanges\nMEDIAN2D_FAST3_TYPE median2D_fast3(in sampler2D tex, in vec2 st, in vec2 radius) {\n  MEDIAN2D_FAST3_TYPE v[9];\n  for (int dX = -1; dX <= 1; ++dX) {\n      for (int dY = -1; dY <= 1; ++dY) {\n          vec2 offset = vec2(float(dX), float(dY));\n          // If a pixel in the window is located at (x+dX, y+dY), put it at index (dX + R)(2R + 1) + (dY + R) of the\n          // pixel array. This will fill the pixel array, with the top left pixel of the window at pixel[0] and the\n          // bottom right pixel of the window at pixel[N-1].\n          v[(dX + 1) * 3 + (dY + 1)] = MEDIAN2D_FAST3_SAMPLER_FNC(st + offset * radius);\n      }\n  }\n  MEDIAN2D_FAST3_TYPE temp = MEDIAN2D_FAST3_TYPE(0.);\n  MEDIAN_MNMX6(0, 1, 2, 3, 4, 5);\n  MEDIAN_MNMX5(1, 2, 3, 4, 6);\n  MEDIAN_MNMX4(2, 3, 4, 7);\n  MEDIAN_MNMX3(3, 4, 8);\n  return v[4];\n}\n#endif\n\n/*\nauthor: [Morgan McGuire, Kyle Whitson]\ndescription: |\n  3x3 median filter, adapted from "A Fast, Small-Radius GPU Median Filter" \n  by Morgan McGuire in ShaderX6 https://casual-effects.com/research/McGuire2008Median/index.html\nuse: median2D_fast5(<sampler2D> texture, <vec2> st, <vec2> pixel)\noptions:\n  MEDIAN2D_FAST5_TYPE: default vec4\n  MEDIAN2D_FAST5_SAMPLER_FNC(POS_UV): default texture2D(tex, POS_UV)\nlicense:\n  Copyright (c) Morgan McGuire and Williams College, 2006. All rights reserved.\n  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:\n  Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.\n  Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.\n  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n\n*/\n\n#ifndef MEDIAN2D_FAST5_TYPE\n#define MEDIAN2D_FAST5_TYPE vec4\n#endif\n\n#ifndef MEDIAN2D_FAST5_SAMPLER_FNC\n#define MEDIAN2D_FAST5_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n#ifndef MEDIAN_S2\n#define MEDIAN_S2(a, b) temp = a; a = min(a, b); b = max(temp, b);\n#endif\n\n#ifndef MEDIAN_2\n#define MEDIAN_2(a, b) MEDIAN_S2(v[a], v[b]);\n#endif\n\n#ifndef FNC_MEDIAN2D_FAST5\n#define FNC_MEDIAN2D_FAST5\n#define MEDIAN_S2(a, b) temp = a; a = min(a, b); b = max(temp, b);\n#define MEDIAN_2(a, b) MEDIAN_S2(v[a], v[b]);\n\n#define MEDIAN_24(a, b, c, d, e, f, g, h) MEDIAN_2(a, b); MEDIAN_2(c, d); MEDIAN_2(e, f); MEDIAN_2(g, h);\n#define MEDIAN_25(a, b, c, d, e, f, g, h, i, j) MEDIAN_24(a, b, c, d, e, f, g, h); MEDIAN_2(i, j);\n\nMEDIAN2D_FAST5_TYPE median2D_fast5(in sampler2D tex, in vec2 st, in vec2 radius) {\n  MEDIAN2D_FAST5_TYPE v[25];\n  for (int dX = -2; dX <= 2; ++dX) {\n      for (int dY = -2; dY <= 2; ++dY) {\n          vec2 offset = vec2(float(dX), float(dY));\n          // If a pixel in the window is located at (x+dX, y+dY), put it at index (dX + R)(2R + 1) + (dY + R) of the\n          // pixel array. This will fill the pixel array, with the top left pixel of the window at pixel[0] and the\n          // bottom right pixel of the window at pixel[N-1].\n          v[(dX + 2) * 5 + (dY + 2)] = MEDIAN2D_FAST5_SAMPLER_FNC(st + offset * radius);\n      }\n  }\n\n  MEDIAN2D_FAST5_TYPE temp = MEDIAN2D_FAST5_TYPE(0.);\n  MEDIAN_25(0,  1,   3, 4,  2,  4,  2,  3,  6,  7);\n  MEDIAN_25(5,  7,   5, 6,  9,  7,  1,  7,  1,  4);\n  MEDIAN_25(12, 13, 11, 13, 11, 12, 15, 16, 14, 16);\n  MEDIAN_25(14, 15, 18, 19, 17, 19, 17, 18, 21, 22);\n  MEDIAN_25(20, 22, 20, 21, 23, 24, 2,  5,  3,  6);\n  MEDIAN_25(0,  6,  0,  3,  4,  7,  1,  7,  1,  4);\n  MEDIAN_25(11, 14, 8,  14, 8,  11, 12, 15, 9,  15);\n  MEDIAN_25(9,  12, 13, 16, 10, 16, 10, 13, 20, 23);\n  MEDIAN_25(17, 23, 17, 20, 21, 24, 18, 24, 18, 21);\n  MEDIAN_25(19, 22, 8,  17, 9,  18, 0,  18, 0,  9);\n  MEDIAN_25(10, 19, 1,  19, 1,  10, 11, 20, 2,  20);\n  MEDIAN_25(2,  11, 12, 21, 3,  21, 3,  12, 13, 22);\n  MEDIAN_25(4,  22, 4,  13, 14, 23, 5,  23, 5,  14);\n  MEDIAN_25(15, 24, 6,  24, 6,  15, 7,  16, 7,  19);\n  MEDIAN_25(3,  11, 5,  17, 11, 17, 9,  17, 4,  10);\n  MEDIAN_25(6,  12, 7,  14, 4,  6,  4,  7,  12, 14);\n  MEDIAN_25(10, 14, 6,  7,  10, 12, 6,  10, 6,  17);\n  MEDIAN_25(12, 17, 7,  17, 7,  10, 12, 18, 7,  12);\n  MEDIAN_24(10, 18, 12, 20, 10, 20, 10, 12);\n  return v[12];\n}\n#endif\n\n\n#ifndef FNC_MEDIAN\n#define FNC_MEDIAN\nMEDIAN_TYPE median3(in sampler2D tex, in vec2 st, in vec2 radius) {\n  return median2D_fast3(tex, st, radius);\n}\n\nMEDIAN_TYPE median5(in sampler2D tex, in vec2 st, in vec2 radius) {\n  return median2D_fast5(tex, st, radius);\n}\n\nMEDIAN_TYPE median(in sampler2D tex, in vec2 st, in vec2 radius) {\n  return MEDIAN_AMOUNT(tex, st, radius);\n}\n#endif\n'},6827:e=>{e.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: make a radial blur, with dir as the direction to the center and strength as the amount\nuse: radialBlur(<sampler2D> texture, <vec2> st, <vec2> dir [, <float> strength] )\noptions:\n  RADIALBLUR_KERNELSIZE: Default 64 \n  RADIALBLUR_STRENGTH: Default 0.125\n  RADIALBLUR_TYPE: Default `vec4`\n  RADIALBLUR_SAMPLER_FNC(POS_UV): Default `texture2D(tex, POS_UV)`\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n*/\n\n#ifndef RADIALBLUR_KERNELSIZE\n#define RADIALBLUR_KERNELSIZE 64\n#endif\n\n#ifndef RADIALBLUR_STRENGTH\n#define RADIALBLUR_STRENGTH .125\n#endif\n\n#ifndef RADIALBLUR_TYPE\n#define RADIALBLUR_TYPE vec4\n#endif\n\n#ifndef RADIALBLUR_SAMPLER_FNC\n#define RADIALBLUR_SAMPLER_FNC(POS_UV) texture2D(tex, POS_UV)\n#endif\n\n#ifndef FNC_RADIALBLUR\n#define FNC_RADIALBLUR\nRADIALBLUR_TYPE radialBlur(in sampler2D tex, in vec2 st, in vec2 dir, in float strength) {\n  RADIALBLUR_TYPE color = RADIALBLUR_TYPE(0.);\n  float f_samples = float(RADIALBLUR_KERNELSIZE);\n  float f_factor = 1./f_samples;\n  for (int i = 0; i < RADIALBLUR_KERNELSIZE; i += 2) {\n      color += RADIALBLUR_SAMPLER_FNC(st + float(i) * f_factor * dir * strength);\n      color += RADIALBLUR_SAMPLER_FNC(st + float(i+1) * f_factor * dir * strength);\n  }\n  return color * f_factor;\n}\n\nRADIALBLUR_TYPE radialBlur(in sampler2D tex, in vec2 st, in vec2 dir) {\n  return radialBlur(tex, st, dir, RADIALBLUR_STRENGTH);\n}\n#endif\n'}},n={};function t(i){var o=n[i];if(void 0!==o)return o.exports;var A=n[i]={exports:{}};return e[i](A,A.exports,t),A.exports}t.n=e=>{var n=e&&e.__esModule?()=>e.default:()=>e;return t.d(n,{a:n}),n},t.d=(e,n)=>{for(var i in n)t.o(n,i)&&!t.o(e,i)&&Object.defineProperty(e,i,{enumerable:!0,get:n[i]})},t.o=(e,n)=>Object.prototype.hasOwnProperty.call(e,n);var i={};(()=>{t.d(i,{Z:()=>N});var e=t(1995),n=t.n(e),o=t(4207),A=t.n(o),E=t(548),s=t.n(E),R=t(7030),r=t.n(R),I=t(6815),S=t.n(I),a=t(6827),T=t.n(a);const N={bilateralBlur:n(),boxBlur:A(),gaussianBlur:s(),mean:r(),median:S(),radialBlur:T()}})();var o=i.Z;export{o as default};