var n={8236:n=>{n.exports='/*\nauthor: Brad Larson\ndescription: adaptive threshold from https://github.com/BradLarson/GPUImage/blob/master/framework/Source/GPUImageAdaptiveThresholdFilter.m\nuse: adaptiveThreshold(<float> value, <float> blur_value, <float> bias)\nlicense: |\n  Copyright (c) 2012, Brad Larson, Ben Cochran, Hugues Lismonde, Keitaroh Kobayashi, Alaric Cole, Matthew Clark, Jacob Gundersen, Chris Williams.\n  All rights reserved.\n  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:\n  Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.\n  Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.\n  Neither the name of the GPUImage framework nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.\n  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n*/\n\n#ifndef FNC_ADAPTIVETHRESHOLD\n#define FNC_ADAPTIVETHRESHOLD\nfloat adaptiveThreshold(in float value, in float blur_value, in float bias) {\n    return step(blur_value + bias, value);\n}\n\nfloat adaptiveThreshold(in float value, in float blur_value) {\n    return step(blur_value - 0.05, value);\n}\n#endif\n'},6951:n=>{n.exports="#ifndef QTR_PI\n#define QTR_PI 0.78539816339\n#endif\n#ifndef HALF_PI\n#define HALF_PI 1.5707963267948966192313216916398\n#endif\n#ifndef PI\n#define PI 3.1415926535897932384626433832795\n#endif\n#ifndef TWO_PI\n#define TWO_PI 6.2831853071795864769252867665590\n#endif\n#ifndef TAU\n#define TAU 6.2831853071795864769252867665590\n#endif\n#ifndef ONE_OVER_PI\n#define ONE_OVER_PI 0.31830988618\n#endif\n#ifndef PHI\n#define PHI 1.618033988749894848204586834\n#endif\n#ifndef EPSILON\n#define EPSILON 0.0000001\n#endif\n#ifndef GOLDEN_RATIO\n#define GOLDEN_RATIO 1.6180339887\n#endif\n#ifndef GOLDEN_ANGLE // (3.-sqrt(5.0))*PI radians\n#define GOLDEN_ANGLE 2.39996323\n#endif\n"},7877:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: decimate a value with an specific presicion \nuse: decimation(<float|vec2|vec3|vec4> value, <float|vec2|vec3|vec4> presicion)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_DECIMATION\n#define FNC_DECIMATION\n#define decimation(value, presicion) (floor(value * presicion)/presicion)\n#endif'},1496:n=>{n.exports="/*\nauthor: [Ian McEwan, Ashima Arts]\ndescription: fade\nuse: fade(<vec2|vec3|vec4> t)\nlicense: |\n  Copyright (C) 2011 Ashima Arts. All rights reserved.\n  Distributed under the MIT License. See LICENSE file.\n  https://github.com/ashima/webgl-noise\n*/\n\n#ifndef FNC_FADE\n#define FNC_FADE\nfloat fade(in float t) {\n  return t * t * t * (t * (t * 6. - 15.) + 10.);\n}\n\nvec2 fade(in vec2 t) {\n  return t * t * t * (t * (t * 6. - 15.) + 10.);\n}\n\nvec3 fade(in vec3 t) {\n  return t * t * t * (t * (t * 6. - 15. ) + 10.);\n}\n\nvec4 fade(vec4 t) {\n  return t*t*t*(t*(t*6.0-15.0)+10.0);\n}\n#endif\n"},2381:n=>{n.exports="/*\nauthor: [Ian McEwan, Ashima Arts]\ndescription: grad4, used for snoise(vec4 v)\nuse: grad4(<float> j, <vec4> ip)\nlicense: |\n  Copyright (C) 2011 Ashima Arts. All rights reserved.\n  Distributed under the MIT License. See LICENSE file.\n  https://github.com/ashima/webgl-noise\n*/\n#ifndef FNC_GRAD4\n#define FNC_GRAD4\nvec4 grad4(float j, vec4 ip) {\n    const vec4 ones = vec4(1.0, 1.0, 1.0, -1.0);\n    vec4 p,s;\n\n    p.xyz = floor( fract (vec3(j) * ip.xyz) * 7.0) * ip.z - 1.0;\n    p.w = 1.5 - dot(abs(p.xyz), ones.xyz);\n    s = vec4(lessThan(p, vec4(0.0)));\n    p.xyz = p.xyz + (s.xyz*2.0 - 1.0) * s.www;\n\n    return p;\n}\n#endif\n"},1056:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: Squared length\nuse: lengthSq(<vec2|float2> st)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_LENGTHSQ\n#define FNC_LENGTHSQ\nfloat lengthSq(in vec2 st) {\n    return dot(st, st);\n}\n\nfloat lengthSq(in vec3 pos) {\n    return dot(pos, pos);\n}\n#endif\n'},1578:n=>{n.exports='/*\nauthor: Johan Ismael\ndescription: Map a value between one range to another.\nuse: map(<float|vec2|vec3|vec4> value, <float|vec2|vec3|vec4> inMin, <float|vec2|vec3|vec4> inMax, <float|vec2|vec3|vec4> outMin, <float|vec2|vec3|vec4> outMax)\nlicense: |\n  Copyright (c) 2017 Johan Ismael.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_MAP\n#define FNC_MAP\n\nfloat map(in float value, in float inMin, in float inMax, in float outMin, in float outMax) {\n  return outMin + (outMax - outMin) * (value - inMin) / (inMax - inMin);\n}\n\nvec2 map(in vec2 value, in vec2 inMin, in vec2 inMax, in vec2 outMin, in vec2 outMax) {\n  return outMin + (outMax - outMin) * (value - inMin) / (inMax - inMin);\n}\n\nvec3 map(in vec3 value, in vec3 inMin, in vec3 inMax, in vec3 outMin, in vec3 outMax) {\n  return outMin + (outMax - outMin) * (value - inMin) / (inMax - inMin);\n}\n\nvec4 map(in vec4 value, in vec4 inMin, in vec4 inMax, in vec4 outMin, in vec4 outMax) {\n  return outMin + (outMax - outMin) * (value - inMin) / (inMax - inMin);\n}\n\n#endif\n'},4688:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: extend GLSL Max function to add more arguments\nuse: \n  - max(<float> A, <float> B, <float> C[, <float> D])\n  - max(<vec2|vec3|vec4> A)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_MAX\n#define FNC_MAX\nfloat max(in float a, in float b, in float c) {\n  return max(a, max(b, c));\n}\n\nfloat max(in float a, in float b, in float c, in float d) {\n  return max(max(a, b), max(c, d));\n}\n\nfloat max(const vec2 v) {\n    return max(v.x, v.y);\n}\n\nfloat max(const vec3 v) {\n    return max(v.x, v.y, v.z);\n}\n\nfloat max(const vec4 v) {\n    return max(v.x, v.y, v.z, v.w);\n}\n#endif\n'},254:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: extend GLSL min function to add more arguments\nuse: \n  - min(<float> A, <float> B, <float> C[, <float> D])\n  - min(<vec2|vec3|vec4> A)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_MIN\n#define FNC_MIN\nfloat min(in float a, in float b, in float c) {\n  return min(a, min(b, c));\n}\n\nfloat min(in float a, in float b, in float c, in float d) {\n  return min(min(a,b), min(c, d));\n}\n\nfloat min(const vec2 v) {\n    return min(v.x, v.y);\n}\n\nfloat min(const vec3 v) {\n    return min(v.x, v.y, v.z);\n}\n\nfloat min(const vec4 v) {\n    return min(v.x, v.y, v.z, v.w);\n}\n#endif\n'},5824:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: expands mix to linearly mix more than two values\nuse: mix(<float|vec2|vec3|vec4> a, <float|vec2|vec3|vec4> b, <float|vec2|vec3|vec4> c [, <float|vec2|vec3|vec4> d], <float> pct)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_MIX\n#define FNC_MIX\nfloat mix(float a , float b, float c, float pct) {\n     return mix(\n         mix(a, b, 2. * pct),\n         mix(b, c, 2. * (max(pct, .5) - .5)),\n         step(.5, pct)\n     );\n}\n\nvec2 mix(vec2 a , vec2 b, vec2 c, float pct) {\n     return mix(\n         mix(a, b, 2. * pct),\n         mix(b, c, 2. * (max(pct, .5) - .5)),\n         step(.5, pct)\n     );\n}\n\nvec2 mix(vec2 a , vec2 b, vec2 c, vec2 pct) {\n     return mix(\n         mix(a, b, 2. * pct),\n         mix(b, c, 2. * (max(pct, .5) - .5)),\n         step(.5, pct)\n     );\n}\n\nvec3 mix(vec3 a , vec3 b, vec3 c, float pct) {\n     return mix(\n         mix(a, b, 2. * pct),\n         mix(b, c, 2. * (max(pct, .5) - .5)),\n         step(.5, pct)\n     );\n}\n\nvec3 mix(vec3 a , vec3 b, vec3 c, vec3 pct) {\n     return mix(\n         mix(a, b, 2. * pct),\n         mix(b, c, 2. * (max(pct, .5) - .5)),\n         step(.5, pct)\n     );\n}\n\nvec4 mix(vec4 a , vec4 b, vec4 c, float pct) {\n     return mix(\n         mix(a, b, 2. * pct),\n         mix(b, c, 2. * (max(pct, .5) - .5)),\n         step(.5, pct)\n     );\n}\n\nvec4 mix(vec4 a , vec4 b, vec4 c, vec4 pct) {\n     return mix(\n         mix(a, b, 2. * pct),\n         mix(b, c, 2. * (max(pct, .5) - .5)),\n         step(.5, pct)\n     );\n}\n\nfloat mix(in float a , in float b, in float c, in float d, in float pct) {\n     return mix(\n         mix(a, b, 3. * pct),\n         mix(b,\n             mix( c,\n                  d,\n                  3. * (max(pct, .66) - .66)),\n             3. * (clamp(pct, .33, .66) - .33)\n         ),\n         step(.33, pct)\n     );\n}\n\nvec2 mix(in vec2 a , in vec2 b, in vec2 c, in vec2 d, in float pct) {\n     return mix(\n         mix(a, b, 3. * pct),\n         mix(b,\n             mix( c,\n                  d,\n                  3. * (max(pct, .66) - .66)),\n             3. * (clamp(pct, .33, .66) - .33)\n         ),\n         step(.33, pct)\n     );\n}\n\nvec2 mix(in vec2 a , in vec2 b, in vec2 c, in vec2 d, in vec2 pct) {\n     return mix(\n         mix(a, b, 3. * pct),\n         mix(b,\n             mix( c,\n                  d,\n                  3. * (max(pct, .66) - .66)),\n             3. * (clamp(pct, .33, .66) - .33)\n         ),\n         step(.33, pct)\n     );\n}\n\nvec3 mix(in vec3 a , in vec3 b, in vec3 c, in vec3 d, in float pct) {\n     return mix(\n         mix(a, b, 3. * pct),\n         mix(b,\n             mix( c,\n                  d,\n                  3. * (max(pct, .66) - .66)),\n             3. * (clamp(pct, .33, .66) - .33)\n         ),\n         step(.33, pct)\n     );\n}\n\nvec3 mix(in vec3 a , in vec3 b, in vec3 c, in vec3 d, in vec3 pct) {\n     return mix(\n         mix(a, b, 3. * pct),\n         mix(b,\n             mix( c,\n                  d,\n                  3. * (max(pct, .66) - .66)),\n             3. * (clamp(pct, .33, .66) - .33)\n         ),\n         step(.33, pct)\n     );\n}\n\nvec4 mix(in vec4 a , in vec4 b, in vec4 c, in vec4 d, in float pct) {\n     return mix(\n         mix(a, b, 3. * pct),\n         mix(b,\n             mix( c,\n                  d,\n                  3. * (max(pct, .66) - .66)),\n             3. * (clamp(pct, .33, .66) - .33)\n         ),\n         step(.33, pct)\n     );\n}\n\nvec4 mix(in vec4 a , in vec4 b, in vec4 c, in vec4 d, in vec4 pct) {\n     return mix(\n         mix(a, b, 3. * pct),\n         mix(b,\n             mix( c,\n                  d,\n                  3. * (max(pct, .66) - .66)),\n             3. * (clamp(pct, .33, .66) - .33)\n         ),\n         step(.33, pct)\n     );\n}\n#endif\n'},7802:n=>{n.exports="/*\nauthor: [Ian McEwan, Ashima Arts]\ndescription: modulus of 289\nuse: mod289(<float|vec2|vec3|vec4> x)\nlicense: |\n  Copyright (C) 2011 Ashima Arts. All rights reserved.\n  Distributed under the MIT License. See LICENSE file.\n  https://github.com/ashima/webgl-noise\n*/\n#ifndef FNC_MOD289\n#define FNC_MOD289\nfloat mod289(in float x) {\n  return x - floor(x * (1. / 289.)) * 289.;\n}\n\nvec2 mod289(in vec2 x) {\n  return x - floor(x * (1. / 289.)) * 289.;\n}\n\nvec3 mod289(in vec3 x) {\n  return x - floor(x * (1. / 289.)) * 289.;\n}\n\nvec4 mod289(in vec4 x) {\n  return x - floor(x * (1. / 289.)) * 289.;\n}\n#endif\n"},1:n=>{n.exports="/*\nauthor: [Ian McEwan, Ashima Arts]\ndescription: modulus of 289\nuse: mod289(<float|vec2|vec3|vec4> x)\nlicense: |\n  Copyright (C) 2011 Ashima Arts. All rights reserved.\n  Distributed under the MIT License. See LICENSE file.\n  https://github.com/ashima/webgl-noise\n*/\n#ifndef FNC_MOD289\n#define FNC_MOD289\nfloat mod289(in float x) {\n  return x - floor(x * (1. / 289.)) * 289.;\n}\n\nvec2 mod289(in vec2 x) {\n  return x - floor(x * (1. / 289.)) * 289.;\n}\n\nvec3 mod289(in vec3 x) {\n  return x - floor(x * (1. / 289.)) * 289.;\n}\n\nvec4 mod289(in vec4 x) {\n  return x - floor(x * (1. / 289.)) * 289.;\n}\n#endif\n\n\n/*\nauthor: [Ian McEwan, Ashima Arts]\ndescription: permute\nuse: permute(<float|vec2|vec3|vec4> x)\nlicense : |\n  Copyright (C) 2011 Ashima Arts. All rights reserved.\n  Distributed under the MIT License. See LICENSE file.\n  https://github.com/ashima/webgl-noise\n*/\n\n#ifndef FNC_PERMUTE\n#define FNC_PERMUTE\nfloat permute(in float x) {\n     return mod289(((x * 34.) + 1.)*x);\n}\n\nvec3 permute(in vec3 x) {\n  return mod289(((x*34.0)+1.0)*x);\n}\n\nvec4 permute(in vec4 x) {\n     return mod289(((x * 34.) + 1.)*x);\n}\n#endif\n"},5661:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: power of 2\nuse: pow2(<float|vec2|vec3|vec4> x)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_POW2\n#define FNC_POW2\nfloat pow2(in float x) {\n  return x * x;\n}\n\nvec2 pow2(in vec2 x) {\n  return x * x;\n}\n\nvec3 pow2(in vec3 x) {\n  return x * x;\n}\n\nvec4 pow2(in vec4 x) {\n  return x * x;\n}\n#endif\n'},1759:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: power of 3\nuse: pow3(<float|vec2|vec3|vec4> x)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_POW3\n#define FNC_POW3\nfloat pow3(in float x) {\n  return x * x * x;\n}\n\nvec2 pow3(in vec2 x) {\n  return x * x * x;\n}\n\nvec3 pow3(in vec3 x) {\n  return x * x * x;\n}\n\nvec4 pow3(in vec4 x) {\n  return x * x * x;\n}\n#endif\n'},8029:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: power of 5\nuse: pow5(<float|vec2|vec3|vec4> x)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_POW5\n#define FNC_POW5\nfloat pow5(in float x) {\n    float x2 = x * x;\n    return x2 * x2 * x;\n}\n\nvec2 pow5(in vec2 x) {\n    vec2 x2 = x * x;\n    return x2 * x2 * x;\n}\n\nvec3 pow5(in vec3 x) {\n    vec3 x2 = x * x;\n    return x2 * x2 * x;\n}\n\nvec4 pow5(in vec4 x) {\n    vec4 x2 = x * x;\n    return x2 * x2 * x;\n}\n#endif\n'},2257:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: power of 7\nuse: pow7(<float|vec2|vec3|vec4> x)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_POW2\n#define FNC_POW2\nfloat pow7(in float x) {\n  return x * x * x * x * x * x * x;\n}\n\nvec2 pow7(in vec2 x) {\n  return x * x * x * x * x * x * x;\n}\n\nvec3 pow7(in vec3 x) {\n  return x * x * x * x * x * x * x;\n}\n\nvec4 pow7(in vec4 x) {\n  return x * x * x * x * x * x * x;\n}\n#endif\n'},6398:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: fast approximation to pow()\nuse: powFast(<float> x, <float> exp)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_POWFAST\n#define FNC_POWFAST\n\nfloat powFast(float a, float b) {\n  return a / ((1. - b) * a + b);\n}\n\n#endif'},2471:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: returns a 2x2 rotation matrix\nuse: rotate2d(<float> radians)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_ROTATE2D\n#define FNC_ROTATE2D\nmat2 rotate2d(in float radians){\n    float c = cos(radians);\n    float s = sin(radians);\n    return mat2(c, -s, s, c);\n}\n#endif\n'},5085:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: returns a 4x4 rotation matrix\nuse: rotate4d(<vec3> axis, <float> radians)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_ROTATE3D\n#define FNC_ROTATE3D\nmat3 rotate3d(in vec3 axis, in float radians) {\n    axis = normalize(axis);\n    float s = sin(radians);\n    float c = cos(radians);\n    float oc = 1.0 - c;\n\n    return mat3(oc * axis.x * axis.x + c,           oc * axis.x * axis.y - axis.z * s,  oc * axis.z * axis.x + axis.y * s,\n                oc * axis.x * axis.y + axis.z * s,  oc * axis.y * axis.y + c,           oc * axis.y * axis.z - axis.x * s,\n                oc * axis.z * axis.x - axis.y * s,  oc * axis.y * axis.z + axis.x * s,  oc * axis.z * axis.z + c );\n}\n#endif\n'},3448:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: returns a 4x4 rotation matrix\nuse: rotate4d(<vec3> axis, <float> radians)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_ROTATE4D\n#define FNC_ROTATE4D\nmat4 rotate4d(in vec3 axis, in float radians) {\n    axis = normalize(axis);\n    float s = sin(radians);\n    float c = cos(radians);\n    float oc = 1.0 - c;\n\n    return mat4(oc * axis.x * axis.x + c,           oc * axis.x * axis.y - axis.z * s,  oc * axis.z * axis.x + axis.y * s,  0.0,\n                oc * axis.x * axis.y + axis.z * s,  oc * axis.y * axis.y + c,           oc * axis.y * axis.z - axis.x * s,  0.0,\n                oc * axis.z * axis.x - axis.y * s,  oc * axis.y * axis.z + axis.x * s,  oc * axis.z * axis.z + c,           0.0,\n                0.0,                                0.0,                                0.0,                                1.0);\n}\n#endif\n'},2109:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: returns a 4x4 rotation matrix\nuse: rotate4dX(<float> radians)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_ROTATE4DX\n#define FNC_ROTATE4DX\nmat4 rotate4dX(in float phi){\n    return mat4(\n        vec4(1.,0.,0.,0),\n        vec4(0.,cos(phi),-sin(phi),0.),\n        vec4(0.,sin(phi),cos(phi),0.),\n        vec4(0.,0.,0.,1.));\n}\n#endif\n'},3538:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: returns a 4x4 rotation matrix\nuse: rotate4dY(<float> radians)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_ROTATE4DY\n#define FNC_ROTATE4DY\nmat4 rotate4dY(in float theta){\n    return mat4(\n        vec4(cos(theta),0.,-sin(theta),0),\n        vec4(0.,1.,0.,0.),\n        vec4(sin(theta),0.,cos(theta),0.),\n        vec4(0.,0.,0.,1.));\n}\n#endif\n'},3553:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: returns a 4x4 rotation matrix\nuse: rotate4dZ(<float> radians)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_ROTATE4DZ\n#define FNC_ROTATE4DZ\nmat4 rotate4dZ(in float psi){\n    return mat4(\n        vec4(cos(psi),-sin(psi),0.,0),\n        vec4(sin(psi),cos(psi),0.,0.),\n        vec4(0.,0.,1.,0.),\n        vec4(0.,0.,0.,1.));\n}\n#endif\n'},4782:n=>{n.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: clamp a value between 0 and 1\nuse: saturation(<float|vec2|vec3|vec4> value)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_SATURATE\n#define FNC_SATURATE\n// #define saturate(x) clamp(x, 0.0, 1.0)\nfloat saturate( float x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec2 saturate( vec2 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec3 saturate( vec3 x) {\n    return clamp(x, 0.0, 1.0);\n}\n\nvec4 saturate( vec4 x) {\n    return clamp(x, 0.0, 1.0);\n}\n#endif'},608:n=>{n.exports="/*\nauthor: [Ian McEwan, Ashima Arts]\ndescription: \nuse: taylorInvSqrt(<float|vec4> x)\nLicense : |\n  Copyright (C) 2011 Ashima Arts. All rights reserved.\n  Distributed under the MIT License. See LICENSE file.\n  https://github.com/ashima/webgl-noise\n*/\n\n#ifndef FNC_TAYLORINVSQRT\n#define FNC_TAYLORINVSQRT\nfloat taylorInvSqrt(in float r) {\n  return 1.79284291400159 - 0.85373472095314 * r;\n}\n\nvec4 taylorInvSqrt(in vec4 r) {\n  return 1.79284291400159 - 0.85373472095314 * r;\n}\n#endif"}},e={};function t(i){var o=e[i];if(void 0!==o)return o.exports;var a=e[i]={exports:{}};return n[i](a,a.exports,t),a.exports}t.n=n=>{var e=n&&n.__esModule?()=>n.default:()=>n;return t.d(e,{a:e}),e},t.d=(n,e)=>{for(var i in e)t.o(e,i)&&!t.o(n,i)&&Object.defineProperty(n,i,{enumerable:!0,get:e[i]})},t.o=(n,e)=>Object.prototype.hasOwnProperty.call(n,e);var i={};(()=>{t.d(i,{Z:()=>J});var n=t(8236),e=t.n(n),o=t(1056),a=t.n(o),s=t(7802),r=t.n(s),c=t(2257),T=t.n(c),I=t(2109),E=t.n(I),O=t(6951),R=t.n(O),N=t(1578),A=t.n(N),l=t(1),f=t.n(l),d=t(6398),S=t.n(d),h=t(3538),p=t.n(h),u=t(7877),x=t.n(u),m=t(4688),v=t.n(m),H=t(5661),L=t.n(H),C=t(2471),F=t.n(C),b=t(3553),w=t.n(b),D=t(1496),P=t.n(D),M=t(254),g=t.n(M),W=t(1759),y=t.n(W),U=t(5085),G=t.n(U),Y=t(4782),B=t.n(Y),z=t(2381),V=t.n(z),_=t(5824),X=t.n(_),j=t(8029),K=t.n(j),q=t(3448),Q=t.n(q),Z=t(608),k=t.n(Z);const J={adaptiveThreshold:e(),lengthSq:a(),mod289:r(),pow7:T(),rotate4dX:E(),consts:R(),map:A(),permute:f(),powFast:S(),rotate4dY:p(),decimation:x(),max:v(),pow2:L(),rotate2d:F(),rotate4dZ:w(),fade:P(),min:g(),pow3:y(),rotate3d:G(),saturate:B(),grad4:V(),mix:X(),pow5:K(),rotate4d:Q(),taylorInvSqrt:k()}})();var o=i.Z;export{o as default};