!function(e,n){"object"==typeof exports&&"object"==typeof module?module.exports=n():"function"==typeof define&&define.amd?define([],n):"object"==typeof exports?exports.lygia=n():e.Lygia=n()}(self,(function(){return(()=>{var e={7225:e=>{e.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: Flip Y axis\nuse: flipY(<vec2> st)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_FLIPY\n#define FNC_FLIPY\nvec2 flipY(in vec2 st) {\n  return vec2(st.x, 1. - st.y);\n}\n#endif\n'},9357:e=>{e.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: Fix the aspect ratio of a space keeping things squared for you.\nuse: ratio(vec2 st, vec2 st_size)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_RATIO\n#define FNC_RATIO\nvec2 ratio(in vec2 st, in vec2 s) {\n    return mix( vec2((st.x*s.x/s.y)-(s.x*.5-s.y*.5)/s.y,st.y),\n                vec2(st.x,st.y*(s.y/s.x)-(s.y*.5-s.x*.5)/s.x),\n                step(s.x,s.y));\n}\n#endif\n'},1904:e=>{e.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: returns a 2x2 rotation matrix\nuse: rotate2d(<float> radians)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_ROTATE2D\n#define FNC_ROTATE2D\nmat2 rotate2d(in float radians){\n    float c = cos(radians);\n    float s = sin(radians);\n    return mat2(c, -s, s, c);\n}\n#endif\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: returns a 4x4 rotation matrix\nuse: rotate4d(<vec3> axis, <float> radians)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_ROTATE4D\n#define FNC_ROTATE4D\nmat4 rotate4d(in vec3 axis, in float radians) {\n    axis = normalize(axis);\n    float s = sin(radians);\n    float c = cos(radians);\n    float oc = 1.0 - c;\n\n    return mat4(oc * axis.x * axis.x + c,           oc * axis.x * axis.y - axis.z * s,  oc * axis.z * axis.x + axis.y * s,  0.0,\n                oc * axis.x * axis.y + axis.z * s,  oc * axis.y * axis.y + c,           oc * axis.y * axis.z - axis.x * s,  0.0,\n                oc * axis.z * axis.x - axis.y * s,  oc * axis.y * axis.z + axis.x * s,  oc * axis.z * axis.z + c,           0.0,\n                0.0,                                0.0,                                0.0,                                1.0);\n}\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: rotate a 2D space by a radian radians\nuse: rotate(<vec3|vec2> st, float radians [, vec2 center])\noptions:\n  - CENTER_2D\n  - CENTER_3D\n  - CENTER_4D\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_ROTATE\n#define FNC_ROTATE\nvec2 rotate(in vec2 st, in float radians, in vec2 center) {\n  return rotate2d(radians) * (st - center) + center;\n}\n\nvec2 rotate(in vec2 st, in float radians) {\n  #ifdef CENTER_2D\n  return rotate(st, radians, CENTER_2D);\n  #else\n  return rotate(st, radians, vec2(.5));\n  #endif\n}\n\nvec3 rotate(in vec3 xyz, in float radians, in vec3 axis, in vec3 center) {\n  return (rotate4d(axis, radians) * vec4(xyz - center, 1.)).xyz + center;\n}\n\nvec3 rotate(in vec3 xyz, in float radians, in vec3 axis) {\n  #ifdef CENTER_3D\n  return rotate(xyz, radians, axis, CENTER_3D);\n  #else\n  return rotate(xyz, radians, axis, vec3(0.));\n  #endif\n}\n\nvec4 rotate(in vec4 xyzw, in float radians, in vec3 axis, in vec4 center) {\n  return rotate4d(axis, radians) * (xyzw - center) + center;\n}\n\nvec4 rotate(in vec4 xyzw, in float radians, in vec3 axis) {\n  #ifdef CENTER_4D\n  return rotate(xyzw, radians, axis, CENTER_4D);\n  #else\n  return rotate(xyzw, radians, axis, vec4(0.));\n  #endif\n}\n#endif\n'},8535:e=>{e.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: returns a 4x4 rotation matrix\nuse: rotate4dX(<float> radians)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_ROTATE4DX\n#define FNC_ROTATE4DX\nmat4 rotate4dX(in float phi){\n    return mat4(\n        vec4(1.,0.,0.,0),\n        vec4(0.,cos(phi),-sin(phi),0.),\n        vec4(0.,sin(phi),cos(phi),0.),\n        vec4(0.,0.,0.,1.));\n}\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: rotate a 2D space by a radian angle\nuse: rotateX(<vec3|vec4> pos, float radian [, vec3 center])\noptions:\n  - CENTER_3D\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_ROTATEX\n#define FNC_ROTATEX\nvec3 rotateX(in vec3 pos, in float radian, in vec3 center) {\n  return (rotate4dX(radian) * vec4(pos - center, 1.)).xyz + center;\n}\n\nvec3 rotateX(in vec3 pos, in float radian) {\n  #ifdef CENTER_3D\n  return rotateX(pos, radian, CENTER_3D);\n  #else\n  return rotateX(pos, radian, vec3(.0));\n  #endif\n}\n#endif\n'},5422:e=>{e.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: returns a 4x4 rotation matrix\nuse: rotate4dY(<float> radians)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_ROTATE4DY\n#define FNC_ROTATE4DY\nmat4 rotate4dY(in float theta){\n    return mat4(\n        vec4(cos(theta),0.,-sin(theta),0),\n        vec4(0.,1.,0.,0.),\n        vec4(sin(theta),0.,cos(theta),0.),\n        vec4(0.,0.,0.,1.));\n}\n#endif\n\n\n/*\nauthor: Patricio Gonzalez Vivo\ndescription: rotate a 2D space by a radian angle\nuse: rotateY(<vec3> pos, float radian [, vec4 center])\noptions:\n  - CENTER_3D\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_ROTATEY\n#define FNC_ROTATEY\nvec3 rotateY(in vec3 pos, in float radian, in vec3 center) {\n  return (rotate4dY(radian) * vec4((pos - center), 1.)).xyz + center;\n}\n\nvec3 rotateY(in vec3 pos, in float radian) {\n  #ifdef CENTER_3D\n  return rotateY(pos, radian, CENTER_3D);\n  #else\n  return rotateY(pos, radian, vec3(.0));\n  #endif\n}\n#endif\n'},9174:e=>{e.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: returns a 4x4 rotation matrix\nuse: rotate4dZ(<float> radians)\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n\n*/\n\n#ifndef FNC_ROTATE4DZ\n#define FNC_ROTATE4DZ\nmat4 rotate4dZ(in float psi){\n    return mat4(\n        vec4(cos(psi),-sin(psi),0.,0),\n        vec4(sin(psi),cos(psi),0.,0.),\n        vec4(0.,0.,1.,0.),\n        vec4(0.,0.,0.,1.));\n}\n#endif\n\n\n/*\nfunction: rotateZ\nauthor: Patricio Gonzalez Vivo\ndescription: rotate a 2D space by a radian angle\nuse: rotateZ(<vec3|vec4> pos, float radian [, vec3 center])\noptions:\n  - CENTER_3D\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_ROTATEZ\n#define FNC_ROTATEZ\nvec3 rotateZ(in vec3 pos, in float radian, in vec3 center) {\n  return (rotate4dZ(radian) * vec4(pos - center, 0.) ).xyz + center;\n}\n\nvec3 rotateZ(in vec3 pos, in float radian) {\n  #ifdef CENTER_3D\n  return rotateZ(pos, radian, CENTER_3D);\n  #else\n  return rotateZ(pos, radian, vec3(.0));\n  #endif\n}\n#endif\n'},8457:e=>{e.exports='/*\nauthor: Patricio Gonzalez Vivo\ndescription: scale a 2D space variable\nuse: scale(<vec2> st, <vec2|float> scale_factor [, <vec2> center])\noptions:\n    - CENTER\n    - CENTER_2D\n    - CENTER_3D\nlicense: |\n  Copyright (c) 2017 Patricio Gonzalez Vivo.\n  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.    \n*/\n\n#ifndef FNC_SCALE\n#define FNC_SCALE\nfloat scale(in float st, in float s, in float center) {\n  return (st - center) * s + center;\n}\n\nfloat scale(in float st, in float s) {\n  #ifdef CENTER_2D\n  return scale(st,  s, CENTER);\n  #else\n  return scale(st,  s, .5);\n  #endif\n}\n\n\nvec2 scale(in vec2 st, in vec2 s, in vec2 center) {\n  return (st - center) * s + center;\n}\n\nvec2 scale(in vec2 st, in float value, in vec2 center) {\n  return scale(st, vec2(value), center);\n}\n\nvec2 scale(in vec2 st, in vec2 s) {\n  #ifdef CENTER_2D\n  return scale(st,  s, CENTER_2D);\n  #else\n  return scale(st,  s, vec2(.5));\n  #endif\n}\n\nvec2 scale(in vec2 st, in float value) {\n  return scale(st, vec2(value));\n}\n\nvec3 scale(in vec3 st, in vec3 s, in vec3 center) {\n  return (st - center) * s + center;\n}\n\nvec3 scale(in vec3 st, in float value, in vec3 center) {\n  return scale(st, vec3(value), center);\n}\n\nvec3 scale(in vec3 st, in vec3 s) {\n  #ifdef CENTER_3D\n  return scale(st,  s, CENTER_3D);\n  #else\n  return scale(st,  s, vec3(.5));\n  #endif\n}\n\nvec3 scale(in vec3 st, in float value) {\n  return scale(st, vec3(value));\n}\n#endif\n'}},n={};function t(i){var o=n[i];if(void 0!==o)return o.exports;var a=n[i]={exports:{}};return e[i](a,a.exports,t),a.exports}t.n=e=>{var n=e&&e.__esModule?()=>e.default:()=>e;return t.d(n,{a:n}),n},t.d=(e,n)=>{for(var i in n)t.o(n,i)&&!t.o(e,i)&&Object.defineProperty(e,i,{enumerable:!0,get:n[i]})},t.o=(e,n)=>Object.prototype.hasOwnProperty.call(e,n),t.r=e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})};var i={};return(()=>{"use strict";t.r(i),t.d(i,{default:()=>d});var e=t(7225),n=t.n(e),o=t(9357),a=t.n(o),s=t(1904),r=t.n(s),T=t(8535),E=t.n(T),c=t(5422),O=t.n(c),R=t(9174),I=t.n(R),N=t(8457),A=t.n(N);const d={flipY:n(),ratio:a(),rotate:r(),rotateX:E(),rotateY:O(),rotateZ:I(),scale:A()}})(),i})()}));